'From Squeak 3.2 of 11 July 2002 [latest update: #4917] on 16 April 2003 at 6:11:07 pm'!
Object subclass: #Morph
	instanceVariableNames: 'bounds owner submorphs fullBounds color extension '
	classVariableNames: 'EmptyArray WarpProtect '
	poolDictionaries: ''
	category: 'Morphic-Kernel'!
Object subclass: #MorphExtension
	instanceVariableNames: 'locked visible sticky balloonText balloonTextSelector externalName isPartsDonor actorState player eventHandler otherProperties identifier path '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Kernel'!
TestCase subclass: #MorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Kernel'!
ReferenceStream subclass: #SmartRefStream
	instanceVariableNames: 'structures steady reshaped renamed renamedConv superclasses progressBar objCount classInstVars '
	classVariableNames: 'DisplayProgress ScannedObject '
	poolDictionaries: ''
	category: 'System-Object Storage'!
SymbolListType subclass: #DirectionType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Protocols-Type Vocabularies'!
SymbolListType subclass: #EffectType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Protocols-Type Vocabularies'!
TileMorph subclass: #EffectTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Scripting Tiles'!

!Object methodsFor: 'scripts-kernel' stamp: 'kuri-t 12/13/2002 14:13'!
universalTilesForGetterOf: aMethodInterface
	"Return universal tiles for a getter on the given method interface."

	| ms argTile argArray itsSelector |
	itsSelector _ aMethodInterface selector.
	argArray _ #().

	"Three gratuituous special cases..."

	(itsSelector == #color:sees:) ifTrue:
		[argTile _ ScriptingSystem tileForArgType: #Color.
		argArray _ Array with: argTile colorSwatch color with: argTile colorSwatch color copy].

	itsSelector == #seesColor: ifTrue:
		[argTile _ ScriptingSystem tileForArgType: #Color.
		argArray _  Array with: argTile colorSwatch color].

	itsSelector == #touchesA: ifTrue:
		[argTile _ ScriptingSystem tileForArgType: #Player.
		argArray _ Array with: argTile actualObject].

	itsSelector == #nearTo: ifTrue:
		[argTile _ ScriptingSystem tileForArgType: #Player.
		argArray _ Array with: argTile actualObject].

	ms _ MessageSend receiver: self selector: itsSelector arguments: argArray.
	^ ms asTilesIn: self class globalNames: (self class officialClass ~~ CardPlayer)
			"For CardPlayers, use 'self'.  For others, name it, and use its name."! !

!Object methodsFor: 'NetMorph testing' stamp: 'kuri-t 11/21/2002 17:30'!
isProxy
	^false! !

!Object methodsFor: 'NetMorph testing' stamp: 'kuri-t 12/13/2002 15:03'!
shouldPassAsProxy
	^ false.! !


!ClassCategoryReader methodsFor: 'fileIn/Out' stamp: 'ka 10/17/2002 19:35'!
scanFrom: aStream logged: logFlag 
	"File in methods from the stream, aStream."
	| methodText |
	[methodText _ aStream nextChunkText.
	methodText size > 0]
		whileTrue: [class
				compile: methodText
				classified: category
				withStamp: changeStamp
				notifying: (SyntaxError new category: category)
				logged: logFlag]! !


!ClassDescription methodsFor: 'compiling' stamp: 'ka 10/17/2002 19:34'!
compile: text classified: category withStamp: changeStamp notifying: requestor logged: logFlag 
	^ self
		compile: text
		classified: category
		withStamp: changeStamp
		notifying: requestor
		logSource: logFlag! !


!CommandHistory class methodsFor: 'system startup' stamp: 'mu 12/11/2002 16:30'!
forgetAllGrabCommandsFrom: starter
	"Forget all the commands that might be held on to in the properties dicitonary of various morphs for various reasons."

	| object |
	object _ starter.
	[
		[0 == object] whileFalse: [
			(object isMorph and: [object isProxy not] ) ifTrue: [object removeProperty: #undoGrabCommand].
			object _ object nextObject].
		] ifError: [:err :rcvr | "object is obsolete"
			self forgetAllGrabCommandsFrom: object nextObject].

	"CommandHistory forgetAllGrabCommandsFrom: true someObject"
! !


!Debugger class methodsFor: 'opening' stamp: 'kuri-t 1/8/2003 18:08'!
openInterrupt: aString onProcess: interruptedProcess
	"Open a notifier in response to an interrupt. An interrupt occurs when the user types the interrupt key (cmd-. on Macs, ctrl-c or alt-. on other systems) or when the low-space watcher detects that memory is low."
	| debugger |
	<primitive: 19> "Simulation guard"
	debugger _ self new.
	debugger
		process: interruptedProcess
		controller: ((Smalltalk isMorphic not
					and: [ScheduledControllers activeControllerProcess == interruptedProcess])
						ifTrue: [ScheduledControllers activeController])
		context: interruptedProcess suspendedContext.
	debugger externalInterrupt: true.

Preferences logDebuggerStackToFile ifTrue:
	[(aString includesSubString: 'Space') & 
		(aString includesSubString: 'low') ifTrue: [
			Smalltalk logError: aString inContext: debugger interruptedContext to:'LowSpaceDebug.log']].
	NmProcessManager terminateAll.
	World stopRunningAll.
	^ debugger
		openNotifierContents: nil
		label: aString
! !


!DiskProxy methodsFor: 'as yet unclassified'!
step
	"no-op"
	^ self! !


!DisplayTransform methodsFor: 'accessing'!
withOffset: aPoint
	^ self subclassResponsibility! !


!CompositeTransform methodsFor: 'accessing'!
withOffset: aPoint 
	^ localTransform _ localTransform withOffset: aPoint! !


!FileList methodsFor: 'file list menu'!
openMorphFromFile
	"Reconstitute a Morph from the selected file, presumed to be represent a Morph saved
	via the SmartRefStream mechanism, and open it in an appropriate Morphic world"

 	| aFileStream morphOrList |
	Smalltalk verifyMorphicAvailability ifFalse: [^ self].
	aFileStream _ directory readOnlyFileNamed: self fullName.
	morphOrList _ aFileStream fileInObjectAndCode.
	(morphOrList isKindOf: SqueakPage) ifTrue: [morphOrList _ morphOrList contentsMorph].
	(ActiveWorld allMorphs
			detect: [:morph | morph identifier = morphOrList identifier]
			ifNone: [])
			= nil
		ifFalse: [morphOrList _ morphOrList copy].
	Smalltalk isMorphic
		ifTrue: [ActiveWorld addMorphsAndModel: morphOrList]
		ifFalse:
			[morphOrList isMorph ifFalse: [^ self errorMustBeMorph].
			morphOrList openInWorld]! !


!Form methodsFor: 'fileIn/Out' stamp: 'ar 3/3/2001 15:50'!
unhibernate
	"If my bitmap has been compressed into a ByteArray,
	then expand it now, and return true."
	| resBits |
	bits isForm ifTrue:[
		resBits _ bits.
		bits _ Bitmap new: self bitsSize.
		resBits displayResourceFormOn: self.
		^true].
	bits == nil ifTrue:[bits _ Bitmap new: self bitsSize. ^true].
	(bits isMemberOf: ByteArray)
		ifTrue: [bits _ Bitmap decompressFromByteArray: bits. ^ true].
	^ false! !

!Form methodsFor: 'resources' stamp: 'RAA 6/23/2002 13:34'!
readNativeResourceFrom: byteStream
	| img aStream |
	(byteStream isKindOf: FileStream) ifTrue:[
		"Ugly, but ImageReadWriter will send #reset which is implemented as #reopen and we may not be able to do so."
		aStream _ RWBinaryOrTextStream with: byteStream contents.
	] ifFalse:[
		aStream _ byteStream.
	].
	img _ [ImageReadWriter formFromStream: aStream] on: Error do:[:ex| nil].
	img ifNil:[^nil].
	img displayOn: self.
	img _ nil.! !


!Form class methodsFor: 'image reading/writing' stamp: 'ns 1/9/2003 17:34'!
formFromStream: aBinaryStream 
	| form |
	[form _ self new readResourceFrom: aBinaryStream]
		ensure: [aBinaryStream close].
	^ form! !

!Form class methodsFor: 'image reading/writing' stamp: 'ns 1/9/2003 11:37'!
putForm: aForm onStream: aWriteStream 
	[aForm storeResourceOn: aWriteStream]
		ensure: [aWriteStream close]! !


!GIFReadWriter methodsFor: 'accessing' stamp: 'ns 1/10/2003 11:17'!
nextPutImage: aForm

	| f newF |
	aForm unhibernate.
	f _ aForm colorReduced.  "minimize depth"
	f depth > 8 ifTrue: [
		"Not enough color space; do it the hard way."
		f _ f asFormOfDepth: 8.
		(aForm colorsUsed includes: Color transparent)
			ifTrue: [f _ f as8BitColorForm]].
	f depth < 8 ifTrue: [
		"writeBitData: expects depth of 8"
		newF _ f class extent: f extent depth: 8.
		(f isKindOf: ColorForm)
			ifTrue: [
				newF
					copyBits: f boundingBox
					from: f at: 0@0
					clippingBox: f boundingBox
					rule: Form over
					fillColor: nil
					map: nil.
				newF colors: f colors]
			ifFalse: [f displayOn: newF].
		f _ newF].
	(f isKindOf: ColorForm)
		ifTrue: [
			(f colorsUsed includes: Color transparent) ifTrue: [
				transparentIndex _ (f colors indexOf: Color transparent) - 1]]
		ifFalse: [transparentIndex _ nil].
	width _ f width.
	height _ f height.
	bitsPerPixel _ f depth.
	colorPalette _ f colormapIfNeededForDepth: 32.
	interlace _ false.
	self writeHeader.
	self writeBitData: f bits.
	self close.
! !


!Morph methodsFor: 'copying'!
shallowCopy
	| shallowCopyObject |
	shallowCopyObject _ super shallowCopy.
	shallowCopyObject assureExtension instVarNamed: 'identifier' put: UUID new.
	^ shallowCopyObject! !

!Morph methodsFor: 'submorphs-add/remove'!
delete
	"Remove the receiver as a submorph of its owner and make its new owner be nil."
	| aWorld |
	aWorld _ self world ifNil: [World].	"or some proper of getting the World"

	"Terminate genie recognition focus"
	"I encountered a case where the hand was nil, so I put in a little protection - raa"
	aWorld ifNotNil: [
		aWorld currentHand ifNotNilDo: [ :h | h disableGenieFocus: self].
	].

	owner ifNotNil:
		[(extension == nil or: [self player == nil])
		ifTrue: [owner privateRemoveMorph: self.
				owner _ nil]
		ifFalse: ["Player must be notified"
				owner privateRemoveMorph: self.
				owner _ nil.
				self player noteDeletionOf: self fromWorld: aWorld]
		].
	self submorphs
		do: [:submorph | submorph player isNil
				ifFalse: [submorph player noteDeletionOf: self fromWorld: aWorld]]! !

!Morph methodsFor: 'rotate scale and flex' stamp: 'kuri-t 2/18/2003 14:36'!
addFlexShell
	"Wrap a rotating and scaling shell around this morph."
	| oldHalo flexMorph myWorld |
	myWorld _ self world.
	oldHalo _ self halo.
	self owner isFlexMorph
		ifTrue: [flexMorph _ self owner]
		ifFalse: [self owner addMorph: (flexMorph _ self newTransformationMorph asFlexOf: self)].
	self transferStateToRenderer: flexMorph.
	oldHalo
		ifNotNil: [oldHalo setTarget: flexMorph].
	myWorld
		ifNotNil: [myWorld startSteppingSubmorphsOf: flexMorph].
	^ flexMorph! !

!Morph methodsFor: 'dropping/grabbing'!
slideToTrash: evt
	"Perhaps slide the receiver across the screen to a trash can and make it disappear into it.  In any case, remove the receiver from the screen."

	| aForm trash startPoint endPoint |
	((self renderedMorph == Utilities scrapsBook) or: [self renderedMorph isKindOf: TrashCanMorph]) ifTrue:
		[self delete.  ^ self].
	Preferences slideDismissalsToTrash ifTrue:
		[aForm _ self imageForm offset: 0@0.
		trash _ ActiveWorld
			findDeepSubmorphThat:
				[:aMorph | (aMorph isKindOf: TrashCanMorph) and:
					[aMorph topRendererOrSelf owner == ActiveWorld]]
			ifAbsent:
				[trash _ TrashCanMorph new.
				trash position: ActiveWorld bottomLeft - (0 @ (trash extent y + 26)).
				trash openInWorld.
				trash].
		endPoint _ trash fullBoundsInWorld center - (self topRendererOrSelf extent // 2).
		startPoint _ self topRendererOrSelf topLeft].
	self topRendererOrSelf delete.
	ActiveWorld displayWorld.
	Preferences slideDismissalsToTrash ifTrue:
		[aForm slideFrom: startPoint to: endPoint nSteps: 12 delay: 15].
	Utilities addToTrash: self! !

!Morph methodsFor: 'private'!
privateAddMorph: aMorph atIndex: index

	| oldIndex myWorld itsWorld |
	((index >= 1) and: [index <= (submorphs size + 1)])
		ifFalse: [^ self error: 'index out of range'].
	myWorld _ self world.
	(aMorph owner == self and: [(oldIndex _ submorphs indexOf: aMorph) > 0])
		ifTrue:
		["aMorph's position changes within in the submorph chain"
		oldIndex < index
			ifTrue:
			["moving aMorph to back"
			submorphs replaceFrom: oldIndex to: index-2 with: submorphs startingAt: oldIndex+1.
			submorphs at: index-1 put: aMorph]
			ifFalse:
			["moving aMorph to front"
			oldIndex-1 to: index by: -1 do:[:i|
				submorphs at: i+1 put: (submorphs at: i)].
			submorphs at: index put: aMorph]]
		ifFalse:
		["adding a new morph"
		aMorph owner ifNotNil:
			[itsWorld _ aMorph world.
			itsWorld == myWorld ifFalse: [aMorph outOfWorld: itsWorld].
			aMorph owner privateRemoveMorph: aMorph].
		aMorph privateOwner: self.
		submorphs _ submorphs copyReplaceFrom: index to: index-1 with: (Array with: aMorph).
		itsWorld == myWorld ifFalse:[aMorph intoWorld: myWorld]].
	aMorph layoutChanged.
	self layoutChanged.
	myWorld ifNotNil: [self addedOrRemovedSubmorph: aMorph].! !

!Morph methodsFor: 'fileIn/out'!
saveOnFile
	"Ask the user for a filename and save myself on a SmartReferenceStream file.  Writes out the version and class structure.  The file is fileIn-able.  UniClasses will be filed out."

	| aFileName fileStream ok topRendererOrSelf |
	aFileName _ ('my ', self class name) asFileName.	"do better?"
	aFileName _ FillInTheBlank request: 'File name? (".morph" will be added to end)' 
			initialAnswer: aFileName.
	aFileName size == 0 ifTrue: [^ self beep].
	topRendererOrSelf _ self topRendererOrSelf.
	topRendererOrSelf
		allMorphsDo: [:m | m prepareToBeSaved].

	ok _ aFileName endsWith: '.morph'.	"don't double them"
	ok _ ok | (aFileName endsWith: '.sp').
	ok ifFalse: [aFileName _ aFileName,'.morph'].
	fileStream _ FileStream newFileNamed: aFileName.
	fileStream fileOutClass: nil andObject: topRendererOrSelf.	"Puts UniClass definitions out anyway"! !

!Morph methodsFor: 'fileIn/out'!
writeOn: aStream 
	| topRendererOrSelf srefStream savedState |
	topRendererOrSelf _ self topRendererOrSelf.
	topRendererOrSelf
		allMorphsDo: [:m | m prepareToBeSaved].
	srefStream _ SmartRefStream on: aStream.
	savedState _ srefStream isDisplayProgress.
	[srefStream isDisplayProgress: false.
	srefStream nextPut: topRendererOrSelf]
		ensure: [srefStream close.
			srefStream isDisplayProgress: savedState]! !

!Morph methodsFor: 'meta-actions' stamp: 'ns 12/10/2002 14:19'!
buildHandleMenu: aHand
	"Build the morph menu for the given morph's halo's menu handle. This menu has two sections. The first section contains commands that are interpreted by the hand; the second contains commands provided by the target morph. This method allows the morph to decide which items should be included in the hand's section of the menu."

	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu addStayUpItem.
	menu addLine.
	self addStandardHaloMenuItemsTo: menu hand: aHand.
	menu defaultTarget: aHand.
	self addAddHandMenuItemsForHalo: menu  hand: aHand.
	menu defaultTarget: self.
	self addCustomHaloMenuItems: menu hand: aHand.
	menu defaultTarget: aHand.

	menu addLine.
	self addNetMorphMenuItemsTo: menu hand: aHand.
	menu addLine.

	^ menu! !

!Morph methodsFor: 'meta-actions' stamp: 'ns 12/10/2002 14:18'!
buildMetaMenu: evt
	"Build the morph menu. This menu has two sections. The first section contains commands that are handled by the hand; the second contains commands handled by the argument morph."
	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu addStayUpItem.
	menu add: 'grab' action: #grabMorph:.
	menu add: 'copy to paste buffer' action: #copyToPasteBuffer:.
	self maybeAddCollapseItemTo: menu.
	menu add: 'delete' action: #dismissMorph:.
	menu addLine.
	menu add: 'copy Postscript' action: #clipPostscript.
	menu add: 'print PS to file...' action: #printPSToFile.
	menu addLine.
	menu add: 'go behind' action: #goBehind.
	menu add: 'add halo' action: #addHalo:.
	menu add: 'duplicate' action: #maybeDuplicateMorph:.

	self addEmbeddingMenuItemsTo: menu hand: evt hand.

	menu add: 'resize' action: #resizeMorph:.
	"Give the argument control over what should be done about fill styles"
	self addFillStyleMenuItems: menu hand: evt hand.
	self addDropShadowMenuItems: menu hand: evt hand.
	self addLayoutMenuItems: menu hand: evt hand.
	menu addUpdating: #hasClipSubmorphsString target: self selector: #changeClipSubmorphs argumentList: #().
	menu addLine.

	(self morphsAt: evt position) size > 1 ifTrue:
		[menu add: 'submorphs...'
			target: self
			selector: #invokeMetaMenuAt:event:
			argument: evt position].
	menu addLine.
	menu add: 'inspect' selector: #inspectAt:event: argument: evt position.
	menu add: 'explore' action: #explore.
	menu add: 'browse hierarchy' action: #browseHierarchy.
	menu add: 'make own subclass' action: #subclassMorph.
	menu addLine.
	menu add: 'set variable name...' action: #choosePartName.
	(self isMorphicModel) ifTrue:
		[menu add: 'save morph as prototype' action: #saveAsPrototype.
		(self ~~ self world modelOrNil) ifTrue:
			 [menu add: 'become this world''s model' action: #beThisWorldsModel]].
	menu add: 'save morph in file' action: #saveOnFile.
	(self hasProperty: #resourceFilePath)
		ifTrue: [((self valueOfProperty: #resourceFilePath) endsWith: '.morph')
				ifTrue: [menu add: 'save as resource' action: #saveAsResource].
				menu add: 'update from resource' action: #updateFromResource]
		ifFalse: [menu add: 'attach to resource' action: #attachToResource].
	menu add: 'show actions' action: #showActions.
	menu addLine.
	self addDebuggingItemsTo: menu hand: evt hand.

	menu addLine.
	self addNetMorphMenuItemsTo: menu hand: evt hand.
	menu addLine.

	self addCustomMenuItems: menu hand: evt hand.
	^ menu! !

!Morph methodsFor: 'meta-actions' stamp: 'ka 12/11/2002 17:45'!
dismissMorph: evt 
	| world haloMorphs |
	world _ self world
				ifNil: [^ self].
	haloMorphs _ world haloMorphs
				select: [:haloMorph | haloMorph target == self].
	haloMorphs
		do: [:haloMorph | 
			(self isKindOf: SelectionMorph)
				ifTrue: [haloMorph target delete].
			haloMorph delete].
	world stopStepping: self.
	self submorphs
		do: [:submorph | submorph dismissMorph: evt].
	self delete! !

!Morph methodsFor: 'NetMorph effects'!
appearImageSquares
	| newDisplay morph |
	morph _ self topRendererOrSelf.
	morph visible
		ifTrue: [morph visible: false.
			morph renderedMorph refreshWorld].
	newDisplay _ Morph imageAll: morph.
	self fadeImageSquares: newDisplay at: self bounds topLeft.
	morph visible: true! !

!Morph methodsFor: 'NetMorph effects'!
curtainFall
	| newDisplay morph |
	morph _ self topRendererOrSelf.
	morph visible
		ifTrue: [morph visible: true.
			morph renderedMorph refreshWorld].
	newDisplay _ Morph imageWithout: morph.
	self
		curtainImage: newDisplay
		at: self bounds topLeft
		delta: 0 @ 2.
	morph visible: false! !

!Morph methodsFor: 'NetMorph effects'!
curtainRise
	| newDisplay morph |
	morph _ self topRendererOrSelf.
	morph visible
		ifTrue: [morph visible: false.
			morph renderedMorph refreshWorld].
	newDisplay _ Morph imageAll: morph.
	self
		curtainImage: newDisplay
		at: self bounds topLeft
		delta: 0 @ -2.
	morph visible: true! !

!Morph methodsFor: 'NetMorph effects'!
dissolve
	| afterForm beforeForm copyForm morph lead startTime minTime |
	morph _ self topRendererOrSelf.
	beforeForm _ Morph imageAll: morph.
	afterForm _ Morph imageWithout: morph.
	copyForm _ beforeForm deepCopy.
	minTime _ 500.
	startTime _ Time millisecondClockValue.
	0.0
		to: 1.0
		by: 1.0 / 32
		do: [:factor | 
			copyForm _ beforeForm deepCopy.
			copyForm
				copyBits: afterForm
				at: 0 @ 0
				translucent: factor.
			copyForm displayAt: self bounds topLeft.
			Display forceDisplayUpdate.
			lead _ startTime + (factor * 32 - 1 * minTime // 32) - Time millisecondClockValue.
			lead > 10
				ifTrue: [(Delay forMilliseconds: lead) wait]].
	morph visible: false! !

!Morph methodsFor: 'NetMorph effects'!
fadeImageSquares
	| newDisplay morph |
	morph _ self topRendererOrSelf.
	newDisplay _ Morph imageWithout: morph.
	self fadeImageSquares: newDisplay at: self bounds topLeft.
	morph visible: false! !

!Morph methodsFor: 'NetMorph effects'!
frenchDoorClose
	| afterForm beforeForm morph innerForm outerForm |
	morph _ self topRendererOrSelf.
	beforeForm _ Morph imageWithout: morph.
	afterForm _ Morph imageAll: morph.
	innerForm _ beforeForm.
	outerForm _ afterForm.
	self
		french: self
		InnerForm: innerForm
		outerForm: outerForm
		stepFrom: self extent
		to: 0 @ self height.
	morph visible: false! !

!Morph methodsFor: 'NetMorph effects'!
frenchDoorOpen
	| afterForm beforeForm morph innerForm outerForm |
	morph _ self topRendererOrSelf.
	beforeForm _ Morph imageWithout: morph.
	afterForm _ Morph imageAll: morph.
	innerForm _ beforeForm.
	outerForm _ afterForm.
	self
		french: self
		InnerForm: innerForm
		outerForm: outerForm
		stepFrom: 0 @ self height
		to: self extent.
	morph visible: true! !

!Morph methodsFor: 'NetMorph effects'!
frenchWindowClose
	| afterForm beforeForm morph innerForm outerForm |
	morph _ self topRendererOrSelf.
	afterForm _ Morph imageWithout: morph.
	beforeForm _ Morph imageAll: morph.
	innerForm _ afterForm.
	outerForm _ beforeForm.
	self
		french: self
		InnerForm: innerForm
		outerForm: outerForm
		stepFrom: self extent
		to: self width @ 0.
	morph visible: false! !

!Morph methodsFor: 'NetMorph effects'!
frenchWindowOpen
	| afterForm beforeForm morph innerForm outerForm |
	morph _ self topRendererOrSelf.
	beforeForm _ Morph imageWithout: morph.
	afterForm _ Morph imageAll: morph.
	innerForm _ beforeForm.
	outerForm _ afterForm.
	self
		french: self
		InnerForm: innerForm
		outerForm: outerForm
		stepFrom: self width @ 0
		to: self extent.
	morph visible: true! !

!Morph methodsFor: 'NetMorph effects'!
none
	"noop"
	^ self! !

!Morph methodsFor: 'NetMorph effects'!
pageIn
	| newDisplay morph |
	morph _ self topRendererOrSelf.
	morph visible
		ifTrue: [morph visible: false.
			morph renderedMorph refreshWorld].
	newDisplay _ Morph imageAll: morph.
	self
		curtainImage: newDisplay
		at: self bounds topLeft
		delta: 2 @ 0.
	morph visible: true! !

!Morph methodsFor: 'NetMorph effects'!
pageOut
	| newDisplay morph |
	morph _ self topRendererOrSelf.
	morph visible
		ifTrue: [morph visible: true.
			morph renderedMorph refreshWorld].
	newDisplay _ Morph imageWithout: morph.
	self
		curtainImage: newDisplay
		at: self bounds topLeft
		delta: -2 @ 0.
	morph visible: false! !

!Morph methodsFor: 'NetMorph effects'!
poofIn
	| morph |
	morph _ self topRendererOrSelf.
	NmPoofs
		showInBounds: (morph bounds outsetBy: 20 @ 20).
	morph visible: true! !

!Morph methodsFor: 'NetMorph effects'!
poofOut
	| morph |
	morph _ self topRendererOrSelf.
	NmPoofs
		showInBounds: (morph bounds outsetBy: 20 @ 20).
	morph visible: false! !

!Morph methodsFor: 'NetMorph effects'!
zoomIn
	| newDisplay morph vanishingPoint |
	morph _ self topRendererOrSelf.
	morph visible
		ifTrue: [morph visible: false.
			morph renderedMorph refreshWorld].
	newDisplay _ Morph imageAll: morph.
	vanishingPoint _ morph width // 2 @ (morph height // 2).
	Display
		zoomIn: true
		orOutTo: newDisplay
		at: morph bounds topLeft
		vanishingPoint: vanishingPoint.
	morph visible: true! !

!Morph methodsFor: 'NetMorph effects'!
zoomOut
	| newDisplay morph vanishingPoint |
	morph _ self topRendererOrSelf.
	newDisplay _ Morph imageWithout: morph.
	vanishingPoint _ morph width // 2 @ (morph height // 2).
	Display
		zoomIn: false
		orOutTo: newDisplay
		at: morph bounds topLeft
		vanishingPoint: vanishingPoint.
	morph visible: false! !

!Morph methodsFor: 'NetMorph extension'!
address
	self extension == nil
		ifTrue: [self assureExtension].
	^ self extension address! !

!Morph methodsFor: 'NetMorph extension' stamp: 'kuri-t 1/14/2003 17:48'!
formerWorldBounds
	self extension == nil
		ifTrue: [self assureExtension].
	^ self
		valueOfProperty: #formerWorldBounds
		ifAbsent: [ActiveWorld bounds]! !

!Morph methodsFor: 'NetMorph extension'!
home
	self extension == nil
		ifTrue: [self assureExtension].
	^ self extension home! !

!Morph methodsFor: 'NetMorph extension'!
identifier
	self extension == nil
		ifTrue: [self assureExtension].
	^ self extension identifier! !

!Morph methodsFor: 'NetMorph extension' stamp: 'kuri-t 2/7/2003 12:08'!
lastWarpTime
	self extension == nil
		ifTrue: [self assureExtension].
	^ self
		valueOfProperty: #lastWarpTime
		ifAbsent: []! !

!Morph methodsFor: 'NetMorph extension' stamp: 'kuri-t 2/7/2003 12:21'!
lastWarpTime: millisecond 
	self extension == nil
		ifTrue: [self assureExtension].
	self setProperty: #lastWarpTime toValue: millisecond! !

!Morph methodsFor: 'NetMorph extension'!
path
	self extension == nil
		ifTrue: [self assureExtension].
	^ self extension path! !

!Morph methodsFor: 'NetMorph extension' stamp: 'kuri-t 2/7/2003 12:21'!
path: visitedLocationCollection 
	self extension == nil
		ifTrue: [self assureExtension].
	self extension path: visitedLocationCollection! !

!Morph methodsFor: 'NetMorph extension' stamp: 'kuri-t 1/15/2003 12:13'!
resetIdentifier
	self extension
		ifNotNil: [self extension resetIdentifier]! !

!Morph methodsFor: 'NetMorph extension' stamp: 'kuri-t 1/22/2003 15:33'!
warpDirection
	self extension == nil
		ifTrue: [self assureExtension].
	^ self
		valueOfProperty: #warpDirection
		ifAbsent: []! !

!Morph methodsFor: 'NetMorph extension' stamp: 'kuri-t 2/7/2003 12:21'!
warpDirection: warpDirection 
	self extension == nil
		ifTrue: [self assureExtension].
	self setProperty: #warpDirection toValue: warpDirection! !

!Morph methodsFor: 'NetMorph extension' stamp: 'kuri-t 1/22/2003 14:42'!
warpType
	self extension == nil
		ifTrue: [self assureExtension].
	^ self
		valueOfProperty: #warpType
		ifAbsent: []! !

!Morph methodsFor: 'NetMorph extension' stamp: 'kuri-t 2/7/2003 12:21'!
warpType: warpType 
	self extension == nil
		ifTrue: [self assureExtension].
	self setProperty: #warpType toValue: warpType! !

!Morph methodsFor: 'NetMorph extension' stamp: 'kuri-t 1/14/2003 14:00'!
warping
	self extension == nil
		ifTrue: [self assureExtension].
	^ self valueOfProperty: #warping! !

!Morph methodsFor: 'NetMorph extension' stamp: 'kuri-t 2/7/2003 12:21'!
warping: statusSymbol
	self extension == nil
		ifTrue: [self assureExtension].
	self setProperty: #warping toValue: statusSymbol! !

!Morph methodsFor: 'NetMorph support' stamp: 'mu 4/16/2003 01:56'!
currentPointInTheMap
	^NmWorldMap localPoint
	
	! !

!Morph methodsFor: 'NetMorph support' stamp: 'kuri-t 1/24/2003 15:08'!
isWarping
	^ #(#prepareWarp #warp #warpingOut ) includes: self warping! !

!Morph methodsFor: 'NetMorph support' stamp: 'MU 12/28/2002 01:59'!
leaveMarkerMorph
	| markerMorph |
	markerMorph _ NmMarkerMorph on: self.
	markerMorph openInWorld.
	self currentHand attachMorph: markerMorph.
	! !

!Morph methodsFor: 'NetMorph support' stamp: 'ns 10/24/2002 20:16'!
reinstallAllScripts
	self allMorphs
		do: [:each | 
			| playerClass selectors | 
			each path addLast: NmUrl local.
			playerClass _ each player class.
			selectors _ playerClass organization listAtCategoryNamed: #scripts.
			selectors
				do: [:selector | 
					| editor | 
					editor _ each scriptEditorFor: selector.
					editor install]]! !

!Morph methodsFor: 'NetMorph support' stamp: 'kuri-t 1/14/2003 15:24'!
warp
	self warp: #ifOutOfWorldBounds! !

!Morph methodsFor: 'NetMorph support' stamp: 'kuri-t 1/23/2003 19:20'!
warp: warpType 
	self warpType: warpType.
	self isArrivedAtLeftBound
		ifTrue: [^ self warpToLeft].
	self isArrivedAtRightBound
		ifTrue: [^ self warpToRight].
	self isArrivedAtBottomBound
		ifTrue: [^ self warpToBottom].
	self isArrivedAtTopBound
		ifTrue: [^ self warpToTop]! !

!Morph methodsFor: 'NetMorph support' stamp: 'kuri-t 1/24/2003 16:06'!
warpTo: destination 
	self
		warpTo: destination
		x: self topRendererOrSelf bounds left
		y: self topRendererOrSelf bounds top! !

!Morph methodsFor: 'NetMorph support' stamp: 'mu 4/15/2003 19:11'!
warpTo: destination x: x y: y 
	WarpProtect
		critical: [| morphByteArray nmUrl connector | 
			self owner
				ifNil: [^ self].
			self isWarpable
				ifFalse: [^ self].
			[self warping: #warp.
			self forceRemoveHalo.
			morphByteArray _ self toWarpByteArray.
			self
				playerNotNilDo: [self player
						instantiatedUserScriptsDo: [:scriptInstantiation | scriptInstantiation stopTicking]].
			NmProcessManager terminateAllOf: self identifier.
			self stopKeepMoving. 
			nmUrl _ self addressFromDestination: destination.
			connector _ NmRemoteConnector connect: nmUrl ipAddressOrHost port: nmUrl port.
			connector
				callCatchAndGo: morphByteArray
				x: x
				y: y.
			self warpingOut: nmUrl]
				on: Error
				do: [:ex | self handleWarpError: ex]]! !

!Morph methodsFor: 'NetMorph support' stamp: 'kuri-t 1/24/2003 14:37'!
warpToHome
	^ self warpTo: self home! !

!Morph methodsFor: 'NetMorph support' stamp: 'mu 3/23/2003 14:47'!
warpToNeighbor: ipAndPortArray 
	WarpProtect
		critical: [| morphByteArray connector host port | 
			host _ ipAndPortArray first.
			port _ ipAndPortArray last.
			self owner
				ifNil: [^ self].
			self isWarpable
				ifFalse: [^ self].
			[self warping: #warp.
			self forceRemoveHalo.
			morphByteArray _ self toWarpByteArray.
			self
				playerNotNilDo: [self player
						instantiatedUserScriptsDo: [:scriptInstantiation | scriptInstantiation stopTicking]].
			NmProcessManager terminateAllOf: self identifier.
			self stopKeepMoving.
			connector _ NmRemoteConnector connect: host port: port.
			connector callCatchAndGo: morphByteArray.
			self
				warpingOut: (NmUrl host: host port: port)]
				on: Error
				do: [:ex | self handleWarpError: ex]]! !

!Morph methodsFor: 'NetMorph support' stamp: 'mu 4/12/2003 21:24'!
warpedIn: nmUrl 
	| url netMorphProxy |
	self warping: #warpedIn.
	url _ nmUrl copy.
	self path addLast: url.
	self
		playerNotNilDo: [self player runAllWarpedInScripts].
	self shouldKeepMoving
		ifTrue: [self startKeepMoving].
	netMorphProxy _ NmUtil netMorphProxyCache
				at: self identifier
				ifAbsent: [].
	netMorphProxy
		ifNotNil: [NmUtil netMorphProxyCache removeKey: self identifier.
				(netMorphProxy player isNil not
					and: [self player notNil])
				ifTrue: [netMorphProxy player becomeForward: self player].
			netMorphProxy becomeForward: self]! !

!Morph methodsFor: 'NetMorph support' stamp: 'mu 4/12/2003 21:24'!
warpingOut: nmUrl 
	| playerClass identifier className |
	self warping: #warpingOut.
	identifier _ self identifier.
	className _ self renderedMorph class name.
	self
		playerNotNilDo: [self player runAllWarpingOutScripts].
	self purgeAllCommands.
	self resetIdentifier.
	submorphs
		do: [:submorph | submorph resetIdentifier].
	self topRendererOrSelf dismissMorph: ActiveEvent.
	self presenter flushPlayerListCache.
	playerClass _ self player class.
	self
		playerNotNilDo: [self player becomeForward: (NmMorphProxy
					className: className
					uuid: identifier
					url: nmUrl) player].
	(#(#UnscriptedPlayer #UndefinedObject ) includes: playerClass name)
		ifFalse: [playerClass removeFromSystemUnlogged].
	NmWarpedOutNotification signal.! !

!Morph methodsFor: 'NetMorph effects-private'!
curtainImage: newDisplay at: topLeft delta: delta 
	| boundingBox wipeRect nSteps |
	boundingBox _ newDisplay boundingBox.
	wipeRect _ delta x = 0
				ifTrue: [delta y = 0
						ifTrue: [nSteps _ 1.
							boundingBox]
						ifFalse: [nSteps _ boundingBox height // delta y abs + 1.
							delta y > 0
								ifTrue: [boundingBox topLeft extent: boundingBox width @ delta y]
								ifFalse: [boundingBox bottomLeft + delta extent: boundingBox width @ delta y negated]]]
				ifFalse: [nSteps _ boundingBox width // delta x abs + 1.
					delta x > 0
						ifTrue: [boundingBox topLeft extent: delta x @ boundingBox height]
						ifFalse: [boundingBox topRight + delta extent: delta x negated @ boundingBox height]].
	Display
		wipeImage: newDisplay
		at: topLeft
		clippingBox: nil
		rectForIndex: [:i | 
			(Delay forMilliseconds: 3) wait.
			i <= nSteps
				ifTrue: [wipeRect translateBy: delta * (i - 1)]]! !

!Morph methodsFor: 'NetMorph effects-private'!
fadeImageSquares: newDisplay at: topLeft 
	Display
		fadeImage: newDisplay
		at: topLeft
		indexAndMaskDo: [:i :mask | 
			mask
				fill: ((16 - i) asPoint extent: (i * 2) asPoint)
				fillColor: Color black.
			(Delay forMilliseconds: 5) wait.
			i <= 16]! !

!Morph methodsFor: 'NetMorph effects-private'!
french: aMorph InnerForm: innerForm outerForm: outerForm stepFrom: stepFromPoint to: toPoint 
	| nSteps aCanvas boxExtent box lead startTime minTime |
	nSteps _ 30.
	aCanvas _ FormCanvas extent: aMorph bounds extent.
	aCanvas drawImage: outerForm at: 0 @ 0.
	minTime _ 500.
	startTime _ Time millisecondClockValue.
	1
		to: 30
		do: [:stepNumber | 
			boxExtent _ self
						stepFrom: stepFromPoint
						to: toPoint
						stepNumber: stepNumber
						nSteps: nSteps.
			aCanvas drawImage: innerForm at: 0 @ 0.
			box _ Rectangle center: aCanvas form boundingBox center extent: boxExtent.
			aCanvas
				drawImage: outerForm
				at: box topLeft
				sourceRect: box.
			aCanvas form displayAt: self bounds topLeft.
			Display forceDisplayUpdate.
			lead _ startTime + (stepNumber - 1 * minTime // 30) - Time millisecondClockValue.
			lead > 10
				ifTrue: [(Delay forMilliseconds: lead) wait]]! !

!Morph methodsFor: 'NetMorph effects-private'!
stepFrom: p1 to: p2 stepNumber: stepNumber nSteps: nSteps 
	^ p2 - p1 * stepNumber // nSteps + p1! !

!Morph methodsFor: 'NetMorph effects-support'!
imageAll: aMorph 
	^ self class imageAll: aMorph! !

!Morph methodsFor: 'NetMorph effects-support'!
imageBelow: aMorph 
	^ self class imageBelow: aMorph! !

!Morph methodsFor: 'NetMorph effects-support'!
imageWithout: aMorph 
	^ self class imageWithout: aMorph! !

!Morph methodsFor: 'NetMorph effects-support'!
intersectsWindows: aRectangle below: targetMorph 
	^ self class intersectsWindows: aRectangle below: targetMorph! !

!Morph methodsFor: 'NetMorph effects-support'!
outsideBelowAndAboveWindows: aRectangle with: targetMorph 
	^ self class outsideBelowAndAboveWindows: aRectangle with: targetMorph! !

!Morph methodsFor: 'NetMorph effects-support'!
outsideWindows: aRectangle with: targetMorph 
	^ self class outsideWindows: aRectangle with: targetMorph! !

!Morph methodsFor: 'NetMorph private' stamp: 'mu 4/12/2003 21:40'!
addressFromDestination: destination
	| destPoint ipAndPortArray |

	destPoint _ NmWorldMap pointOf: destination.
	destPoint isNil ifTrue: [^NmUrl new].
	
	ipAndPortArray _ NmResolver default ipAndPortArrayAt: destPoint.
	ipAndPortArray isNil ifTrue: [^NmUrl new].
	
	^NmUrl host: ipAndPortArray first port: ipAndPortArray last asNumber! !

!Morph methodsFor: 'NetMorph private' stamp: 'kuri-t 1/15/2003 15:43'!
clearExtensionBeforeWarp
	| renderer |
	renderer _ self topRendererOrSelf.
	#(#formerOwner #formerPosition #undoGrabCommand )
		do: [:each | renderer extension removeProperty: each]! !

!Morph methodsFor: 'NetMorph private' stamp: 'kuri-t 2/6/2003 14:48'!
deferWarpToNeighbor: destination 
	self warping: #prepareWarp.
	WorldState
		addDeferredUIMessage: [self warpToNeighbor: destination]! !

!Morph methodsFor: 'NetMorph private' stamp: 'kuri-t 2/6/2003 14:47'!
forceRemoveHalo
	| halo |
	(halo _ self halo)
		ifNotNil: [halo forceDelete]! !

!Morph methodsFor: 'NetMorph private' stamp: 'kuri-t 1/31/2003 14:31'!
handleWarpError: aException 
	self warping: #warpFailed.
	(aException isKindOf: NmpGenericError)
		ifTrue: [^ self showBalloon: aException messageText asString].
	aException pass! !

!Morph methodsFor: 'NetMorph private' stamp: 'kuri-t 2/17/2003 12:32'!
isArrivedAtBottomBound
	| morphRect worldRect warpType |
	ActiveWorld bottomFenceEnabled
		ifTrue: [^ false].
	warpType _ self warpType.
	morphRect _ self bounds.
	worldRect _ ActiveWorld bounds.
	warpType = #ifOutOfWorldBounds
		ifTrue: [^ morphRect top > worldRect bottom].
	warpType = #ifCrossingWorldBounds
		ifTrue: [^ morphRect center y > worldRect bottom].
	warpType = #ifTouchedWorldBounds
		ifTrue: [^ morphRect bottom > worldRect bottom]! !

!Morph methodsFor: 'NetMorph private' stamp: 'kuri-t 2/17/2003 12:32'!
isArrivedAtLeftBound
	| morphRect worldRect warpType |
	ActiveWorld leftFenceEnabled
		ifTrue: [^ false].
	warpType _ self warpType.
	morphRect _ self bounds.
	worldRect _ ActiveWorld bounds.
	warpType = #ifOutOfWorldBounds
		ifTrue: [^ morphRect right < worldRect left].
	warpType = #ifCrossingWorldBounds
		ifTrue: [^ morphRect center x < worldRect left].
	warpType = #ifTouchedWorldBounds
		ifTrue: [^ morphRect left < worldRect left]! !

!Morph methodsFor: 'NetMorph private' stamp: 'kuri-t 2/17/2003 12:33'!
isArrivedAtRightBound
	| morphRect worldRect warpType |
	ActiveWorld rightFenceEnabled
		ifTrue: [^ false].
	warpType _ self warpType.
	morphRect _ self bounds.
	worldRect _ ActiveWorld bounds.
	warpType = #ifOutOfWorldBounds
		ifTrue: [^ morphRect left > worldRect right].
	warpType = #ifCrossingWorldBounds
		ifTrue: [^ morphRect center x > worldRect right].
	warpType = #ifTouchedWorldBounds
		ifTrue: [^ morphRect right > worldRect right]! !

!Morph methodsFor: 'NetMorph private' stamp: 'kuri-t 2/17/2003 12:33'!
isArrivedAtTopBound
	| morphRect worldRect warpType |
	ActiveWorld topFenceEnabled
		ifTrue: [^ false].
	warpType _ self warpType.
	morphRect _ self bounds.
	worldRect _ ActiveWorld bounds.
	warpType = #ifOutOfWorldBounds
		ifTrue: [^ morphRect bottom < worldRect top].
	warpType = #ifCrossingWorldBounds
		ifTrue: [^ morphRect center y < worldRect top].
	warpType = #ifTouchedWorldBounds
		ifTrue: [^ morphRect top < worldRect top]! !

!Morph methodsFor: 'NetMorph private' stamp: 'mu 1/4/2003 19:51'!
playerNotNilDo: aBlock 
	^ self player ifNotNil: aBlock! !

!Morph methodsFor: 'NetMorph private' stamp: 'kuri-t 1/22/2003 15:49'!
toWarpByteArray
	| write |
	write _ RWBinaryOrTextStream on: String new.
	Cursor write
		showWhile: [self
				playerNotNilDo: [self player class scripts
						valuesDo: [:script | script prepareForWarp]].
			self clearExtensionBeforeWarp.
			self writeOn: write].
	^ NmUtil gzippedFrom: write contents asByteArray! !

!Morph methodsFor: 'NetMorph private' stamp: 'mu 3/23/2003 14:38'!
warpToBottom
	| destination |
	destination _ NmWorldMap bottomDestination.
	destination notNil
		ifTrue: [self warpDirection: #bottomWarp.
			self deferWarpToNeighbor: destination]! !

!Morph methodsFor: 'NetMorph private' stamp: 'mu 3/23/2003 14:38'!
warpToLeft
	| destination |
	destination _ NmWorldMap leftDestination.
	destination notNil
		ifTrue: [self warpDirection: #leftWarp.
			self deferWarpToNeighbor: destination]! !

!Morph methodsFor: 'NetMorph private' stamp: 'mu 3/23/2003 14:39'!
warpToRight
	| destination |
	destination _ NmWorldMap rightDestination.
	destination notNil
		ifTrue: [self warpDirection: #rightWarp.
			self deferWarpToNeighbor: destination]! !

!Morph methodsFor: 'NetMorph private' stamp: 'mu 3/23/2003 14:39'!
warpToTop
	| destination |
	destination _ NmWorldMap topDestination.
	destination notNil
		ifTrue: [self warpDirection: #topWarp.
			self deferWarpToNeighbor: destination]! !

!Morph methodsFor: 'NetMorph delegate' stamp: 'kuri-t 10/16/2002 18:36'!
rendererBounds
	^ self topRendererOrSelf bounds! !

!Morph methodsFor: 'NetMorph delegate' stamp: 'kuri-t 10/16/2002 18:36'!
rendererReferencePosition
	^ self topRendererOrSelf referencePosition! !

!Morph methodsFor: 'NetMorph testing' stamp: 'kuri-t 2/13/2003 16:31'!
isWarpable
	| previousMSec currentMSec |
	(previousMSec _ self lastWarpTime)
		ifNil: [^ true].
	currentMSec _ Time millisecondClockValue.
	^ currentMSec - previousMSec > NmSettings warpableInterval! !

!Morph methodsFor: 'NetMorph testing' stamp: 'kuri-t 12/13/2002 15:03'!
shouldPassAsProxy
	^ true.! !

!Morph methodsFor: 'NetMorph testing' stamp: 'kuri-t 12/10/2002 14:44'!
shouldPrepareForWarp
	^ false! !

!Morph methodsFor: 'NetMorph converting' stamp: 'kuri-t 12/13/2002 15:06'!
asProxy
	^ NmMorphProxy on: self! !

!Morph methodsFor: 'NetMorph menu' stamp: 'kuri-t 1/6/2003 14:52'!
addNetMorphMenuItemsTo: aMenu hand: aHandMorph 
	| selectorWithArguments subMenu |
	selectorWithArguments _ OrderedCollection new.
	selectorWithArguments
		add: (Array
				with: 'address'
				with: #showContentsOf:
				with: #address).
	selectorWithArguments
		add: (Array
				with: 'home'
				with: #showContentsOf:
				with: #home).
	selectorWithArguments
		add: (Array
				with: 'identifier'
				with: #showContentsOf:
				with: #identifier).
	selectorWithArguments
		add: (Array
				with: 'guruguru warp'
				with: #guruguruWarp
				with: nil).
	subMenu _ MenuMorph new defaultTarget: self.
	selectorWithArguments
		do: [:each | subMenu perform: #add:selector:argument: withArguments: each].
	
subMenu 
		add: 'leave mark...'
		action: #leaveMarkerMorph.
	subMenu
		add: 'warp to '
		subMenu: (self addWarpToMenuItemsTo: subMenu hand: aHandMorph).
	aMenu add: 'NetMorph' subMenu: subMenu.
	^ subMenu! !

!Morph methodsFor: 'NetMorph menu' stamp: 'mu 3/23/2003 15:57'!
addWarpToMenuItemsTo: aMenu hand: aHandMorph 
	| availableUrls subMenu selectorWithArguments selector |
	selector _ #warpFromMenuTo:.
	availableUrls _ NmWorldMap allWorldNames
				asSortedCollection: [:x :y | x asString < y asString].
	selectorWithArguments _ OrderedCollection new.
	availableUrls
		do: [:each | selectorWithArguments
				add: (Array
						with: each asString
						with: selector
						with: each)].
	subMenu _ MenuMorph new defaultTarget: self.
	selectorWithArguments
		do: [:each | subMenu perform: #add:selector:argument: withArguments: each].
	subMenu addLine.
	subMenu
		add: 'Home'
		action: #warpToHome.
	subMenu addLine.
	subMenu
		add: 'other ...'
		selector: selector
		argument: nil.
	^ subMenu! !

!Morph methodsFor: 'NetMorph menu' stamp: 'ka 1/15/2003 16:48'!
askWarpDestination
	| answer url |
	answer _ FillInTheBlankMorph
				request: 'Where do you wanna go?'
				initialAnswer: ''
				centerAt: (ActiveHand
						ifNil: [Sensor]) cursorPoint
				inWorld: ActiveWorld
				onCancelReturn: nil.
	answer
		ifNil: [^ nil].
	(url _ NmUtil urlFromString: answer)
		ifNil: [self inform: 'bad input.'.
			^ nil].
	^ url! !

!Morph methodsFor: 'NetMorph menu' stamp: 'ns 12/10/2002 15:19'!
showContentsOf: selector 
	| stringMorph anObject |
	anObject _ self perform: selector.
	stringMorph _ StringMorph contents: anObject asString.
	stringMorph name: selector.
	self player currentHand attachMorph: stringMorph! !

!Morph methodsFor: 'NetMorph menu' stamp: 'kuri-t 1/24/2003 14:37'!
warpFromMenuTo: destination 
	| whereIGo |
	destination
		ifNil: [whereIGo _ self askWarpDestination.
			whereIGo
				ifNil: [^ self]]
		ifNotNil: [whereIGo _ destination].
	self assuredPlayer assureUniClass.
	self warpTo: whereIGo! !

!Morph methodsFor: 'NetMorph e-toy support' stamp: 'kuri-t 12/17/2002 15:35'!
costumeState
	| costumeState |
	costumeState _ NmCostumeState new.
	costumeState imageForm: self imageForm.
	costumeState rotationCenter: self rotationCenter.
	costumeState rotationStyle:  self rotationStyle.
	costumeState referencePosition: self referencePosition.
	costumeState forwardDirection: self forwardDirection.
	costumeState shouldRememberCostumes: self shouldRememberCostumes.
	^ costumeState! !

!Morph methodsFor: 'geometry keep moving' stamp: 'mu 4/11/2003 16:10'!
getMoveDelta
	| delta |
	delta _ self valueOfProperty: #moveDelta
				ifAbsent: [| end start | 
					end _ self 	valueOfProperty: #moveEndPoint
								ifAbsent: [^ 0 @ 0].
					start _ self valueOfProperty: #moveStartPoint
								ifAbsent: [^ 0 @ 0].
					delta _ end - start.
					self setProperty: #moveDelta toValue: delta.
					delta].
	^ delta! !

!Morph methodsFor: 'geometry keep moving' stamp: 'mu 1/2/2003 20:01'!
moveEndPoint: aPoint
	self setProperty: #moveEndPoint toValue: aPoint! !

!Morph methodsFor: 'geometry keep moving' stamp: 'mu 1/2/2003 20:01'!
moveStartPoint: aPoint
	self setProperty: #moveStartPoint toValue: aPoint! !

!Morph methodsFor: 'geometry keep moving' stamp: 'mu 1/2/2003 20:11'!
rememberMoveEndPoint
	self moveEndPoint: self topRendererOrSelf position! !

!Morph methodsFor: 'geometry keep moving' stamp: 'kuri-t 2/18/2003 15:16'!
rememberMoveStartPoint
	self moveStartPoint: self topRendererOrSelf position! !

!Morph methodsFor: 'geometry keep moving' stamp: 'kuri-t 2/18/2003 14:55'!
resetKeepMovingStatus
	self removeProperty: #moveStartPoint.
	self removeProperty: #moveEndPoint.
	self removeProperty: #moveDelta! !

!Morph methodsFor: 'geometry keep moving' stamp: 'mu 1/2/2003 19:57'!
shouldKeepMoving
	^ self valueOfProperty: #shouldKeepMoving
		ifAbsent: [false]! !

!Morph methodsFor: 'geometry keep moving' stamp: 'mu 1/2/2003 19:57'!
shouldKeepMoving: aBoolean 
	self setProperty: #shouldKeepMoving toValue: aBoolean! !

!Morph methodsFor: 'geometry keep moving' stamp: 'kuri-t 2/18/2003 15:50'!
startKeepMoving
	(NmSettings useKeepMoving not
			or: [self getMoveDelta = (0 @ 0)])
		ifTrue: [^ self].
	self shouldKeepMoving: true.
	self
		startStepping: #stepMove
		at: Time millisecondClockValue
		arguments: nil
		stepTime: 800! !

!Morph methodsFor: 'geometry keep moving' stamp: 'mu 1/4/2003 18:49'!
stepMove
	self shouldKeepMoving
		ifTrue: [self topRendererOrSelf position: self topRendererOrSelf position + self getMoveDelta.
			self topRendererOrSelf warp.
			self topRendererOrSelf owner == HandMorph
				ifTrue: [self stopKeepMoving]]! !

!Morph methodsFor: 'geometry keep moving' stamp: 'kuri-t 2/18/2003 14:38'!
stopKeepMoving
	self resetKeepMovingStatus.
	self shouldKeepMoving: false.
	self stopSteppingSelector: #stepMove! !

!Morph methodsFor: 'NetMorph example' stamp: 'kuri-t 1/6/2003 12:39'!
addPhrase: aPhrase to: aScriptor 
	| i slideMorph p1 p2 |
	aScriptor prepareToUndoDropOf: aPhrase.
	i _ aScriptor submorphs size.
	slideMorph _ aPhrase imageForm offset: 0 @ 0.
	p1 _ aPhrase screenRectangle topLeft.
	aPhrase delete.
	aScriptor stopSteppingSelector: #trackDropZones.
	aScriptor world displayWorld.
	(aPhrase isKindOf: PhraseTileMorph)
		ifTrue: [aPhrase justGrabbedFromViewer: false].
	aPhrase tileRows
		do: [:tileList | 
			aScriptor
				insertTileRow: (Array
						with: (tileList first rowOfRightTypeFor: owner forActor: aPhrase associatedPlayer))
				after: i.
			i _ i + 1].
	aScriptor removeSpaces.
	aScriptor enforceTileColorPolicy.
	aScriptor layoutChanged.
	aScriptor fullBounds.
	p2 _ (aScriptor submorphs
				atPin: (i - 1
						max: (aScriptor instVarNamed: 'firstTileRow'))) screenRectangle topLeft.
	slideMorph
		slideFrom: p1
		to: p2
		nSteps: 5
		delay: 50
		andStay: true.
	aScriptor playSoundNamed: 'scritch'.
	aScriptor topEditor install! !

!Morph methodsFor: 'NetMorph example' stamp: 'kuri-t 1/4/2003 13:43'!
buildPhraseForSelector: selector
	| methodInterface player aDocString resultType cmd universal aPhrase argType argTile balloonTextSelector tileBearingHelp selfTile |
	methodInterface _ self methodInterfaceNamed: selector.
	player _ self assuredPlayer.
	aDocString _ methodInterface documentationOrNil.
	aDocString = 'no help available'
		ifTrue: [aDocString _ nil].
	resultType _ methodInterface resultType.
	cmd _ methodInterface selector.
	(universal _ player isUniversalTiles)
		ifTrue: [aPhrase _ player universalTilesForInterface: methodInterface]
		ifFalse: [cmd numArgs == 0
				ifTrue: [aPhrase _ PhraseTileMorph new vocabulary: self currentVocabulary.
					aPhrase
						setOperator: cmd
						type: resultType
						rcvrType: #Player]
				ifFalse: ["only one arg supported in classic tiles, so if this 
					is fed 
					with a selector with > 1 arg, results will be very 
					strange "
					argType _ methodInterface typeForArgumentNumber: 1.
					aPhrase _ PhraseTileMorph new vocabulary: self currentVocabulary.
					aPhrase
						setOperator: cmd
						type: resultType
						rcvrType: #Player
						argType: argType.
					argTile _ ScriptingSystem tileForArgType: argType.
					argTile position: aPhrase lastSubmorph position.
					aPhrase lastSubmorph addMorph: argTile]].
	(player slotInfo includesKey: cmd)
		ifTrue: [balloonTextSelector _ #userSlot].
	(player belongsToUniClass
			and: [player class includesSelector: cmd])
		ifTrue: [aDocString
				ifNil: [aDocString _ (player class userScriptForPlayer: player selector: cmd) documentationOrNil].
			aDocString
				ifNil: [balloonTextSelector _ #userScript]].
	tileBearingHelp _ universal
				ifTrue: [aPhrase submorphs second]
				ifFalse: [aPhrase operatorTile].
	aDocString
		ifNil: [balloonTextSelector
				ifNil: [tileBearingHelp setProperty: #inherentSelector toValue: cmd.
					balloonTextSelector _ #methodComment].
			tileBearingHelp balloonTextSelector: balloonTextSelector]
		ifNotNil: [tileBearingHelp setBalloonText: aDocString].
	aPhrase markAsPartsDonor.
	cmd == #emptyScript
		ifTrue: [aPhrase setProperty: #newPermanentScript toValue: true.
			aPhrase setProperty: #newPermanentPlayer toValue: player.
			aPhrase submorphs second setBalloonText: 'drag and drop to 
add a new script'].
	universal
		ifFalse: [selfTile _ player tileToRefer.
			selfTile position: aPhrase firstSubmorph position.
			aPhrase firstSubmorph addMorph: selfTile].
	^ aPhrase duplicate! !

!Morph methodsFor: 'NetMorph example' stamp: 'kuri-t 1/4/2003 12:18'!
forwardPhrase
	^ self buildPhraseForSelector: #forward:.! !

!Morph methodsFor: 'NetMorph example' stamp: 'kuri-t 1/6/2003 12:42'!
guruguruWarp
	| scriptEditor basePhrase |
	self openViewerForArgument.
	basePhrase _ self forwardPhrase.
	scriptEditor _ basePhrase morphToDropInPasteUp: ActiveWorld.
	basePhrase justGrabbedFromViewer: false.
	scriptEditor openInWorld.
	HandMorph attach: scriptEditor.
	self addPhrase: self turnPhrase to: scriptEditor.
	self addPhrase: self warpPhrase to: scriptEditor.
	ActiveWorld restoreDisplay.! !

!Morph methodsFor: 'NetMorph example' stamp: 'kuri-t 1/4/2003 11:34'!
methodInterfaceNamed: selector 
	| player vocabulary |
	player _ self assuredPlayer.
	vocabulary _ (CategoryViewer new initializeFor: player) currentVocabulary.
	^ vocabulary
		methodInterfaceAt: selector
		ifAbsent: []! !

!Morph methodsFor: 'NetMorph example' stamp: 'kuri-t 1/4/2003 12:19'!
turnPhrase
	^ self buildPhraseForSelector: #turn:.! !

!Morph methodsFor: 'NetMorph example' stamp: 'kuri-t 1/4/2003 12:19'!
warpPhrase
	^ self buildPhraseForSelector: #warp.! !


!BookMorph methodsFor: 'menu' stamp: 'ka 1/27/2003 13:45'!
loadImagesIntoBook
	"PowerPoint stores GIF presentations as individual slides named Slide1, Slide2, etc.
	Load these into the book.  mjg 9/99"

	| directory filenumber form newpage |
	directory _ ((StandardFileMenu oldFileFrom: FileDirectory default) ifNil: [^ nil]) directory.
	directory isNil ifTrue: [^ nil].

	"Start loading 'em up!!"
	filenumber _ 1.
	[directory fileExists: 'XCh',(filenumber asString), '.jpg'] whileTrue:
		[Transcript show: 'XCh',(filenumber asString), '.jpg'; cr.
		(Smalltalk bytesLeft < 1000000) ifTrue: ["Make some room"
			(self valueOfProperty: #url) == nil ifTrue:
				[self savePagesOnURL]
			ifFalse: [self saveAsNumberedURLs].].
		form _ Form fromFileNamed: 
			(directory fullNameFor: 'XCh', (filenumber asString), '.jpg').
		newpage _ PasteUpMorph new extent: (form extent).
		newpage addMorph: (SketchMorph withForm: form).
		self pages addLast: newpage.
		filenumber _ filenumber + 1.].

	"After adding all, delete the first page."
	self goToPage: 1.
	self deletePageBasic.

	"Save the book"
	"(self valueOfProperty: #url) == nil ifTrue:
				[self savePagesOnURL]
			ifFalse: [self saveAsNumberedURLs]."! !


!FlapTab methodsFor: 'textual tabs' stamp: 'ns 2/14/2003 16:53'!
assumeString: aString font: aFont orientation: orientationSymbol color: aColor 
	| aTextMorph workString tabStyle |
	labelString _ aString asString.
	orientationSymbol == #vertical
		ifTrue: [workString _ String
						streamContents: [:s | labelString
								do: [:c | s nextPut: c]
								separatedBy: [s nextPut: Character cr]]]
		ifFalse: [workString _ labelString].
	tabStyle _ TextStyle new leading: 0;
				
				newFontArray: (Array with: aFont).
	aTextMorph _ (TextMorph new setTextStyle: tabStyle)
				contents: (workString asText
						addAttribute: (TextKern kern: 3)).
	self removeAllMorphs.
	self borderWidth: 2;
		 borderColor: #raised.
	aColor
		ifNotNil: [self color: aColor].
	self addMorph: aTextMorph centered.
	aTextMorph lock! !

!FlapTab methodsFor: 'textual tabs' stamp: 'mu 2/19/2003 15:13'!
changeTabText: aString 
	| label |
	aString isEmptyOrNil
		ifTrue: [^ self].
	label _ aString.
	self useStringTab: label.
	submorphs first delete.
	self
		assumeString: label
		font: Preferences standardFlapFont
		orientation: (Flaps orientationForEdge: self edgeToAdhereTo)
		color: nil! !


!HaloMorph methodsFor: 'initialization' stamp: 'kuri-t 2/6/2003 12:43'!
delete
	"Delete the halo.  Tell the target that it no longer has the halo; accept any pending edits to the name; and then either actually delete myself or start to fade out"

	self prepareToDelete.
	Preferences haloTransitions
		ifTrue:
			[self stopStepping; startStepping.
			self startSteppingSelector: #fadeOutFinally]
		ifFalse:
			[super delete]! !

!HaloMorph methodsFor: 'initialization' stamp: 'kuri-t 2/6/2003 12:44'!
forceDelete
	self prepareToDelete.
	super delete! !

!HaloMorph methodsFor: 'initialization' stamp: 'kuri-t 2/6/2003 12:42'!
prepareToDelete
	target
		ifNotNil: [target hasHalo: false].
	self acceptNameEdit.
	self isMagicHalo: false! !

!HaloMorph methodsFor: 'stepping'!
localHaloBoundsFor: aMorph

	"aMorph may be in the hand and perhaps not in our world"

	| r |

	r _ aMorph topRendererOrSelf worldBoundsForHalo truncated.
	aMorph world = self world ifTrue: [^r].
	^((self transformFromOutermostWorld) globalBoundsToLocal: r) truncated! !

!HaloMorph methodsFor: 'private' stamp: 'tk 7/14/2001 11:04'!
doDrag: evt with: dragHandle
	| thePoint |
	evt hand obtainHalo: self.
	thePoint _ target point: evt position - positionOffset from: owner.
	target setConstrainedPosition:(target griddedPoint: thePoint) hangOut: true.
! !

!HaloMorph methodsFor: 'private' stamp: 'kuri-t 2/18/2003 14:26'!
endInteraction
	"Clean up after a user interaction with the a halo control"

	self isMagicHalo: false. "no longer"
	self magicAlpha: 1.0.
	(target isInWorld not or: [owner == nil]) ifTrue: [^ self].
	self isInWorld ifTrue:
		["make sure handles show in front, even if flex shell added"
		self comeToFront.
		self addHandles].
	(self valueOfProperty: #commandInProgress) doIfNotNil:
		[:cmd | self rememberCommand: cmd.
		self removeProperty: #commandInProgress].

	target rememberMoveEndPoint.
	target startKeepMoving
! !

!HaloMorph methodsFor: 'private' stamp: 'mu 1/2/2003 19:17'!
startDrag: evt with: dragHandle
	"Drag my target without removing it from its owner."

	| itsOwner |
	self obtainHaloForEvent: evt andRemoveAllHandlesBut: dragHandle.
	positionOffset _ dragHandle center - (target point: target position in: owner).
	
	target rememberMoveStartPoint.

	 ((itsOwner _ target topRendererOrSelf owner) notNil and:
			[itsOwner automaticViewing]) ifTrue:
				[target openViewerForArgument]! !


!HandMorph methodsFor: 'grabbing/dropping' stamp: 'mu 1/4/2003 17:29'!
attachMorph: m
	"Position the center of the given morph under this hand, then grab it.
	This method is used to grab far away or newly created morphs."
	| delta |
	m stopKeepMoving.
	self releaseMouseFocus. "Break focus"
	delta _ m bounds extent // 2.
	m position: (self position - delta).
	m formerPosition: m position.
	targetOffset _ m position - self position.
	self addMorphBack: m.
! !

!HandMorph methodsFor: 'grabbing/dropping' stamp: 'mu 1/4/2003 17:29'!
grabMorph: aMorph
	"Grab the given morph (i.e., add it to this hand and remove it from its current owner) without changing its position. This is used to pick up a morph under the hand's current position, versus attachMorph: which is used to pick up a morph that may not be near this hand."
	| grabbed |
	aMorph stopKeepMoving.
	self releaseMouseFocus. "Break focus"
	grabbed _ aMorph aboutToBeGrabbedBy: self.
	grabbed ifNil:[^self].
	grabbed _ grabbed topRendererOrSelf.
	^self grabMorph: grabbed from: grabbed owner! !

!HandMorph methodsFor: 'private'!
objectForDataStream: refStrm
	| dp |
	"I am about to be written on an object file.  Write a path to me in the other system instead."
	refStrm project isNil ifFalse: [
		(refStrm project world hands includes: self) ifTrue: [
			^ self]].	"owned by the project"
	dp _ DiskProxy global: #World selector: #primaryHand args: #().
	refStrm replace: self with: dp.
	^ dp
	"Note, when this file is loaded in an MVC project, this will return nil.  The MenuItemMorph that has this in a field will have that item not work.  Maybe warn the user at load time?"! !


!MenuMorph methodsFor: 'initialization' stamp: 'kuri-t 2/14/2003 12:11'!
delete
	activeSubMenu
		ifNotNil: [activeSubMenu delete].
	^ self topRendererOrSelf isFlexMorph
		ifTrue: [self topRendererOrSelf delete]
		ifFalse: [super delete]! !


!Morph class methodsFor: 'instance creation' stamp: 'MU2 1/21/2003 16:54'!
fromUUID: anUUID 
	"Morph fromUUID: UUID new"
	"Morph fromUUID: ActiveWorld allMorphs first identifier"
	| detection netMorphProxy morphProxy |
	detection _ (ActiveWorld allMorphs reject: [:each | each isRenderer])
				detect: [:morph | morph identifier = anUUID]
				ifNone: [].
	detection isNil
		ifFalse: [^ detection].
	netMorphProxy _ NmUtil netMorphProxyCache
				at: anUUID
				ifAbsent: [].
	netMorphProxy isNil
		ifFalse: [^ netMorphProxy].
	morphProxy _ NmRemoteConnector callFindBy: anUUID retry: 3.
	morphProxy isNil
		ifFalse: [NmUtil netMorphProxyCache at: anUUID put: morphProxy.
			^ morphProxy].
	^ nil! !

!Morph class methodsFor: 'instance creation'!
fromUUIDString: anUUIDString 
	| anUUID |
	anUUID _ UUID fromString: anUUIDString.
	^ self fromUUID: anUUID! !

!Morph class methodsFor: 'instance creation' stamp: 'ka 10/17/2002 19:46'!
readFrom: aStream 
	| object logFlag |
	logFlag _ false.
	aStream reset.
	[[aStream atEnd]
		whileFalse: [aStream skipSeparators.
			[(aStream peekFor: $!!)
				ifTrue: [(Compiler evaluate: aStream nextChunk logged: logFlag)
						scanFrom: aStream
						logged: logFlag]
				ifFalse: [| chunk | 
					chunk _ aStream nextChunk.
					aStream checkForPreamble: chunk.
					Compiler evaluate: chunk logged: logFlag]]
				on: InMidstOfFileinNotification
				do: [:ex | ex resume: true].
			aStream skipStyleChunk]]
		ensure: [aStream close].
	object _ SmartRefStream scannedObject.
	SmartRefStream scannedObject: nil.
	^ object! !

!Morph class methodsFor: 'class initialization' stamp: 'kuri-t 1/31/2003 14:01'!
initialize
	"Morph initialize"

	"this empty array object is shared by all morphs with no submorphs:"
	EmptyArray _ Array new.
	WarpProtect _ Semaphore forMutualExclusion! !

!Morph class methodsFor: 'scripting'!
additionsToViewerCategories
	"Answer a list of (<categoryName> <list of category specs>) pairs that characterize the phrases this kind of morph wishes to add to various Viewer categories.  The special generic Morph version factors each category definition into a separate method; to solve recurrent fileout-ordering problems, this method can still function even if some of those separate methods are absent."

		^ #(additionsToViewerCategoryBasic additionsToViewerCategoryScripts additionsToViewerCategoryColorAndBorder additionsToViewerCategoryGeometry additionsToViewerCategoryMiscellaneous additionsToViewerCategoryButton additionsToViewerCategoryMotion additionsToViewerCategoryObservation additionsToViewerCategoryPenUse additionsToViewerCategoryLayout additionsToViewerCategoryDragAndDrop additionsToViewerCategoryScripting additionsToViewerCategoryTests additionsToViewerCategoryNetMorph)

		select:
			[:aSelector | self respondsTo: aSelector]
		thenCollect:
			[:aSelector | self perform: aSelector]

"Morph additionsToViewerCategories size"
! !

!Morph class methodsFor: 'scripting'!
additionsToViewerCategoryMiscellaneous
	"Answer viewer additions for the 'miscellaneous' category"

	^#(
		miscellaneous 
		(
			(command doMenuItem: 'do the menu item' Menu)
			(command show 'make the object visible')
			(command hide 'make the object invisible')
			(command wearCostumeOf: 'wear the costume of...' Player)

			(command fire 'trigger any and all of this object''s button actions')
			(slot copy 'returns a copy of this object' Player readOnly Player getNewClone	 unused unused)
			(slot elementNumber 'my index in my container' Number readWrite Player getIndexInOwner Player setIndexInOwner:)
			(slot holder 'the object''s container' Player readOnly Player getHolder Player setHolder:)
			(command stampAndErase 'add my image to the pen trails and go away')
			(command effects: 'add an Mugi Mugi effect on me' Effect)
		)
	)

! !

!Morph class methodsFor: 'scripting'!
additionsToViewerCategoryMotion
	"Answer viewer additions for the 'motion' category"

	^#(
		motion 
		(
			(slot x 'The x coordinate' Number readWrite Player getX Player setX:)
			(slot y  	'The y coordinate' Number readWrite Player 	getY Player setY:)
			(slot heading  'Which direction the object is facing.  0 is straight up' Number readWrite Player getHeading Player setHeading:)
			(command forward: 'Moves the object forward in the direction it is heading' Number)
			(slot obtrudes 'whether the object sticks out over its container''s edge' Boolean readOnly Player getObtrudes unused unused) 
			(command moveToward: 'move toward the given object' Player) 
			(command turn: 'Change the heading of the object by the specified amount' Number)
			(command bounce: 'bounce off the edge if hit' Sound) 
			(command wrap 'wrap off the edge if appropriate') 
			(command followPath 'follow the yellow brick road') 
			(command goToRightOf: 'place this object to the right of another' Player)
			(command head: 'turn my head' Direction)
		)
	)

! !

!Morph class methodsFor: 'scripting' stamp: 'ka 1/15/2003 17:51'!
additionsToViewerCategoryNetMorph
	"Answer viewer additions for the 'NetMorph' category"

	^#(
		NetMorph 
		(
			(slot home 'my home' WarpDestination readOnly Player getHome Player unused)
			(slot address 'my address' WarpDestination readOnly Player getAddress Player unused)
			"(slot identifier 'my identifier' String readOnly Player getIdentifier Player unused)"
			(command warp 'engage warp drive')
			(command warp: 'engage warp drive' Warp)
			(command warpTo: 'warp to the specified address' WarpDestination)
		)
	)
! !

!Morph class methodsFor: 'scripting' stamp: 'kuri-t 12/13/2002 14:13'!
additionsToViewerCategoryTests
	"Answer viewer additions for the 'tests' category.  Note that isOverColor is commented out owing to intractable performance problems in continuously evaluating it in a Viewer -- someone should attend to this someday."

	^#(
		#tests 
		(
			"(slot isOverColor 'whether any part of the object is over the given color' Boolean	readOnly Player seesColor: unused unused) "
			(slot isUnderMouse 'whether the object is under the current mouse position' Boolean readOnly	Player getIsUnderMouse unused unused)
			(slot colorSees	'whether the given color sees the given color' Boolean readOnly	Player color:sees:	unused	unused)
			(slot touchesA	'whether I touch something that looks like...' Boolean readOnly Player touchesA:	unused	unused)
			(slot obtrudes 'whether the object sticks out over its container''s edge' Boolean readOnly Player getObtrudes unused unused)
			(slot nearTo '' Boolean readOnly Player nearTo: unused	unused)
		)
	)
! !

!Morph class methodsFor: 'support'!
canvasAll: aMorph 
	| wholeCanvas visible baseCanvas |
	visible _ aMorph visible.
	visible
		ifFalse: [aMorph visible: true].
	wholeCanvas _ FormCanvas extent: ActiveWorld bounds extent.
	wholeCanvas fullDraw: ActiveWorld.
	visible
		ifFalse: [aMorph visible: false].
	baseCanvas _ FormCanvas extent: aMorph bounds extent.
	baseCanvas drawImage: wholeCanvas form at: aMorph bounds topLeft negated.
	^ baseCanvas! !

!Morph class methodsFor: 'support'!
canvasBelow: aMorph 
	| wholeCanvas intersectsWindows bgMorph baseCanvas |
	wholeCanvas _ FormCanvas extent: ActiveWorld bounds extent.
	(bgMorph _ ActiveWorld backgroundSketch) isNil
		ifTrue: [wholeCanvas fillColor: ActiveWorld color]
		ifFalse: [wholeCanvas drawOn: bgMorph].
	wholeCanvas fillColor: Color white.
	wholeCanvas drawMorph: ActiveWorld.
	intersectsWindows _ self intersectsWindows: aMorph bounds below: aMorph.
	intersectsWindows
		do: [:each | wholeCanvas fullDraw: each].
	baseCanvas _ FormCanvas extent: aMorph bounds extent.
	baseCanvas drawImage: wholeCanvas form at: aMorph bounds topLeft negated.
	^ baseCanvas! !

!Morph class methodsFor: 'support'!
canvasWithout: aMorph 
	| wholeCanvas visible baseCanvas |
	visible _ aMorph visible.
	visible
		ifTrue: [aMorph visible: false].
	wholeCanvas _ FormCanvas extent: ActiveWorld bounds extent.
	wholeCanvas fullDraw: ActiveWorld.
	visible
		ifTrue: [aMorph visible: true].
	baseCanvas _ FormCanvas extent: aMorph bounds extent.
	baseCanvas drawImage: wholeCanvas form at: aMorph bounds topLeft negated.
	^ baseCanvas! !

!Morph class methodsFor: 'support' stamp: 'ns 9/18/2002 17:57'!
effectExample
	"Morph effectExample."
	| savedDepth rectangleMorph1 rectangleMorph2 ellipseMorph starMorph selectors |
	(savedDepth _ Display depth) < 32
		ifTrue: [Display newDepth: 32].
	rectangleMorph1 _ RectangleMorph new.
	rectangleMorph1 position: 100 @ 100.
	rectangleMorph1 extent: 200 @ 300.
	rectangleMorph1 color: Color red.
	rectangleMorph2 _ RectangleMorph new.
	rectangleMorph2 position: 250 @ 125.
	rectangleMorph2 extent: 200 @ 300.
	ellipseMorph _ EllipseMorph new.
	ellipseMorph extent: 200 @ 200.
	ellipseMorph position: 150 @ 150.
	starMorph _ StarMorph new.
	starMorph extent: 200 @ 200.
	starMorph color: Color red.
	starMorph position: 150 @ 150.
	starMorph borderWidth: 4.
	starMorph addHandles.
	starMorph setBorderStyle: #complexAltRaised.
	starMorph useGradientFill.
	starMorph fillStyle radial: true.
	starMorph fillStyle
		lastColor: (Color
				r: 0.972
				g: 0.972
				b: 0.066)
		forMorph: starMorph
		hand: ActiveHand.
	starMorph toggleDropShadow.
	rectangleMorph1 openInWorld.
	ellipseMorph openInWorld.
	starMorph openInWorld.
	rectangleMorph2
		color: (TranslucentColor
				r: 1.0
				g: 0.452
				b: 0.645
				alpha: 0.447).
	rectangleMorph2 openInWorld.
	ActiveWorld refreshWorld.
	selectors _ #(#poofIn #fadeImageSquares #appearImageSquares #curtainFall #curtainRise #pageOut #pageIn #zoomOut #zoomIn #frenchDoorClose #frenchDoorOpen #frenchWindowClose #frenchWindowOpen #poofOut #dissolve ).
	Display
		restoreAfter: [selectors
				do: [:selector | 
					Transcript cr; show: selector.
					ellipseMorph perform: selector.
					(Delay forMilliseconds: 500) wait].
			ellipseMorph dismissMorph: nil.
			rectangleMorph1 dismissMorph: nil.
			rectangleMorph2 dismissMorph: nil.
			starMorph dismissMorph: nil.
			Smalltalk garbageCollect.
			ActiveWorld refreshWorld].
	savedDepth ~= Display depth
		ifTrue: [Display newDepth: savedDepth]! !

!Morph class methodsFor: 'support'!
effectSymbols
	"Morph effectSymbols."
	| effectSymbols defaultSymbol |
	defaultSymbol _ #none.
	effectSymbols _ (self organization
				listAtCategoryNamed: (Morph organization categoryOfElement: defaultSymbol)) asOrderedCollection.
	effectSymbols
		remove: defaultSymbol
		ifAbsent: [].
	effectSymbols addFirst: defaultSymbol.
	^ effectSymbols asArray! !

!Morph class methodsFor: 'support'!
imageAll: aMorph 
	^ (self canvasAll: aMorph) form! !

!Morph class methodsFor: 'support'!
imageBelow: aMorph 
	^ (self canvasBelow: aMorph) form! !

!Morph class methodsFor: 'support'!
imageWithout: aMorph 
	^ (self canvasWithout: aMorph) form! !

!Morph class methodsFor: 'support'!
intersectsWindows: aRectangle below: targetMorph 
	| windows |
	windows _ OrderedCollection new.
	ActiveWorld submorphs reverse
		do: [:morph | 
			morph == targetMorph
				ifTrue: [^ windows].
			(morph bounds intersects: targetMorph bounds)
				ifTrue: [windows add: morph]].
	^ windows! !

!Morph class methodsFor: 'support'!
intersectsWindows: aRectangle with: targetMorph 
	^ (ActiveWorld submorphs reverse
		reject: [:morph | morph == targetMorph])
		select: [:morph | morph bounds intersects: targetMorph bounds]! !

!Morph class methodsFor: 'support'!
outsideBelowAndAboveWindows: aRectangle with: targetMorph 
	| intersectsWindows windows |
	intersectsWindows _ self intersectsWindows: aRectangle below: targetMorph.
	windows _ ActiveWorld submorphs asOrderedCollection.
	windows removeAll: intersectsWindows.
	windows
		remove: targetMorph
		ifAbsent: [].
	^ windows! !

!Morph class methodsFor: 'support'!
outsideWindows: aRectangle with: targetMorph 
	| intersectsWindows windows |
	intersectsWindows _ self intersectsWindows: aRectangle with: targetMorph.
	windows _ ActiveWorld submorphs asOrderedCollection.
	windows removeAll: intersectsWindows.
	windows
		remove: targetMorph
		ifAbsent: [].
	^ windows! !


!MorphExtension methodsFor: 'copying'!
clone
	| cloneObject |
	cloneObject _ super clone.
	cloneObject instVarNamed: 'identifier' put: UUID new.
	^ cloneObject! !

!MorphExtension methodsFor: 'copying'!
veryDeepCopyWith: deepCopier 
	| newObject |
	newObject _ super veryDeepCopyWith: deepCopier.
	newObject instVarNamed: 'identifier' put: UUID new.
	^ newObject! !

!MorphExtension methodsFor: 'copying'!
veryDeepInner: deepCopier
	| list values vv |
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  This is special code for the dictionary.  See DeepCopier."

	super veryDeepInner: deepCopier.
	locked _ locked veryDeepCopyWith: deepCopier.
 	visible _ visible veryDeepCopyWith: deepCopier.
 	sticky _ sticky veryDeepCopyWith: deepCopier.
 	balloonText _ balloonText veryDeepCopyWith: deepCopier.
 	balloonTextSelector _ balloonTextSelector veryDeepCopyWith: deepCopier.
 	externalName _ externalName veryDeepCopyWith: deepCopier.
 	isPartsDonor _ isPartsDonor veryDeepCopyWith: deepCopier.
 	actorState _ actorState veryDeepCopyWith: deepCopier.
 	player _ player veryDeepCopyWith: deepCopier.	"Do copy the player of this morph"
 	eventHandler _ eventHandler veryDeepCopyWith: deepCopier.	"has its own restrictions"
 	path _ path veryDeepCopyWith: deepCopier.
 	identifier _ identifier veryDeepCopyWith: deepCopier.

	otherProperties ifNotNil: [
		otherProperties _ otherProperties copy.
		list _ self copyWeakly.	"Properties whose values are only copied weakly"
		values _ list collect: [:pp | 
			vv _ otherProperties at: pp ifAbsent: [nil].
			vv ifNotNil: [otherProperties at: pp put: nil]. "zap it"
			vv].
	 	otherProperties _ otherProperties veryDeepCopyWith: deepCopier.
		1 to: list size do: [:ii | "put old values back"
			(values at: ii) ifNotNil: [otherProperties at: (list at: ii) put: (values at: ii)]]].
! !

!MorphExtension methodsFor: 'initialization'!
initialize
	"Init all booleans to default values"
	locked _ false.
	visible _ true.
	sticky _ false.
	isPartsDonor _ false.
	self initializeNetMorph! !

!MorphExtension methodsFor: 'other'!
isDefault
	"NetMorph: allways returns false."
	"Return true if the receiver is a default and can be omitted"
	locked == true
		ifTrue: [^ false].
	visible == false
		ifTrue: [^ false].
	sticky == true
		ifTrue: [^ false].
	balloonText == nil
		ifFalse: [^ false].
	balloonTextSelector == nil
		ifFalse: [^ false].
	externalName == nil
		ifFalse: [^ false].
	isPartsDonor == true
		ifTrue: [^ false].
	actorState == nil
		ifFalse: [^ false].
	player == nil
		ifFalse: [^ false].
	eventHandler == nil
		ifFalse: [^ false].
	otherProperties == nil
		ifFalse: [otherProperties size > 0
				ifTrue: [^ false]].
	^ false! !

!MorphExtension methodsFor: 'NetMorph initialize' stamp: 'MU 11/11/2002 15:37'!
initializeNetMorph
	| url |
	path _ OrderedCollection new.
	url _ NmUrl local copy.
	path addFirst: url.
	identifier _ UUID new! !

!MorphExtension methodsFor: 'NetMorph initialize' stamp: 'kuri-t 1/15/2003 12:13'!
resetIdentifier
	identifier _ nil! !

!MorphExtension methodsFor: 'NetMorph accessing' stamp: 'ns 10/21/2002 15:08'!
address
	self path isEmpty
		ifFalse: [^ self path last].
	^ nil! !

!MorphExtension methodsFor: 'NetMorph accessing' stamp: 'ns 10/21/2002 15:08'!
home
	self path isEmpty
		ifFalse: [^ self path first].
	^ nil! !

!MorphExtension methodsFor: 'NetMorph accessing' stamp: 'ns 10/21/2002 15:10'!
identifier
	identifier
		ifNil: [identifier _ UUID new].
	^ identifier! !

!MorphExtension methodsFor: 'NetMorph accessing' stamp: 'MU 11/11/2002 15:38'!
path
	path
		ifNil: [| url | 
			path _ OrderedCollection new.
			url _ NmUrl local copy.
			path addFirst: url].
	^ path! !

!MorphExtension methodsFor: 'NetMorph accessing'!
path: visitedLocationCollection 
	path _ visitedLocationCollection! !


!MorphExtension class methodsFor: 'private netMorph'!
classesHasInstVarNames: anArray 
	"MorphExtension classesHasInstVarNames: (Array with: (#home))."
	"MorphExtension classesHasInstVarNames: (Array with: (#address))."
	"MorphExtension classesHasInstVarNames: (Array with: (#identifier))."
	| classes collection |
	classes _ Morph allSubclasses asOrderedCollection.
	classes add: Morph.
	collection _ OrderedCollection new.
	classes
		do: [:each | anArray
				do: [:varName | (each instVarNames includes: varName)
						ifTrue: [collection add: each]]].
	^ collection! !

!MorphExtension class methodsFor: 'private netMorph'!
test
	"Time millisecondsToRun: [MorphExtension test]."
	"15 : without making assureExtension in initialize, 188 : with making assureExtension in initialize."
	BouncingAtomsMorph new openInWorld.
	Display restore! !


!MorphTest methodsFor: 'Testing'!
testDismissMorph
	| rectangle rectangleId ellipse ellipseId ellipseExist rectangleExist |
	rectangle _ RectangleMorph new.
	rectangleId _ rectangle identityHash.
	ellipse _ EllipseMorph new.
	ellipseId _ ellipse identityHash.
	rectangle addMorph: ellipse.
	rectangle openInWorld.
	rectangle topRendererOrSelf dismissMorph: nil.
	rectangle _ ellipse _ nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	ellipseExist _ EllipseMorph allInstances
				detect: [:each | each identityHash == ellipseId]
				ifNone: [].
	rectangleExist _ RectangleMorph allInstances
				detect: [:each | each identityHash == rectangleId]
				ifNone: [].
	self
		should: [ellipseExist isNil].
	self
		should: [rectangleExist isNil]! !

!MorphTest methodsFor: 'Testing'!
testDismissMorphForTransformation
	| rectangle rectangleId ellipse ellipseId ellipseExist rectangleExist |
	rectangle _ RectangleMorph new.
	rectangleId _ rectangle identityHash.
	rectangle openInWorld.
	rectangle heading: 100.
	ellipse _ EllipseMorph new.
	ellipseId _ ellipse identityHash.
	rectangle addMorph: ellipse.
	rectangle topRendererOrSelf dismissMorph: nil.
	rectangle _ ellipse _ nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	ellipseExist _ EllipseMorph allInstances
				detect: [:each | each identityHash == ellipseId]
				ifNone: [].
	rectangleExist _ RectangleMorph allInstances
				detect: [:each | each identityHash == rectangleId]
				ifNone: [].
	self
		should: [ellipseExist isNil].
	self
		should: [rectangleExist isNil]! !

!MorphTest methodsFor: 'Testing'!
testLocalHaloBoundsFor
	| rectangleMorph halo befor after |
	rectangleMorph _ RectangleMorph new.
	rectangleMorph position: 100 @ 100.
	rectangleMorph extent: 200 @ 300.
	rectangleMorph openInWorld.
	rectangleMorph dropEnabled: true.
	rectangleMorph enableDrop: true.
	rectangleMorph enableDragNDrop: true.

	halo _ HaloMorph new setTarget: rectangleMorph.
	befor _	 halo localHaloBoundsFor: rectangleMorph.

	rectangleMorph heading: 90.

	halo _ HaloMorph new setTarget: rectangleMorph.
	after _	 halo localHaloBoundsFor: rectangleMorph topRendererOrSelf.
	self should: [befor width == (after height - 2)].
	self should: [befor height == (after width - 2)].
	rectangleMorph topRendererOrSelf dismissMorph: nil.
	Smalltalk garbageCollect! !

!MorphTest methodsFor: 'Testing'!
testPrivateAddMorphAtIndex
	| rectangleMorph ellipseMorph event |
	rectangleMorph _ RectangleMorph new.
	rectangleMorph position: 100 @ 100.
	rectangleMorph extent: 200 @ 300.
	rectangleMorph openInWorld.
	rectangleMorph dropEnabled: true.
	rectangleMorph enableDrop: true.
	rectangleMorph enableDragNDrop: true.
	rectangleMorph heading: 90.
	ellipseMorph _ EllipseMorph new.
	ellipseMorph extent: 50 @ 100.
	ellipseMorph openInWorld.
	ellipseMorph position: 100 @ 130.
	ellipseMorph heading: 90.
	event _ DropEvent new.
	"event type: #dropEvent."
	event
		setPosition: -100.0 @ 24.0
		contents: ellipseMorph topRendererOrSelf
		hand: HandMorph new.
	rectangleMorph acceptDroppingMorph: ellipseMorph topRendererOrSelf event: event.
	ellipseMorph topRendererOrSelf position: -45 @ -40.
	self
		should: [rectangleMorph submorphs includes: ellipseMorph topRendererOrSelf].
	rectangleMorph topRendererOrSelf dismissMorph: nil.
	Smalltalk garbageCollect! !

!MorphTest methodsFor: 'Testing'!
testSaveOnFile
	| rectangleMorph ellipseMorph event aStream theMorph submorph savingBlock aFileName |
	rectangleMorph _ RectangleMorph new.
	rectangleMorph position: 100 @ 100.
	rectangleMorph extent: 200 @ 300.
	rectangleMorph openInWorld.
	rectangleMorph dropEnabled: true.
	rectangleMorph enableDrop: true.
	rectangleMorph enableDragNDrop: true.
	rectangleMorph heading: 90.
	ellipseMorph _ EllipseMorph new.
	ellipseMorph extent: 50 @ 100.
	ellipseMorph openInWorld.
	ellipseMorph position: 100 @ 130.
	ellipseMorph heading: 90.
	event _ DropEvent new.
	event
		setPosition: -100.0 @ 24.0
		contents: ellipseMorph topRendererOrSelf
		hand: HandMorph new.
	rectangleMorph acceptDroppingMorph: ellipseMorph topRendererOrSelf event: event.
	ellipseMorph topRendererOrSelf position: -45 @ -40.
	"rectangleMorph saveOnFile."
	aFileName _ '__Test.morph'.
	FileDirectory default deleteFileNamed: aFileName.
	savingBlock _ [:morph | 
			| fileStream topRendererOrSelf | 
			topRendererOrSelf _ morph topRendererOrSelf.
			topRendererOrSelf
				allMorphsDo: [:m | m prepareToBeSaved].
			fileStream _ FileStream newFileNamed: aFileName.
			fileStream fileOutClass: nil andObject: topRendererOrSelf].
	savingBlock value: rectangleMorph.
	rectangleMorph topRendererOrSelf dismissMorph: nil.
	aStream _ FileStream oldFileNamed: '__Test.morph'.
	theMorph _ Morph readFrom: aStream.
	theMorph openInWorld.
	submorph _ theMorph renderedMorph submorphs
				detect: [:each | each isKindOf: TransformationMorph]
				ifNone: [].
	self
		should: [submorph notNil].
	self
		should: [submorph renderedMorph isKindOf: EllipseMorph].
	theMorph topRendererOrSelf dismissMorph: nil.
	FileDirectory default deleteFileNamed: aFileName.
	Smalltalk garbageCollect! !

!MorphTest methodsFor: 'Testing'!
testScaleToMatch
	| rectangleMorph ellipseMorph event before after |
	rectangleMorph _ RectangleMorph new.
	rectangleMorph position: 100 @ 100.
	rectangleMorph extent: 200 @ 300.
	rectangleMorph openInWorld.
	rectangleMorph dropEnabled: true.
	rectangleMorph enableDrop: true.
	rectangleMorph enableDragNDrop: true.
	rectangleMorph heading: 90.
	ellipseMorph _ EllipseMorph new.
	ellipseMorph extent: 50 @ 100.
	ellipseMorph openInWorld.
	ellipseMorph position: 100 @ 130.
	ellipseMorph heading: 90.
	event _ DropEvent new.
	"event type: #dropEvent."
	event
		setPosition: -100.0 @ 24.0
		contents: ellipseMorph topRendererOrSelf
		hand: HandMorph new.
	rectangleMorph acceptDroppingMorph: ellipseMorph topRendererOrSelf event: event.
	ellipseMorph topRendererOrSelf position: -45 @ -40.
	before _ ellipseMorph topRendererOrSelf bounds area.
	ellipseMorph topRendererOrSelf scaleToMatch: 246 @ 310.
	after _ ellipseMorph topRendererOrSelf bounds area.
	self
		should: [before == 5304].
	self
		should: [after == 6160].
	rectangleMorph topRendererOrSelf dismissMorph: nil.
	Smalltalk garbageCollect! !

!MorphTest methodsFor: 'Testing'!
testWithOffsetOfCompositeTransform
	| compositeTransform rectangleMorph |
	rectangleMorph _ RectangleMorph new.
	rectangleMorph position: 100 @ 100.
	rectangleMorph extent: 200 @ 300.
	rectangleMorph openInWorld.
	rectangleMorph dropEnabled: true.
	rectangleMorph enableDrop: true.
	rectangleMorph enableDragNDrop: true.
	rectangleMorph heading: 90.
	compositeTransform _ rectangleMorph topRendererOrSelf transform composedWith: rectangleMorph topRendererOrSelf transform.
	self
		should: [compositeTransform respondsTo: #withOffset:].
	self
		should: [compositeTransform offset = (50.0 @ -450.0)].
	self
		should: [compositeTransform scale = 1.0].
	self
		should: [compositeTransform angle = -3.141592653589793].
	compositeTransform withOffset: 1 @ 1.
	self
		should: [compositeTransform offset = (-201.0 @ -249.0)].
	self
		should: [compositeTransform scale = 1.0].
	self
		should: [compositeTransform angle = -3.141592653589793].
	rectangleMorph topRendererOrSelf dismissMorph: nil.
	Smalltalk garbageCollect! !

!MorphTest methodsFor: 'Testing'!
testWithOffsetOfDisplayTransform
	| displayTransform |
	displayTransform _ DisplayTransform new.
	self
		should: [displayTransform respondsTo: #withOffset:].
	self
		should: [[displayTransform withOffset: 2 @ 2.
			false]
				on: Error
				do: [:ex | true]]! !


!ObjectScanner methodsFor: 'as yet unclassified' stamp: 'ka 10/17/2002 19:32'!
lookAhead: aChunk logged: logFlag
	| pieces sup oldName existing newName newDefn |
	aChunk size < 90 ifTrue: [^ aChunk].		"class defn is big!!"
	(aChunk at: 1) == $!! ifTrue: [^ aChunk].	"method def, fast exit"
	pieces _ (aChunk copyFrom: 1 to: (300 min: aChunk size)) findTokens: ' #	\' withCRs.
	pieces size < 3 ifTrue: [^ aChunk].	"really bigger, but just took front"
	(pieces at: 2) = 'subclass:' ifFalse: [^ aChunk].
	sup _ Smalltalk at: (pieces at: 1) asSymbol ifAbsent: [^ aChunk].
	sup class class == Metaclass ifFalse: [^ aChunk].
	((oldName _ pieces at: 3) at: 1) isUppercase ifFalse: [^ aChunk].
	oldName _ oldName asSymbol.
	(Smalltalk includesKey: oldName) ifFalse: [^ aChunk].	"no conflict"
	existing _ Smalltalk at: oldName.
	(existing isKindOf: Class) ifFalse: [^ aChunk].	"Write over non-class global"
	existing isSystemDefined ifTrue: [^ aChunk].	"Go ahead and redefine it!!"
	"Is a UniClass"
	newName _ sup chooseUniqueClassName.
	newDefn _ aChunk copyReplaceAll: oldName with: newName.
	Compiler evaluate: newDefn for: self logged: logFlag.	"Create the new class"
	self rename: oldName toBe: newName.
	^ newName asString		"to be evaluated"
! !

!ObjectScanner methodsFor: 'as yet unclassified' stamp: 'ka 10/17/2002 19:38'!
scanFrom: aByteStream logged: logFlag 
	| valWithOddName47 scannerNamed53 chunkNamed117 |
	pvt3SmartRefStrm _ SmartRefStream on: aByteStream.
	aByteStream ascii.
	[aByteStream atEnd]
		whileFalse: [aByteStream skipSeparators.
			valWithOddName47 _ (aByteStream peekFor: $!!)
						ifTrue: [chunkNamed117 _ aByteStream nextChunk.
							"debug"
							scannerNamed53 _ Compiler
										evaluate: chunkNamed117
										for: self
										logged: logFlag.
							scannerNamed53 class == self class
								ifFalse: [scannerNamed53 scanFrom: aByteStream logged: logFlag]]
						ifFalse: [chunkNamed117 _ aByteStream nextChunk.
							chunkNamed117 _ self lookAhead: chunkNamed117 logged: logFlag.
							Compiler
								evaluate: chunkNamed117
								for: self
								logged: logFlag].
			aByteStream skipStyleChunk].
	^ valWithOddName47! !


!PaintBoxMorph methodsFor: 'recent colors' stamp: 'ka 1/16/2003 15:40'!
fixUpRecentColors
	| inner outer border box form newImage canvas morph |
	self fixUpColorPicker.
	recentColors _ WriteStream on: Array new.
	form _ image.
	newImage _ Form extent: form extent + (0@41) depth: form depth.
	form displayOn: newImage.
	newImage copy: ((0@(form height-10)) extent: form width @ (newImage height - form height + 10)) 
		from: 0 @ (form height - (newImage height - form height + 10))
		in: form rule: Form over.
	canvas _ newImage getCanvas.
	canvas line: 12@(form height-10) to: 92@(form height-10) width: 1 color: Color black.
	canvas _ canvas copyOffset: 12@(form height-9).

	inner _ (Color r: 0.677 g: 0.71 b: 0.968).
	outer _ inner darker darker.
	border _  (Color r: 0.194 g: 0.258 b: 0.194).
	0 to: 1 do:[:y|
		0 to: 3 do:[:x|
			box _ (x*20) @ (y*20) extent: 20@20.
			morph _ BorderedMorph new bounds: ((box insetBy: 1) translateBy: canvas origin + bounds origin).
			morph borderWidth: 1; borderColor: border.
			morph color: Color white.
			morph on: #mouseDown send: #mouseDownRecent:with: to: self.
			morph on: #mouseMove send: #mouseStillDownRecent:with: to: self.
			morph on: #mouseUp send: #mouseUpRecent:with: to: self.
			self addMorphFront: morph.
			recentColors nextPut: morph.
			canvas fillRectangle: box color: Color white.
			canvas frameRectangle: (box insetBy: 1) color: border.
			canvas frameRectangle: (box) color: inner.
			box _ box insetBy: 1.
			canvas line: box topRight to: box bottomRight width: 1 color: outer.
			canvas line: box bottomLeft to: box bottomRight width: 1 color: outer.
	]].
	recentColors _ recentColors contents.
	(RecentColors == nil or:[RecentColors size ~= recentColors size]) ifTrue:[
		RecentColors _ #(#red #magenta #yellow #green #cyan #blue #white #black )
						collect: [:each | Color perform: each]
	] ifFalse:[
		RecentColors keysAndValuesDo:[:idx :aColor| (recentColors at: idx) color: aColor].
	].
	self image: newImage.
	self toggleStamps.
	self toggleStamps.! !


!PasteUpMorph methodsFor: 'menu & halo' stamp: 'ka 12/18/2002 16:07'!
bottomFenceEnabledString
	^ self bottomFenceEnabled
		ifTrue: ['<on>bottom fence enabled']
		ifFalse: ['<off>bottom fence enabled']! !

!PasteUpMorph methodsFor: 'menu & halo' stamp: 'ka 12/18/2002 16:07'!
leftFenceEnabledString
	^ self leftFenceEnabled
		ifTrue: ['<on>left fence enabled']
		ifFalse: ['<off>left fence enabled']! !

!PasteUpMorph methodsFor: 'menu & halo' stamp: 'ka 12/18/2002 16:12'!
playfieldOptionsMenu
	"Answer an auxiliary menu with options specific to playfields -- too many to be housed in the main menu"

	| aMenu isWorld |
	isWorld _ self isWorldMorph.
	aMenu _ MenuMorph new defaultTarget: self.
	aMenu addStayUpItem.
	aMenu add: 'save on file...' action: #saveOnFile.
	aMenu add: 'save as SqueakPage at url...' action: #saveOnURL.
	aMenu add: 'update all from resources' action: #updateAllFromResources.
	(self valueOfProperty: #classAndMethod) ifNotNil:
		[aMenu add: 'broadcast as documentation' action: #saveDocPane].
	aMenu add: 'round up strays' action: #roundUpStrays.
	aMenu balloonTextForLastItem:  'Bring back all objects whose current coordinates keep them from being visible, so that at least a portion of each of my interior objects can be seen.'.
	aMenu add: 'show all players' action: #showAllPlayers.
	aMenu balloonTextForLastItem:  'Make visible the viewers for all players which have user-written scripts in this playfield.'.
	aMenu add: 'hide all players' action: #hideAllPlayers.
	aMenu balloonTextForLastItem:  'Make invisible the viewers for all players in this playfield. This will save space before you publish this project'.


	aMenu addLine.
	aMenu add: 'shuffle contents' action: #shuffleSubmorphs.
	aMenu balloonTextForLastItem: 'Rearranges my contents in random order'.
	self griddingOn
		ifTrue: [aMenu add: 'turn gridding off' action: #griddingOnOff.
				aMenu add: (self gridVisible ifTrue: ['hide'] ifFalse: ['show']) , ' grid'
						action: #gridVisibleOnOff.
				aMenu add: 'set grid spacing...' action: #setGridSpec]
		ifFalse: [aMenu add: 'turn gridding on' action: #griddingOnOff].
	aMenu addLine.

	#(	(autoLineLayoutString	toggleAutoLineLayout
			'whether submorphs should automatically be laid out in lines')
		(indicateCursorString	toggleIndicateCursor
			'whether the "current" submorph should be indicated with a dark black border')
		(isPartsBinString		toggleIsPartsBin
			'whether dragging an object from the interior should produce a COPY of the object')
		(isOpenForDragNDropString	toggleDragNDrop
			'whether objects can be dropped into and dragged out of me')
		(mouseOverHalosString	toggleMouseOverHalos
			'whether objects should put up halos when the mouse is over them')
		(autoExpansionString	toggleAutomaticPhraseExpansion
			'whether tile phrases, dropped on me, should automatically sprout Scriptors around them')
		(originAtCenterString	toggleOriginAtCenter
			'whether the cartesian origin of the playfield should be at its lower-left corner or at the center of the playfield')
		(showThumbnailString	toggleAlwaysShowThumbnail
			'whether large objects should be represented by thumbnail miniatures of themselves')
		(fenceEnabledString	toggleFenceEnabled
			'whether moving objects should stop at the edge of their container')
		(leftFenceEnabledString	toggleLeftFenceEnabled
			'whether moving objects should stop at the left edge of their container')
		(rightFenceEnabledString	toggleRightFenceEnabled
			'whether moving objects should stop at the right edge of their container')
		(topFenceEnabledString	toggleTopFenceEnabled
			'whether moving objects should stop at the top edge of their container')
		(bottomFenceEnabledString	toggleBottomFenceEnabled
			'whether moving objects should stop at the bottom edge of their container')
		(batchPenTrailsString	toggleBatchPenTrails 
			'if true, detailed movement of pens between display updates is ignored.  Thus multiple line segments drawn within a script may not be seen individually.')

	) do:

			[:triplet |
				(isWorld and: [#(toggleAutoLineLayout toggleIndicateCursor toggleIsPartsBin toggleAlwaysShowThumbnail) includes: triplet second]) ifFalse:
					[aMenu addUpdating: triplet first action: triplet second.
					aMenu balloonTextForLastItem: triplet third]]. 

	aMenu addUpdating: #autoViewingString action: #toggleAutomaticViewing.
	aMenu balloonTextForLastItem:  'governs whether, when an object is touched inside me, a viewer should automatically be launched for it.'.

	((isWorld not or: [self backgroundSketch notNil]) or: [presenter isNil])
		ifTrue:
			[aMenu addLine].

	isWorld ifFalse:
		[aMenu add: 'set thumbnail height...' action: #setThumbnailHeight.
		aMenu balloonTextForLastItem: 'if currently showing thumbnails governs the standard height for them'.
		aMenu add: 'behave like a Holder' action: #becomeLikeAHolder.
		aMenu balloonTextForLastItem: 'Set properties to make this object nicely set up to hold frames of a scripted animation.'].

	self backgroundSketch ifNotNil:
		[aMenu add: 'delete background painting' action: #deleteBackgroundPainting.
		aMenu balloonTextForLastItem: 'delete the graphic that forms the background for this me.'].
	presenter ifNil:
		[aMenu add: 'make detachable' action: #makeDetachable.
		aMenu balloonTextForLastItem: 'Allow this area to be separately governed by its own controls.'].

	aMenu addLine.
	aMenu add: 'use standard texture' action: #setStandardTexture.
	aMenu balloonTextForLastItem: 'use a pale yellow-and-blue background texture here.'.
	aMenu add: 'make graph paper...' action: #makeGraphPaper.
	aMenu balloonTextForLastItem: 'Design your own graph paper and use it as the background texture here.'.
	aMenu addTitle: 'playfield options...'.

	^ aMenu
! !

!PasteUpMorph methodsFor: 'menu & halo' stamp: 'ka 12/18/2002 16:12'!
presentViewMenu
	"Answer an auxiliary menu with options specific to viewing playfields -- this is put up from the provisional 'view' halo handle, on pasteup morphs only."

	| aMenu isWorld |
	isWorld _ self isWorldMorph.
	aMenu _ MenuMorph new defaultTarget: self.
	aMenu addStayUpItem.
	self addViewingItemsTo: aMenu.

	#(	"(autoLineLayoutString	toggleAutoLineLayout
			'whether submorphs should automatically be laid out in lines')"
		(indicateCursorString	toggleIndicateCursor
			'whether the "current" submorph should be indicated with a dark black border')
		(resizeToFitString		toggleResizeToFit
			'whether I should automatically strive exactly to fit my contents')
		(behaveLikeAHolderString	toggleBehaveLikeAHolder
			'whether auto-line-layout, resize-to-fit, and indicate-cursor should be set to true; useful for animation control, etc.')
		(isPartsBinString		toggleIsPartsBin
			'whether dragging an object from the interior should produce a COPY of the object')
		(isOpenForDragNDropString	toggleDragNDrop
			'whether objects can be dropped into and dragged out of me')
		(mouseOverHalosString	toggleMouseOverHalos
			'whether objects should put up halos when the mouse is over them')
		(autoExpansionString	toggleAutomaticPhraseExpansion
			'whether tile phrases, dropped on me, should automatically sprout Scriptors around them')
		(originAtCenterString	toggleOriginAtCenter
			'whether the cartesian origin of the playfield should be at its lower-left corner or at the center of the playfield')
		(showThumbnailString	toggleAlwaysShowThumbnail
			'whether large objects should be represented by thumbnail miniatures of themselves')
		(fenceEnabledString	toggleFenceEnabled
			'whether moving objects should stop at the edge of their container')
		(leftFenceEnabledString	toggleLeftFenceEnabled
			'whether moving objects should stop at the left edge of their container')
		(rightFenceEnabledString	toggleRightFenceEnabled
			'whether moving objects should stop at the right edge of their container')
		(topFenceEnabledString	toggleTopFenceEnabled
			'whether moving objects should stop at the top edge of their container')
		(bottomFenceEnabledString	toggleBottomFenceEnabled
			'whether moving objects should stop at the bottom edge of their container')
		(autoViewingString		toggleAutomaticViewing
			'governs whether, when an object is touched inside me, a viewer should automatically be launched for it.')
		(griddingString			griddingOnOff
			'whether gridding should be used in my interior')
		(gridVisibleString		gridVisibleOnOff
			'whether the grid should be shown when gridding is on')


	) do:

			[:triplet |
				(isWorld and: [#(toggleAutoLineLayout toggleIndicateCursor toggleIsPartsBin toggleAlwaysShowThumbnail toggleAutomaticViewing ) includes: triplet second]) ifFalse:
					[aMenu addUpdating: triplet first action: triplet second.
					aMenu balloonTextForLastItem: triplet third]]. 

	aMenu addLine.
	aMenu add: 'round up strays' action: #roundUpStrays.
	aMenu balloonTextForLastItem:  'Bring back all objects whose current coordinates keep them from being visible, so that at least a portion of each of my interior objects can be seen.'.
	aMenu add: 'shuffle contents' action: #shuffleSubmorphs.
	aMenu balloonTextForLastItem: 'Rearranges my contents in random order'.
	aMenu add: 'set grid spacing...' action: #setGridSpec.
	aMenu balloonTextForLastItem: 'Set the spacing to be used when gridding is on'.

	isWorld ifFalse:
		[aMenu add: 'set thumbnail height...' action: #setThumbnailHeight.
		aMenu balloonTextForLastItem: 'if currently showing thumbnails governs the standard height for them'].

	self backgroundSketch ifNotNil:
		[aMenu add: 'delete background painting' action: #deleteBackgroundPainting.
		aMenu balloonTextForLastItem: 'delete the graphic that forms the background for this me.'].
	aMenu addLine.
	self addPenTrailsMenuItemsTo: aMenu.
	aMenu addLine.
	aMenu add: 'use standard texture' action: #setStandardTexture.
	aMenu balloonTextForLastItem: 'use a pale yellow-and-blue background texture here.'.
	aMenu add: 'make graph paper...' action: #makeGraphPaper.
	aMenu balloonTextForLastItem: 'Design your own graph paper and use it as the background texture here.'.
	aMenu addTitle: 'viewing options for "', self externalName, '"'.

	aMenu popUpForHand: self activeHand in: self world
! !

!PasteUpMorph methodsFor: 'menu & halo' stamp: 'ka 12/18/2002 16:07'!
rightFenceEnabledString
	^ self rightFenceEnabled
		ifTrue: ['<on>right fence enabled']
		ifFalse: ['<off>right fence enabled']! !

!PasteUpMorph methodsFor: 'menu & halo' stamp: 'ka 12/18/2002 16:07'!
topFenceEnabledString
	^ self topFenceEnabled
		ifTrue: ['<on>top fence enabled']
		ifFalse: ['<off>top fence enabled']! !

!PasteUpMorph methodsFor: 'options' stamp: 'ka 12/18/2002 15:40'!
bottomFenceEnabled
	^ self
		valueOfProperty: #bottomFenceEnabled
		ifAbsent: [Preferences fenceEnabled]! !

!PasteUpMorph methodsFor: 'options' stamp: 'ka 12/18/2002 15:30'!
bottomFenceEnabled: aBoolean 
	self setProperty: #bottomFenceEnabled toValue: aBoolean! !

!PasteUpMorph methodsFor: 'options' stamp: 'ka 12/18/2002 15:36'!
fenceEnabled
	self leftFenceEnabled
		ifFalse: [^ false].
	self rightFenceEnabled
		ifFalse: [^ false].
	self topFenceEnabled
		ifFalse: [^ false].
	self bottomFenceEnabled
		ifFalse: [^ false].
	^ true! !

!PasteUpMorph methodsFor: 'options' stamp: 'ka 12/18/2002 15:31'!
fenceEnabled: aBoolean 
	self leftFenceEnabled: aBoolean.
	self rightFenceEnabled: aBoolean.
	self topFenceEnabled: aBoolean.
	self bottomFenceEnabled: aBoolean! !

!PasteUpMorph methodsFor: 'options' stamp: 'ka 12/18/2002 15:39'!
leftFenceEnabled
	^ self
		valueOfProperty: #leftFenceEnabled
		ifAbsent: [Preferences fenceEnabled]! !

!PasteUpMorph methodsFor: 'options' stamp: 'ka 12/18/2002 15:30'!
leftFenceEnabled: aBoolean 
	self setProperty: #leftFenceEnabled toValue: aBoolean! !

!PasteUpMorph methodsFor: 'options' stamp: 'ka 12/18/2002 15:39'!
rightFenceEnabled
	^ self
		valueOfProperty: #rightFenceEnabled
		ifAbsent: [Preferences fenceEnabled]! !

!PasteUpMorph methodsFor: 'options' stamp: 'ka 12/18/2002 15:30'!
rightFenceEnabled: aBoolean 
	self setProperty: #rightFenceEnabled toValue: aBoolean! !

!PasteUpMorph methodsFor: 'options' stamp: 'ka 12/18/2002 16:10'!
toggleBottomFenceEnabled
	self bottomFenceEnabled: self bottomFenceEnabled not! !

!PasteUpMorph methodsFor: 'options' stamp: 'ka 12/18/2002 16:09'!
toggleLeftFenceEnabled
	self leftFenceEnabled: self leftFenceEnabled not! !

!PasteUpMorph methodsFor: 'options' stamp: 'ka 12/18/2002 16:10'!
toggleRightFenceEnabled
	self rightFenceEnabled: self rightFenceEnabled not! !

!PasteUpMorph methodsFor: 'options' stamp: 'ka 12/18/2002 16:10'!
toggleTopFenceEnabled
	self topFenceEnabled: self topFenceEnabled not! !

!PasteUpMorph methodsFor: 'options' stamp: 'ka 12/18/2002 15:39'!
topFenceEnabled
	^ self
		valueOfProperty: #topFenceEnabled
		ifAbsent: [Preferences fenceEnabled]! !

!PasteUpMorph methodsFor: 'options' stamp: 'ka 12/18/2002 15:30'!
topFenceEnabled: aBoolean 
	self setProperty: #topFenceEnabled toValue: aBoolean! !


!PhraseTileMorph methodsFor: 'dropping/grabbing' stamp: 'ns 10/3/2002 15:58'!
aboutToBeGrabbedBy: aHand 
	super aboutToBeGrabbedBy: aHand.
	self formerOwner: nil.
	self formerPosition: nil.
	self removeProperty: #undoGrabCommand.
	"CommandHistory resetAllHistory"! !


!Player methodsFor: 'costume' stamp: 'kuri-t 12/17/2002 15:36'!
wearCostumeOf: anotherPlayer
	"Put on a costume similar to the one currently worn by anotherPlayer"

	| targetMorph anotherPlayerCostumeState |
	anotherPlayerCostumeState _ anotherPlayer costume costumeState.
	targetMorph _ SketchMorph withForm: anotherPlayerCostumeState imageForm.
	targetMorph copyCostumeStateFrom: anotherPlayerCostumeState.
	targetMorph extension instVarNamed: 'identifier' put: costume identifier.
	costume extension instVarNamed: 'identifier' put: nil.
	self renderedCostume: targetMorph remember: anotherPlayerCostumeState shouldRememberCostumes! !

!Player methodsFor: 'heading'!
head: aSymbol 
	aSymbol == #up
		ifTrue: [^ self headUp].
	aSymbol == #down
		ifTrue: [^ self headDown].
	aSymbol == #left
		ifTrue: [^ self headLeft].
	aSymbol == #right
		ifTrue: [^ self headRight]! !

!Player methodsFor: 'name' stamp: 'ka 9/25/2002 18:33'!
uniqueNameForReference
	"Answer a unique name for referring to the receiver"

	"| itsReferent |
	self flag: #deferred.  ""The once-and-maybe-future ObjectRepresentativeMorph scheme is for the moment disenfranchised""

	""(costume isKindOf: ObjectRepresentativeMorph) ifTrue:
		[((itsReferent _ costume objectRepresented) isKindOf: Class)
			ifTrue:
				[^ itsReferent name].
		itsReferent == Smalltalk ifTrue: [^ #Smalltalk].
		itsReferent == ScriptingSystem ifTrue: [^ #ScriptingSystem]].""

	^  super uniqueNameForReference"

	^ '(Player fromUUIDString: ', self costume renderedMorph identifier asString printString, ')'

! !

!Player methodsFor: 'slot getters/setters' stamp: 'kuri-t 2/6/2003 12:27'!
setHeading: newHeading
	"Set the heading as indicated"

	| aCostume |
	aCostume _ self costume.
	(newHeading closeTo: aCostume heading) ifTrue: [^ self].
	aCostume heading: newHeading.
	aCostume _ self costume. "in case we just got flexed for no apparent reason"
! !

!Player methodsFor: 'slot getters/setters' stamp: 'kuri-t 1/27/2003 18:36'!
setScaleFactor: aNumber
	"Set the scale factor to be the given value"

	| aCostume |
	aCostume _ self costume.
	aCostume isFlexMorph ifFalse: [aCostume addFlexShell].
	costume scale: ((aNumber asFloat max: 0.1) min: 10.0)! !

!Player methodsFor: 'scripts-execution'!
runAllWarpedInScripts
	"Run all the receiver's scripts marked as #warpedIn. Return a 
	boolean indicating whether any such scripts were encountered 
	and run"

	| any |
	any _ false.
	self
		instantiatedUserScriptsDo: [:aScriptInstantiation | aScriptInstantiation runIfWarpedIn
				ifTrue: [any _ true]].
	^ any! !

!Player methodsFor: 'scripts-execution'!
runAllWarpingOutScripts
	"Run all the receiver's scripts marked as #warpingOut. Return a 
	boolean indicating whether any such scripts were encountered 
	and run"

	| any |
	any _ false.
	self
		instantiatedUserScriptsDo: [:aScriptInstantiation | aScriptInstantiation runIfWarpingOut
				ifTrue: [any _ true]].
	^ any! !

!Player methodsFor: 'scripts-standard' stamp: 'ka 12/18/2002 16:37'!
forward: dist 
	"Move forward (viz. in the direction of my heading) by the given 
	amount "
	| rho radians delta didStray p aCostume aPlayfield |
	(aCostume _ self costume) isInWorld
		ifFalse: [^ self].
	aCostume isWorldOrHandMorph
		ifTrue: [^ self].
	aCostume owner isHandMorph
		ifTrue: [^ self].
	rho _ (aCostume asNumber: dist) asFloat.
	radians _ (self getHeadingUnrounded asFloat - 90.0) degreesToRadians.
	delta _ radians cos @ radians sin * rho.
	aPlayfield _ aCostume pasteUpMorph.
	didStray _ false.
	aPlayfield leftFenceEnabled
		ifTrue: [(aCostume left < aPlayfield left
					and: [delta x < 0])
				ifTrue: [delta _ delta x negated @ delta y.
					didStray _ true]].
	aPlayfield rightFenceEnabled
		ifTrue: [(aCostume right > aPlayfield right
					and: [delta x > 0])
				ifTrue: [delta _ delta x negated @ delta y.
					didStray _ true]].
	aPlayfield topFenceEnabled
		ifTrue: [(aCostume top < aPlayfield top
					and: [delta y < 0])
				ifTrue: [delta _ delta x @ delta y negated.
					didStray _ true]].
	aPlayfield bottomFenceEnabled
		ifTrue: [(aCostume bottom > aPlayfield bottom
					and: [delta y > 0])
				ifTrue: [delta _ delta x @ delta y negated.
					didStray _ true]].
	(didStray
			and: [Preferences fenceSoundEnabled])
		ifTrue: [aCostume makeFenceSound].
	"use and record the fractional position"
	p _ aCostume referencePosition + delta.
	aCostume referencePosition: p! !

!Player methodsFor: 'scripts-standard' stamp: 'mu 4/16/2003 02:05'!
moveToward: aPlayer 
	"Move a standard amount in the direction of the given player. If  
	the object has an instance variable named 'speed', the speed of  
	the motion will be governed by that value"
	| angle myCostume otherCostume deltaPoint toPoint |
	(aPlayer == nil
			or: [aPlayer == self])
		ifTrue: [^ self].
	myCostume _ self costume.
	otherCostume _ aPlayer costume.
	toPoint _ otherCostume currentPointInTheMap.
	myCostume currentPointInTheMap = toPoint
		ifTrue: [(myCostume rendererBounds intersects: otherCostume rendererBounds)
				ifTrue: [^ self]].
	deltaPoint _ NmWorldMap deltaPointTo: toPoint.
	angle _ myCostume referencePosition bearingToPoint: otherCostume rendererReferencePosition + deltaPoint.
	self setHeading: angle.
	self forward: self getSpeed! !

!Player methodsFor: 'misc' stamp: 'sw 11/28/2000 11:05'!
goToRightOf: aPlayer
	"Place the object so that it lies directly to the right of the given object"

	| hisCostume aCostume |
	(aPlayer == nil or: [aPlayer == self]) ifTrue: [^ self].
	(hisCostume _ aPlayer costume) isInWorld ifFalse: [^ self].
	((aCostume _ self costume) owner == hisCostume owner) ifFalse:
		[hisCostume owner addMorphFront: aCostume].
	aCostume position:
		(hisCostume bounds rightCenter - (0 @ (aCostume height // 2)))! !

!Player methodsFor: 'misc' stamp: 'kuri-t 12/13/2002 14:13'!
nearTo: anotherPlayer 
	| envelope myBounds trueNeighbor trueGoal trueSelf |
	anotherPlayer
		ifNil: [^ false].
	envelope _ costume owner
				ifNil: [^ false].
	myBounds _ costume bounds.
	trueSelf _ costume renderedMorph.
	trueGoal _ anotherPlayer costume renderedMorph.
	envelope submorphs
		do: [:each | 
			trueNeighbor _ each renderedMorph.
			(trueNeighbor == trueGoal
					and: [trueNeighbor ~~ trueSelf])
				ifTrue: [(myBounds intersects: each bounds)
						ifTrue: [^ true]]].
	^ false! !

!Player methodsFor: 'slots-NetMorph' stamp: 'ka 1/15/2003 17:45'!
getAddress
	^ self costume renderedMorph address shortPrintString! !

!Player methodsFor: 'slots-NetMorph' stamp: 'ns 9/17/2002 15:57'!
getAuthority
	^ self costume renderedMorph url authority asString! !

!Player methodsFor: 'slots-NetMorph' stamp: 'ka 1/15/2003 17:45'!
getHome
	^ self costume renderedMorph home shortPrintString! !

!Player methodsFor: 'slots-NetMorph'!
getIdentifier
	^ self costume renderedMorph identifier! !

!Player methodsFor: 'scripts-NetMorph'!
effects: effectString 
	self costume perform: effectString asSymbol! !

!Player methodsFor: 'scripts-NetMorph'!
warp
	self costume warp! !

!Player methodsFor: 'scripts-NetMorph' stamp: 'kuri-t 1/10/2003 16:01'!
warp: warpType
	self costume warp: warpType asSymbol! !

!Player methodsFor: 'scripts-NetMorph' stamp: 'kuri-t 1/28/2003 10:59'!
warpTo: address 
	| addressString protcolId destination |
	protcolId _ NmUrl protcolIdentifier , '://'.
	addressString _ (address asLowercase beginsWith: protcolId)
				ifTrue: [address]
				ifFalse: [protcolId , address].
	destination _ addressString asUrl.
	destination = NmUrl local
		ifFalse: [self costume warpTo: destination]! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 11:36'!
getFragment
	^ self costume renderedMorph url fragment! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 10/8/2002 15:57'!
getIpAddress
	^ self costume renderedMorph url ipAddress! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 11:58'!
getPath
	| collection stream |
	collection _ self costume renderedMorph url path.
	stream _ WriteStream on: '/'.
	collection
		do: [:each | stream nextPutAll: '/' , each].
	^ stream contents! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 11:36'!
getPort
	^ self costume renderedMorph url port! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 11:36'!
getQuery
	^ self costume renderedMorph url query! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 11:36'!
getRealm
	^ self costume renderedMorph url realm! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 11:36'!
getScheme
	^ self costume renderedMorph url schemeName! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 11:36'!
getUrl
	^ self costume renderedMorph url toText! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 11:36'!
privateSetUrl: anUrl 
	^ self costume renderedMorph url: anUrl! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 11:35'!
setAuthority: aValue 
	| url port authority |
	url _ self costume renderedMorph url.
	port _ url port isNil
				ifTrue: [NmSettings port asString]
				ifFalse: [url port asString].
	authority _ aValue.
	^ self privateSetUrl: (NmUrl protcolIdentifier , '://' , authority , ':' , port) asUrl! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 11:35'!
setFragment: newFragment 
	| newUrl |
	newUrl _ self costume renderedMorph url.
	newUrl withFragment: newFragment.
	^ self privateSetUrl: newUrl! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 11:48'!
setPath: pathString 
	| path newUrl |
	path _ pathString findTokens: $/.
	path isEmpty
		ifTrue: [path _ #('/' ) asOrderedCollection].
	newUrl _ self costume renderedMorph url.
	newUrl
		schemeName: newUrl schemeName
		authority: newUrl authority
		path: path asArray
		query: newUrl query.
	^ self privateSetUrl: newUrl! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 12:16'!
setPort: aNumber 
	| newUrl |
	newUrl _ self costume renderedMorph url.
	newUrl instVarNamed: #port put: aNumber.
	^ self privateSetUrl: newUrl! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 11:35'!
setQuery: aQuery 
	| newUrl |
	newUrl _ self costume renderedMorph url.
	newUrl
		schemeName: newUrl schemeName
		authority: newUrl authority
		path: newUrl path
		query: aQuery.
	^ self privateSetUrl: newUrl! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 11:35'!
setRealm: aValue 
	| newUrl |
	newUrl _ self costume renderedMorph url.
	newUrl instVarNamed: #realm put: aValue.
	^ self privateSetUrl: newUrl! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 11:35'!
setScheme: schemeName 
	| newUrl |
	newUrl _ self costume renderedMorph url.
	newUrl
		schemeName: "schemeName" 'nm'
		authority: newUrl authority
		path: newUrl path
		query: newUrl query.
	^ self privateSetUrl: newUrl! !

!Player methodsFor: 'slots-NetMorph-url' stamp: 'ns 9/20/2002 11:35'!
setUrl: aValue 
	| newUrl |
	newUrl _ (aValue notNil
					and: [aValue isEmpty not])
				ifTrue: [aValue asUrl]
				ifFalse: [NmUrl new].
	^ self privateSetUrl: newUrl! !

!Player methodsFor: 'NetMorph converting' stamp: 'kuri-t 12/13/2002 15:21'!
asProxy
	^ NmPlayerProxy on: self! !

!Player methodsFor: 'NetMorph testing' stamp: 'kuri-t 12/13/2002 15:03'!
shouldPassAsProxy
	^ true.! !

!Player methodsFor: 'message handling' stamp: 'mu 4/11/2003 16:11'!
perform: selector 
	[^ super perform: selector]
		on: NmNoSuchMorph
		do: [:ex | NmpObject crShow: '##Dispatch was failed and find was also failed...'.
			self stopProgramatically.
			self costume showBalloon: ex messageText asString]! !


!Player class methodsFor: 'instance creation'!
fromUUIDString: anUUIDString 
	| morph |
	morph _ Morph fromUUIDString: anUUIDString.
	morph isNil
		ifTrue: [^ nil].
	^ morph player! !


!PluggableTextMorph methodsFor: 'model access' stamp: 'ka 2/25/2003 18:37'!
getText
	"Retrieve the current model text"
	| newText modelValue |
	getTextSelector == nil
		ifTrue: [^ Text new].
	modelValue _ model perform: getTextSelector.
	newText _ (modelValue respondsTo: #asText)
				ifTrue: [modelValue asText]
				ifFalse: [modelValue asString asText].
	^ newText shallowCopy! !


!Point methodsFor: 'printing'!
storeOn: aStream 
	"x@y printed form is good for storing too"
	aStream nextPut: $(.
	self printOn: aStream.
	aStream nextPut: $)! !


!PolygonMorph methodsFor: 'halo control'!
addFlexShellIfNecessary
	^ super addFlexShellIfNecessary! !

!PolygonMorph methodsFor: 'halo control'!
heading: newHeading 
	super heading: newHeading! !


!Presenter methodsFor: 'viewer' stamp: 'kuri-t 1/9/2003 14:17'!
viewMorph: aMorph
	| aPlayer aViewer aPalette aRect aPoint nominalHeight aFlapTab topItem flapLoc |
	Sensor leftShiftDown ifFalse:
		[((aPalette _ aMorph standardPalette) ~~ nil and: [aPalette isInWorld])
			ifTrue:	[^ aPalette viewMorph: aMorph]].

	aPlayer _ (topItem _ aMorph topRendererOrSelf) assuredPlayer.
	topItem isFlexMorph ifTrue: [topItem renderedMorph player: aPlayer].
	aViewer _ self nascentPartsViewer.
	self cacheSpecs: topItem.		"redo the spec cache once in a while"

	"19 sept 2000 - allow flaps in any paste up"
	flapLoc _ associatedMorph "world".
	Preferences viewersInFlaps ifTrue:
		[aViewer setProperty: #noInteriorThumbnail toValue: true.
		aViewer initializeFor: aPlayer barHeight: 0.
		aViewer enforceTileColorPolicy.
		aViewer fullBounds. "force layout"
		"associatedMorph addMorph: aViewer."		"why???"
		flapLoc hideViewerFlapsOtherThanFor: aPlayer.
		aFlapTab _ flapLoc viewerFlapTabFor: topItem.
		aFlapTab referent submorphs do: 
			[:m | (m isKindOf: Viewer) ifTrue: [m delete]].

		aViewer visible: true.
		aFlapTab applyThickness: aViewer width + 25.
		aFlapTab spanWorld.
		aFlapTab showFlap. 
		aViewer position: aFlapTab referent position.
		aFlapTab referent addMorph: aViewer beSticky.		"moved"
		flapLoc startSteppingSubmorphsOf: aFlapTab.
		flapLoc startSteppingSubmorphsOf: aViewer.
		^ aFlapTab].
		
	aViewer initializeFor: aPlayer barHeight: 6.
	aViewer enforceTileColorPolicy.
	aViewer fullBounds. "force layout"
	Preferences automaticViewerPlacement ifTrue:
		[aPoint _ aMorph bounds right @ 
			(aMorph center y - ((nominalHeight _ aViewer initialHeightToAllow) // 2)).
		aRect _ (aPoint extent: (aViewer width @ nominalHeight)) translatedToBeWithin: flapLoc bounds.
		aViewer position: aRect topLeft.
		aViewer visible: true.
		associatedMorph addMorph: aViewer.
		flapLoc startSteppingSubmorphsOf: aViewer.
		"it's already in the world, somewhat coincidentally"
		^ aViewer].
	aMorph primaryHand attachMorph: (aViewer visible: true).
	^ aViewer! !

!Presenter methodsFor: 'playerList' stamp: 'mu 12/25/2002 19:38'!
allExtantPlayers
	"The initial intent here was to produce a list of Player objects associated with any Morph in the tree beneath the receiver's associatedMorph.  whether it is the submorph tree or perhaps off on unseen bookPages.  We have for the moment moved away from that initial intent, and in the current version we only deliver up players associated with the submorph tree only.

Call #flushPlayerListCache to force recomputation."

	playerList ifNotNil:
		[^ playerList].

	^ playerList _ (associatedMorph allMorphs select: 
		[:m | m player ~~ nil and: [m player isProxy not]] thenCollect: [:m | m player]) asSet asArray! !


!Project methodsFor: 'menu messages' stamp: 'ka 10/21/2002 20:25'!
enter
	"Enter the new project"
	self enter: (CurrentProject parent == self) revert: false saveForRevert: false.! !


!Project class methodsFor: 'instance creation' stamp: 'RAA 11/16/2000 12:08'!
newMorphicOn: aPasteUpOrNil

	| newProject |

	newProject _ self basicNew initMorphic.
	self addingProject: newProject.
	aPasteUpOrNil ifNotNil: [newProject installPasteUpAsWorld: aPasteUpOrNil].
	newProject createViewIfAppropriate.
	^newProject
! !

!Project class methodsFor: 'squeaklet on server' stamp: 'RAA 2/19/2001 07:37'!
squeakletDirectory

	| squeakletDirectoryName |
	squeakletDirectoryName _ 'Squeaklets'.
	(FileDirectory default directoryExists: squeakletDirectoryName) ifFalse: [
		FileDirectory default createDirectory: squeakletDirectoryName
	].
	^FileDirectory default directoryNamed: squeakletDirectoryName! !


!ProjectEntryNotification methodsFor: 'as yet unclassified' stamp: 'ka 10/21/2002 20:28'!
defaultAction
	projectToEnter world reinstallAllScripts.
	self resume: projectToEnter enter! !


!ProjectLoading class methodsFor: 'as yet unclassified' stamp: 'tk 12/14/2001 10:36'!
openName: aFileName stream: preStream fromDirectory: aDirectoryOrNil withProjectView: existingView
	"Reconstitute a Morph from the selected file, presumed to be represent a Morph saved via the SmartRefStream mechanism, and open it in an appropriate Morphic world."
 	| morphOrList proj trusted localDir projStream archive mgr projectsToBeDeleted baseChangeSet |
	(preStream isNil or: [preStream size = 0]) ifTrue: [
		ProgressNotification  signal: '9999 about to enter project'.		"the hard part is over"
		^self inform: 
'It looks like a problem occurred while
getting this project. It may be temporary,
so you may want to try again,'
	].
	ProgressNotification signal: '2:fileSizeDetermined ',preStream size printString.
	preStream isZipArchive 
		ifTrue:[	archive _ ZipArchive new readFrom: preStream.
				projStream _ self projectStreamFromArchive: archive]
		ifFalse:[projStream _ preStream].
	trusted _ SecurityManager default positionToSecureContentsOf: projStream.
	trusted ifFalse:[(SecurityManager default enterRestrictedMode) ifFalse:[
		(preStream respondsTo: #close) ifTrue:[preStream close].
		^self]].

	localDir _ Project squeakletDirectory.
	aFileName ifNotNil: [
		(aDirectoryOrNil isNil or: [aDirectoryOrNil pathName ~= localDir pathName]) ifTrue: [
			localDir deleteFileNamed: aFileName.
			(localDir fileNamed: aFileName) 
				nextPutAll: preStream contents;
				close.
		].
	].
	morphOrList _ projStream asUnZippedStream.
	preStream sleep.		"if ftp, let the connection close"
	ProgressNotification  signal: '3:unzipped'.
	ResourceCollector current: ResourceCollector new.
	baseChangeSet _ Smalltalk changes.
	self useTempChangeSet.		"named zzTemp"
	"The actual reading happens here"
	[morphOrList _ morphOrList fileInObjectAndCode] ensure: [
				Smalltalk newChanges: baseChangeSet].
	mgr _ ResourceManager new initializeFrom: ResourceCollector current.
	mgr registerUnloadedResources.
	archive ifNotNil:[mgr preLoadFromArchive: archive cacheName: aFileName].
	(preStream respondsTo: #close) ifTrue:[preStream close].
	ResourceCollector current: nil.
	ProgressNotification  signal: '4:filedIn'.
	ProgressNotification  signal: '9999 about to enter project'.		"the hard part is over"
	(morphOrList isKindOf: ImageSegment) ifTrue: [
		proj _ morphOrList arrayOfRoots 
			detect: [:mm | mm class == Project] 
			ifNone: [^self inform: 'No project found in this file'].
		proj resourceManager: mgr.
		proj versionFrom: preStream.
		proj lastDirectory: aDirectoryOrNil.
		CurrentProjectRefactoring currentBeParentTo: proj.
		projectsToBeDeleted _ OrderedCollection new.
		existingView ifNil: [
			Smalltalk isMorphic ifTrue: [
				proj createViewIfAppropriate.
			] ifFalse: [
				ChangeSorter allChangeSets add: proj changeSet.
				ProjectView openAndEnter: proj.
				"Note: in MVC we get no further than the above"
			].
		] ifNotNil: [
			(existingView project isKindOf: DiskProxy) ifFalse: [
				existingView project changeSet name: ChangeSet defaultName.
				projectsToBeDeleted add: existingView project.
			].
			(existingView owner isKindOf: SystemWindow) ifTrue: [
				existingView owner model: proj
			].
			existingView project: proj.
		].
		ChangeSorter allChangeSets add: proj changeSet.
		Project current projectParameters 
			at: #deleteWhenEnteringNewProject 
			ifPresent: [ :ignored | 
				projectsToBeDeleted add: Project current.
				Project current removeParameter: #deleteWhenEnteringNewProject.
			].
		projectsToBeDeleted isEmpty ifFalse: [
			proj projectParameters 
				at: #projectsToBeDeleted 
				put: projectsToBeDeleted.
		].
		^ ProjectEntryNotification signal: proj
	].

	(morphOrList isKindOf: SqueakPage) ifTrue: [
		morphOrList _ morphOrList contentsMorph
	].
	(morphOrList isKindOf: PasteUpMorph) ifFalse: [
		^ self inform: 'This is not a PasteUpMorph or exported Project.'
	].
	(Project newMorphicOn: morphOrList) enter
! !


!ResourceCollector methodsFor: 'resource writing' stamp: 'ns 1/9/2003 11:30'!
writeResourceForm: aForm locator: aLocator
	"Store the given form on a file. Return an array with the name and the size of the file"
	| fName fStream fullSize result |
	aLocator ifNotNil:[
		result _ self writeResourceForm: aForm fromLocator: aLocator.
		result ifNotNil:[^result]
		"else fall through"
	].
	fName _ localDirectory nextNameFor:'resource' extension:'form'.
	fStream _ localDirectory newFileNamed: fName.
	fStream binary.
	"aForm storeResourceOn: fStream."
	(self writerClassFor: aForm)
		putForm: aForm
		onStream: fStream.
	fStream open.
	fullSize _ fStream size.
	fStream close.

	"Compress contents here"
"		fStream position: 0.
		fStream compressFile.
		localDirectory deleteFileNamed: fName.
		localDirectory rename: fName, FileDirectory dot, 'gz' toBe: fName.
		fStream _ localDirectory readOnlyFileNamed: fName.
		fullSize _ fStream size.
		fStream close.
"
	^{fName. fullSize}! !

!ResourceCollector methodsFor: 'private' stamp: 'ns 1/15/2003 15:12'!
writerClassFor: aForm 
	| writerClass |
	writerClass _ aForm colorsUsed size < 256
				ifTrue: [GIFReadWriter]
				ifFalse: [(aForm colorsUsed includes: Color transparent)
						ifTrue: [aForm class]
						ifFalse: [| tmpForm | 
							tmpForm _ Form
										extent: aForm extent
										depth: aForm depth
										bits: aForm bits copy.
							tmpForm hibernate bits byteSize * 5 < aForm bits byteSize
								ifTrue: [aForm class]
								ifFalse: [JPEGReadWriter2 new isPluginPresent
										ifTrue: [JPEGReadWriter2]
										ifFalse: [aForm class]]]].
	^ writerClass! !


!ResourceManager methodsFor: 'loading' stamp: 'ns 1/15/2003 11:59'!
preLoadFromArchive: aZipArchive cacheName: aFileName
	"Load the resources from the given zip archive"
	| orig nameMap resMap loc stream |
	self class reloadCachedResources.
	resMap _ Dictionary new.
	nameMap _ Dictionary new.
	unloaded do:[:locator|
		locator localFileName: nil.
		nameMap at: locator urlString put: locator.
		resMap at: locator urlString put: (resourceMap at: locator)].

	aZipArchive members do:[:entry|
		| filename | 
		stream _ nil.
		"see the comment of ZipArchiveMember>>fileName:"
		"Browser fullOnClass: ZipArchiveMember selector: #fileName:."
		filename _ entry fileName copyReplaceAll: FileDirectory slash with: UnixFileDirectory pathNameDelimiter asString.
		orig _ resMap at: filename ifAbsent:[nil].
		loc _ nameMap at: filename ifAbsent:[nil].
		"note: orig and loc may be nil for non-resource members"
		(orig notNil and:[loc notNil]) ifTrue:[
			stream _ entry contentStream.
			self installResource: orig from: stream locator: loc.
			stream reset.
			aFileName 
				ifNil:[self class cacheResource: loc urlString stream: stream]
				ifNotNil:[self class cacheResource: loc urlString inArchive: aFileName]].
	].! !


!ScriptEditorMorph methodsFor: 'other' stamp: 'kuri-t 2/7/2003 16:50'!
methodString
	"Answer the source-code string for the receiver.  This is for use by classic tiles, but is also used in universal tiles to formulate an initial method declaration for a nascent user-defined script; in universalTiles mode, the codeString (at present anyway) is empty -- the actual code derives from the SyntaxMorph in that case"

	^ String streamContents:
		[:aStream |
			aStream nextPutAll: scriptName; cr; cr; tab.
			aStream nextPutAll: '['.
			aStream nextPutAll: self codeString.
			aStream nextPutAll: '] on: MessageNotUnderstood, NmWarpedOutNotification do: []']
! !

!ScriptEditorMorph methodsFor: 'NetMorph serializing' stamp: 'kuri-t 12/10/2002 14:45'!
prepareForWarp
	(self allMorphs
		select: [:morph | morph shouldPrepareForWarp])
		do: [:each | each prepareForWarp]! !

!ScriptEditorMorph methodsFor: 'NetMorph testing' stamp: 'kuri-t 12/10/2002 14:44'!
shouldPrepareForWarp
	^ false! !


!ScriptInstantiation methodsFor: 'running' stamp: 'mu 4/11/2003 16:12'!
runIfTicking: nowTick 
	| ticks rate |
	status == #ticking
		ifFalse: [^ self].
	rate _ self tickingRate.
	(lastTick == nil
			or: [nowTick < lastTick])
		ifTrue: [lastTick _ nowTick.
			ticks _ 1]
		ifFalse: [ticks _ (nowTick - lastTick * rate / 1000) asInteger].
	ticks <= 0
		ifTrue: [^ self].
	"Scripts which have been out of the world and then return can  
	
	have a huge number of ticks accumulated. A better fix would  
	
	be to reset <lastTick> when a script leaves/enters the world.  
	
	Also, if the system is falling behind, this attempt to catch up  
	
	can result in falling further behind, leading to sluggish behavior 
	
	and termination of ticking status. Whether the user really  
	
	wants this catch up behavior needs to be determined (often 
	she  
	
	will not, I suspect) and better ways of doing it need to be  
	
	found"
	ticks _ 1.
	"Who did it?"
	[1
		to: ticks * self frequency
		do: [:i | NmProcessManager
				process: [player perform: selector]
				for: self]]
		on: NmNoSubmorphs
		do: [:ex | NmpObject crShow: '##No submorphs'].
	lastTick _ nowTick.
	ticks > 10
		ifTrue: ["check if we're lagging behind"
			ticks <= (Time millisecondClockValue - lastTick * rate / 1000) asInteger
				ifTrue: ["e.g., time to run script is higher than number of  
					
					ticks"
					self status: #paused.
					self updateAllStatusMorphs]]! !

!ScriptInstantiation methodsFor: 'running'!
runIfWarpedIn
	| result |
	(result _ status == #warpedIn)
		ifTrue: [player perform: selector].
	^ result! !

!ScriptInstantiation methodsFor: 'running'!
runIfWarpingOut
	| result |
	(result _ status == #warpingOut)
		ifTrue: [player perform: selector].
	^ result! !

!ScriptInstantiation methodsFor: 'status control'!
presentScriptStatusPopUp
	"Put up a menu of status alternatives and carry out the request"

	| aMenu reply standardStati  m |
	"NB; the keyStroke branch commented out temporarily until keystrokes can actually be passed along to the user's scripting code"

	standardStati _ #(normal paused ticking mouseDown mouseStillDown mouseUp mouseEnter mouseLeave mouseEnterDragging mouseLeaveDragging opening closing "keyStroke" warpingOut warpedIn).
	aMenu _ SelectionMenu labelList:  #(
		'normal'		" -- run when called"		
		'paused' 		"ready to run all the time"
		'ticking'		"run all the time"
		'mouseDown'	"run when mouse goes down on me"
		'mouseStillDown'	"while mouse still down"
		'mouseUp'		"when mouse comes back up"
		'mouseEnter'	"when mouse enters my bounds, button up"
		'mouseLeave'	"when mouse exits my bounds, button up"
		'mouseEnterDragging'	"when mouse enters my bounds, button down"
		'mouseLeaveDragging'	"when mouse exits my bounds, button down"
		'opening'	"when I am being opened"
		'closing'	"when I am being closed"
		'warpingOut'	"when I am warping out"
		'warpedIn'	"when I am being warped in"
	"	'keyStroke'	run when user hits a key"
		'what do these mean?'
		'apply my status to all siblings'
		)
		lines: #(1 3 6 10 12 14 15)
		selections: (standardStati, #(explainStatusAlternatives assignStatusToAllSiblings)).

	reply _ aMenu startUpWithCaption: 'When should this script run?'.
	(reply == #keyStroke) ifTrue: [^ self inform: 'user-scripted fielding
of keystrokes is not
yet available.'].

	reply == #explainStatusAlternatives ifTrue: [^ self explainStatusAlternatives].
	reply == #assignStatusToAllSiblings ifTrue: [^ self assignStatusToAllSiblings].
	reply ifNotNil: 
		[self status: reply.  "Gets event handlers fixed up"
		reply == #paused ifTrue:
			[m _ player costume.
			(m isKindOf: SpeakerMorph) ifTrue: [m stopSound]].
		self updateAllStatusMorphs]! !


!SmartRefStream methodsFor: 'read write'!
nextPut: anObject 
	"Really write three objects: (version, class structure, object). But  
	only when called from the outside. If any instance-specific  
	classes are present, prepend their source code. byteStream will  
	be in fileOut format.  
	You can see an analysis of which objects are written out by  
	doing:  
	(SmartRefStream statsOfSubObjects: anObject)  
	(SmartRefStream tallyOfSubObjects: anObject)  
	(SmartRefStream subObjects: anObject ofClass: aClass)"
	| info during |
	topCall == nil
		ifTrue: [topCall _ anObject.
			during _ [:bar | info _ self instVarInfo: anObject].
			self isDisplayProgress
				ifTrue: ['Please wait while objects are counted'
						displayProgressAt: Sensor cursorPoint
						from: 0
						to: 10
						during: during]
				ifFalse: [during value: nil].
			self appendClassDefns.
			"For instance-specific classes"
			during _ [:bar | 
					"estimate"
					objCount _ 0.
					progressBar _ bar.
					self setStream: byteStream reading: false.
					"set basePos, but keep any class renames"
					super nextPut: ReferenceStream versionCode.
					super nextPut: info.
					super nextPut: anObject.
					"<- the real writing"
					classInstVars size > 0
						ifTrue: [super nextPut: classInstVars]].
			self isDisplayProgress
				ifTrue: ['Writing an object file'
						displayProgressAt: Sensor cursorPoint
						from: 0
						to: objCount * 4
						during: during]
				ifFalse: [during value: nil].
			"Note: the terminator, $!!, is not doubled inside object  
			data"
			"references is an IDict of every object that got written"
			byteStream ascii.
			byteStream nextPutAll: '!!';
				 cr;
				 cr.
			byteStream padToEndWith: $ .
			"really want to truncate file, but can't"
			topCall _ progressBar _ nil
			"reset it"]
		ifFalse: [super nextPut: anObject.
			progressBar
				ifNotNil: [progressBar value: (objCount _ objCount + 1)]]! !

!SmartRefStream methodsFor: 'read write' stamp: 'ka 10/17/2002 19:36'!
scanFrom: aByteStream logged: logFlag 
	self setStream: aByteStream reading: true.
	ScannedObject _ self next.
	byteStream ascii.
	byteStream next == $!!
		ifFalse: [byteStream close.
			self error: 'Object did not end correctly']! !

!SmartRefStream methodsFor: 'accessing'!
isDisplayProgress
	DisplayProgress isNil
		ifTrue: [DisplayProgress _ true].
	^ DisplayProgress! !

!SmartRefStream methodsFor: 'accessing'!
isDisplayProgress: boolean 
	DisplayProgress _ boolean ~~ false! !


!StandardScriptingSystem methodsFor: 'font & color choices'!
statusColorSymbolFor: statusSymbol
	#(	(normal				green)
		(ticking				blue)
		(paused				red)
		(mouseDown			yellow)
		(mouseStillDown		lightYellow)
		(mouseUp				lightBlue)
		(mouseEnter			lightBrown)
		(mouseLeave			lightRed)
		(mouseEnterDragging	lightGray)
		(mouseLeaveDragging	darkGray)
		(keyStroke				lightGreen)
		(warpingOut			magenta)
		(warpedIn				magenta)) do:

			[:pair | statusSymbol == pair first ifTrue: [^ pair second]].

		^ #blue! !

!StandardScriptingSystem methodsFor: 'utilities' stamp: 'kuri-t 1/10/2003 15:56'!
wordingForOperator: aString
	"Answer the wording to be seen by the user for the given operator symbol/string"

	| toTest |
	toTest _ aString asString.
	#(	(append:				'append')
		(beep:					'make sound')
		(bounce:				'bounce')
		(clearTurtleTrails		'clear pen trails')
		(clearOwnersPenTrails	'clear all pen trails')
		(colorSees				'color  sees')
		(color:sees:				'color sees')
		(doMenuItem:			'do menu item')
		(doScript:				'do')
		(forward:				'forward by')
		(moveToward:			'move toward')
		(goToRightOf:			'align after')
		(include:				'include')
		(isDivisibleBy:			'is divisible by')
		(liftAllPens				'lift all pens')
		(lowerAllPens			'lower all pens')
		(arrowheadsOnAllPens	'arrowheads on all pens')
		(noArrowheadsOnAllPens	'no arrowheads on pens')
		(pauseAll:				'pause all')
		(pauseScript:			'pause script')
		(max:					'max')
		(min:					'min')
		(seesColor:				'is over color')
		(makeNewDrawingIn:	'start painting in')
		(prepend:				'prepend')
		(startAll:				'start all')
		(startScript:				'start script')
		(stopProgramatically	'stop')
		(stopAll:					'stop all')
		(stopScript:				'stop script')
		(tellAllSiblings:			'tell all')
		(turn:					'turn by')
		(wearCostumeOf:		'look like')

		(warp:					'warp')
		(warpTo:				'warp to')
		(isTouched				'near to')
		(head:					'head')
		(effects:				'effect'))

	do:
		[:pair | toTest = pair first ifTrue: [^ pair second]].

	^ toTest

	"StandardScriptingSystem initialize"

! !


!Symbol methodsFor: 'printing' stamp: 'ka 1/15/2003 19:03'!
storeOn: aStream 
	aStream nextPut: $#.
	(Scanner isLiteralSymbol: self)
		ifFalse: [^ super storeOn: aStream].
	(self includes: $:)
		ifTrue: [^ super storeOn: aStream].
	aStream nextPutAll: self! !


!SymbolListType methodsFor: 'tiles' stamp: 'ka 1/15/2003 16:07'!
defaultArgumentTile
	"Answer a tile to represent the type"
	| aTile |
	aTile _ NmSymbolListTile new
				model: self
				getChoicesSelector: #choices
				dataType: self vocabularyName.
	aTile addArrows.
	aTile setLiteral: self choices first.
	^ aTile! !


!DirectionType methodsFor: 'initialization'!
initialize
	super initialize.
	self vocabularyName: #Direction.
	symbols _ #(#up #down #left #right )! !


!EffectType methodsFor: 'initialization'!
initialize
	"Vocabulary initialize."
	super initialize.
	self vocabularyName: #Effect.
	symbols _ Morph effectSymbols! !


!SystemWindow methodsFor: 'events' stamp: 'mu 1/2/2003 21:31'!
mouseDown: evt

	self stopKeepMoving.
	self setProperty: #clickPoint toValue: evt cursorPoint.
	TopWindow == self ifFalse:
		[evt hand releaseKeyboardFocus.
		self activate].
	model windowActiveOnFirstClick ifTrue:
		["Normally window keeps control of first click.
		Need explicit transmission for first-click activity."
		submorphs do: [:m | (m containsPoint: evt cursorPoint) ifTrue: [m mouseDown: evt]]]

! !


!TheWorldMenu methodsFor: 'commands'!
readMorphFromAFile
	"Produce a morph from a file -- either a saved .morph file or a graphics file"

	| morphOrList ff aName f m |
	aName _ Utilities chooseFileWithSuffixFromList:
(#('.morph'), Utilities graphicsFileSuffixes) withCaption: 'Choose a file
to load'.
	aName ifNil: [^ self].  "User made no choice"
	aName == #none ifTrue: [^ self inform: 
'Sorry, no suitable files found
(names should end with .morph, .gif,
.bmp, .jpeg, .jpe, .jp, or .form)'].

	(aName asLowercase endsWith: '.morph')
		ifTrue:
			[ff _ FileStream readOnlyFileNamed: aName.
			morphOrList _ ff fileInObjectAndCode.		"code filed in is the Model class"
			"the file may contain either a single morph or an array of morphs"
			(ActiveWorld allMorphs
					detect: [:morph | morph identifier = morphOrList identifier]
					ifNone: [])
					= nil
				ifFalse: [morphOrList _ morphOrList copy].
			myWorld addMorphsAndModel: morphOrList]
		ifFalse:
			[f _ Form fromFileNamed: aName.
			f ifNil: [^ self error: 'unrecognized image file format'].
			m _ myWorld drawingClass new form: f.
			myHand attachMorph: m]
! !

!TheWorldMenu methodsFor: 'commands' stamp: 'my 4/9/2003 23:29'!
saveAsNeighbors
	NmUtil makeNeighborImage! !

!TheWorldMenu methodsFor: 'construction' stamp: 'my 4/9/2003 23:30'!
buildWorldMenu
	"Build the menu that is put up when the screen-desktop is clicked on"

	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu commandKeyHandler: self.
	self colorForDebugging: menu.
	menu addStayUpItem.
	self fillIn: menu from: {
		{'previous project' . { #myWorld . #goBack }. 'return to the most-recently-visited project'}.
		{'jump to project...' . { #myWorld . #jumpToProject }. 'put up a list of all projects, letting me choose one to go to' }.
		{'save project on file...' . { #myWorld  . #saveOnFile }. 'save this project on a file' }.
		{'load project from file...' . { self  . #loadProject }. 'load a project from a file' }.
		nil}.
	myWorld addUndoItemsTo: menu.

		self fillIn: menu from: {
		{'restore display (r)' . { World . #restoreMorphicDisplay }. 'repaint the screen -- useful for removing unwanted display artifacts, lingering cursors, etc.' }.
		nil}.
		self fillIn: menu from: {
		{'logging on' . { self . #loggingOn }. 'logging on.' }.
		{'logging off' . { self . #loggingOff }. 'logging off.' }.
		nil}.
	Preferences simpleMenus ifFalse:
		[self fillIn: menu from: { 
			{'open...' . { self  . #openWindow } }.
			{'windows...' . { self  . #windowsDo } }.
			{'changes...' . { self  . #changesDo } }}].
	self fillIn: menu from: { 
		{'help...' . { self  . #helpDo }.  'puts up a menu of useful items for updating the system, determining what version you are running, and much else'}.
		{'appearance...' . { self  . #appearanceDo }. 'put up a menu offering many controls over appearance.' }}.

	Preferences simpleMenus ifFalse:
		[self fillIn: menu from: {
			{'do...' . { Utilities . #offerCommonRequests} . 'put up an editible list of convenient expressions, and evaluate the one selected.' }}].

	self fillIn: menu from: { 
		nil.
		{'objects (o)' . { #myWorld . #activateObjectsTool } . 'A tool for finding and obtaining many kinds of objects'}.
		{'new morph...' . { self  . #newMorph }. 'Offers a variety of ways to create new objects'}.
		nil.
		{'authoring tools...' . { self  . #scriptingDo } . 'A menu of choices useful for authoring'}.
		{'playfield options...' . { self  . #playfieldDo } . 'A menu of options pertaining to this object as viewed as a playfield' }.
		{'flaps...'. { self . #flapsDo } . 'A menu relating to use of flaps.  For best results, use "keep this menu up"' }.
		{'projects...' . { self  . #projectDo }. 'A menu of commands relating to use of projects' }}.
	Preferences simpleMenus ifFalse:
		[self fillIn: menu from: { 
			{'print PS to file...' . { self  . #printWorldOnFile } . 'write the world into a postscript file'}.
			{'debug...' . { self  . #debugDo } . 'a menu of debugging items' }}].
	self fillIn: menu from: { 
		nil.
		{'save' . { self  . #saveSession } . 'save the current version of the image on disk' }.
		{'save as...' . { Smalltalk . #saveAs }. 'save the current version of the image on disk under a new name.'}.
		{'save as new version' . { Smalltalk . #saveAsNewVersion }. 'give the current image a new version-stamped name and save it under that name on disk.' }.
		{'save as today''s image' . { self . #saveAsTodayVersion }. 'give the current image a new today''s name and save it under that name on disk.' }.
		{'save as neighbors' . { self . #saveAsNeighbors }. '(NetMorph) set map loading setting to local and save two neighbor images. Local WorldMap.csv will be created.' }.
		{'save and quit' . { self  . #saveAndQuit } . 'save the current image on disk, and quit out of Squeak.'}.
		{'quit' . { self  . #quitSession } . 'quit out of Squeak.' }}.

	^ menu! !


!TileMorph methodsFor: 'NetMorph serializing' stamp: 'kuri-t 12/13/2002 15:27'!
prepareForWarp
	type ~~ #objRef ifTrue: [^ self].
	actualObject isProxy ifTrue: [^ self].
	actualObject isPlayerLike ifFalse: [^ self].
	self topEditor playerScripted == actualObject ifTrue: [^ self].

	actualObject _ actualObject asProxy! !

!TileMorph methodsFor: 'NetMorph testing' stamp: 'kuri-t 12/10/2002 14:44'!
shouldPrepareForWarp
	^ true! !


!EffectTile methodsFor: 'user interface'!
mouseDown: evt 
	| aPoint index isUp effectChoices adjustment |
	upArrow
		ifNotNil: [((isUp _ upArrow containsPoint: (aPoint _ evt cursorPoint))
					or: [downArrow containsPoint: aPoint])
				ifTrue: [effectChoices _ Morph effectSymbols.
					index _ effectChoices indexOf: literal.
					index > 0
						ifTrue: [adjustment _ isUp
										ifTrue: [1]
										ifFalse: [-1].
							self
								literal: (effectChoices atWrap: index + adjustment)]].
			^ self].
	super mouseStillDown: evt! !

!EffectTile methodsFor: 'user interface'!
mouseMove: evt 
	"overridden so as NOT to keep scrolling"
	^ self! !

!EffectTile methodsFor: 'user interface'!
wantsKeyboardFocusFor: aSubmorph 
	^ false! !

!EffectTile methodsFor: 'initialization'!
initialize
	super initialize.
	self addArrows; setLiteral: 'none'.
	self labelMorph useStringFormat! !

!EffectTile methodsFor: 'type'!
resultType
	"Answer the result type of the receiver"
	^ #Effect! !


!TransformationMorph methodsFor: 'accessing'!
scaleToMatch: aPoint
	| scaleFactor tfm originalScale |
	tfm _ transform withScale: 1.0.
	originalScale _ ((tfm localBoundsToGlobal: self renderedMorph fullBounds) corner -
		(tfm localPointToGlobal: self renderedMorph referencePosition)) r.
	"Catch cases where the reference point is on fullBounds corner"
	originalScale < 1.0 ifTrue:[originalScale _ 1.0].
	scaleFactor _ ((self globalPointToLocal: aPoint)
				- self referencePosition) r / originalScale.
	scaleFactor _ scaleFactor < 1.0
		ifTrue: [scaleFactor detentBy: 0.05 atMultiplesOf: 0.25 snap: false]
		ifFalse: [scaleFactor detentBy: 0.1 atMultiplesOf: 0.5 snap: false].
	self adjustAfter:[self scale: ((scaleFactor min: 8.0) max: 0.1)].! !

!TransformationMorph methodsFor: 'menu' stamp: 'kuri-t 1/9/2003 14:10'!
removeFlexShell
	^ self! !

!TransformationMorph methodsFor: 'e-toy support' stamp: 'ar 9/22/2000 13:38'!
heading
	^self renderedMorph heading! !

!TransformationMorph methodsFor: 'stepping and presenter' stamp: 'ka 12/12/2002 16:02'!
stepTime
	"Answer the stepTime of my rendered morph if posible"
	| rendered |
	rendered _ [self renderedMorph]
				on: NmNoSubmorphs
				do: [:ex | ex return: self].
	rendered == self
		ifTrue: [^ super stepTime].
	"Hack to avoid infinite recursion"
	^ rendered stepTime! !

!TransformationMorph methodsFor: 'geometry keep moving' stamp: 'mu 1/2/2003 20:07'!
getMoveDelta
	^self renderedMorph getMoveDelta! !

!TransformationMorph methodsFor: 'geometry keep moving' stamp: 'mu 1/2/2003 20:07'!
rememberMoveEndPoint
	^self renderedMorph rememberMoveEndPoint! !

!TransformationMorph methodsFor: 'geometry keep moving' stamp: 'mu 1/2/2003 20:07'!
rememberMoveStartPoint
	^self renderedMorph rememberMoveStartPoint! !

!TransformationMorph methodsFor: 'geometry keep moving' stamp: 'kuri-t 2/18/2003 14:46'!
resetKeepMovingStatus
	^self renderedMorph resetKeepMovingStatus! !

!TransformationMorph methodsFor: 'geometry keep moving' stamp: 'mu 1/2/2003 20:06'!
shouldKeepMoving
	^self renderedMorph shouldKeepMoving! !

!TransformationMorph methodsFor: 'geometry keep moving' stamp: 'mu 1/2/2003 20:06'!
shouldKeepMoving: aBoolean 
	^self renderedMorph shouldKeepMoving: aBoolean ! !

!TransformationMorph methodsFor: 'geometry keep moving' stamp: 'mu 1/2/2003 20:07'!
startKeepMoving
	^self renderedMorph startKeepMoving! !

!TransformationMorph methodsFor: 'geometry keep moving' stamp: 'mu 1/2/2003 20:38'!
stopKeepMoving
	^self renderedMorph stopKeepMoving! !

!TransformationMorph methodsFor: 'NetMorph support' stamp: 'ka 12/12/2002 16:01'!
renderedMorph
	submorphs size = 0
		ifTrue: [^ NmNoSubmorphs signal: self printString].
	^ self firstSubmorph renderedMorph! !

!TransformationMorph methodsFor: 'NetMorph support' stamp: 'mu 4/11/2003 16:12'!
warpTo: destination x: x y: y 
	submorphs isEmpty
		ifTrue: [NmpObject crShow:  '##Real morph was warped. So just ignoring warpting request...'.
			^ self].
	^ super
		warpTo: destination
		x: x
		y: y! !

!TransformationMorph methodsFor: 'NetMorph extension' stamp: 'kuri-t 1/14/2003 17:08'!
address
	^ self renderedMorph address! !

!TransformationMorph methodsFor: 'NetMorph extension' stamp: 'kuri-t 1/14/2003 17:47'!
formerWorldBounds
	^ self renderedMorph formerWorldBounds! !

!TransformationMorph methodsFor: 'NetMorph extension' stamp: 'kuri-t 1/15/2003 12:02'!
home
	^ self renderedMorph home! !

!TransformationMorph methodsFor: 'NetMorph extension' stamp: 'kuri-t 1/14/2003 17:08'!
identifier
	^ self renderedMorph identifier! !

!TransformationMorph methodsFor: 'NetMorph extension' stamp: 'kuri-t 2/7/2003 12:20'!
lastWarpTime
	^ self renderedMorph lastWarpTime! !

!TransformationMorph methodsFor: 'NetMorph extension' stamp: 'kuri-t 2/7/2003 12:21'!
lastWarpTime: millisecond
	self renderedMorph lastWarpTime: millisecond! !

!TransformationMorph methodsFor: 'NetMorph extension' stamp: 'kuri-t 1/15/2003 12:01'!
path
	^ self renderedMorph path! !

!TransformationMorph methodsFor: 'NetMorph extension' stamp: 'kuri-t 1/15/2003 12:13'!
resetIdentifier
	^ self renderedMorph resetIdentifier! !

!TransformationMorph methodsFor: 'NetMorph extension' stamp: 'kuri-t 1/22/2003 15:34'!
warpDirection
	^ self renderedMorph warpDirection! !

!TransformationMorph methodsFor: 'NetMorph extension' stamp: 'kuri-t 2/7/2003 12:22'!
warpDirection: warpDirection
	self renderedMorph warpDirection: warpDirection! !

!TransformationMorph methodsFor: 'NetMorph extension' stamp: 'kuri-t 1/22/2003 14:41'!
warpType
	^ self renderedMorph warpType! !

!TransformationMorph methodsFor: 'NetMorph extension' stamp: 'kuri-t 2/7/2003 12:22'!
warpType: warpType
	self renderedMorph warpType: warpType! !

!TransformationMorph methodsFor: 'NetMorph extension' stamp: 'kuri-t 1/14/2003 17:13'!
warping
	^ self renderedMorph warping! !

!TransformationMorph methodsFor: 'NetMorph extension' stamp: 'kuri-t 2/7/2003 12:22'!
warping: statusSymbol
	self renderedMorph warping: statusSymbol! !

!TransformationMorph methodsFor: 'obsolete' stamp: 'kuri-t 1/9/2003 14:11'!
obsoleteRemoveFlexShell
	"Remove the shell used to make a morph rotatable and scalable."

	| oldHalo unflexed pensDown player myWorld refPos |
	refPos _ self referencePosition.
	myWorld _ self world.
	oldHalo _ self halo.
	submorphs isEmpty ifTrue: [^ self delete].
	unflexed _ self firstSubmorph.
	pensDown _ OrderedCollection new.
	self allMorphsDo:  "Note any pens down -- must not be down during the move"
		[:m | ((player _ m player) notNil and: [player getPenDown]) ifTrue:
			[m == player costume ifTrue:
				[pensDown add: player.
				player setPenDown: false]]].
	self submorphs do: [:m |
		m position: self center - (m extent // 2).
		owner addMorph: m].
	unflexed absorbStateFromRenderer: self.
	pensDown do: [:p | p setPenDown: true].
	oldHalo ifNotNil: [oldHalo setTarget: unflexed].
	myWorld ifNotNil: [myWorld startSteppingSubmorphsOf: unflexed].
	self delete.
	unflexed referencePosition: refPos.
	^ unflexed! !


!UniclassScript methodsFor: 'NetMorph serializing' stamp: 'kuri-t 12/5/2002 17:21'!
prepareForWarp
	currentScriptEditor ifNotNil:
		[currentScriptEditor prepareForWarp].
	formerScriptingTiles isEmptyOrNil ifFalse:
		[formerScriptingTiles _ OrderedCollection new]! !


!Url methodsFor: 'testing' stamp: 'mu 4/15/2003 16:39'!
isNmUrl
	^false! !


!Url class methodsFor: 'parsing'!
absoluteFromText: aString
	"Url absoluteFromText: 'nm://dvorak/auau'" 
	"Url absoluteFromText: 'msw://chaos.resnet.gatech.edu:9000/testbook?top'"
	"Url absoluteFromText: 'telnet:chaos.resnet.gatech.edu'"
	"Url absoluteFromText: 'file:/etc/passwd'"

	| remainder scheme fragment ind newUrl |

	"trim surrounding whitespace"
	remainder _ aString withBlanksTrimmed.	

	"extract the fragment, if any"
	ind _ remainder indexOf: $#.
	ind > 0 ifTrue: [
		fragment _ remainder copyFrom: ind+1 to: remainder size.
		remainder _ remainder copyFrom: 1 to: ind-1 ].

	"choose class based on the scheme name, and let that class do the bulk of the parsing"
	scheme _ self schemeNameForString: remainder.

	scheme = nil ifTrue: [
		newUrl _ HttpUrl new privateInitializeFromText: remainder ].

	(scheme = 'http') ifTrue: [ newUrl _ HttpUrl new privateInitializeFromText: remainder ].
	(scheme = 'msw') ifTrue: [ newUrl _ MswUrl new privateInitializeFromText: remainder ]. 
	(scheme = 'ftp') ifTrue:[ newUrl _ FtpUrl new privateInitializeFromText: remainder ].
	(scheme = 'file') ifTrue: [newUrl _ FileUrl new privateInitializeFromText: remainder ].
	(scheme = NmUrl protcolIdentifier) ifTrue: [newUrl _ NmUrl new privateInitializeFromText: remainder ].
	
	(scheme = 'browser') ifTrue: [ newUrl _ BrowserUrl new privateInitializeFromText: remainder ].
	(scheme = 'mailto') ifTrue: [ newUrl _ MailtoUrl new privateInitializeFromText: remainder ].

	newUrl ifNil: [  newUrl _ GenericUrl new privateInitializeFromText: remainder ].


	"set the fragment"
	newUrl privateFragment: fragment.


	"all done"
	^newUrl! !


!UserScript methodsFor: 'NetMorph serializing' stamp: 'kuri-t 12/4/2002 17:04'!
prepareForWarp 
	self
		allScriptVersionsDo: [:v | v prepareForWarp]! !


!Viewer methodsFor: 'special phrases' stamp: 'kuri-t 12/13/2002 14:11'!
nearToPhrase
	"Answer a conjured-up nearTo phrase in classic tile"

	| outerPhrase |
	outerPhrase _ PhraseTileMorph new setOperator: #+ "temp dummy" 
				type: #Boolean rcvrType: #Player argType: #Player.

	(outerPhrase submorphs at: 2) delete.	"operator"
	outerPhrase addMorphBack: (TileMorph new setOperator: #nearTo:).
	(outerPhrase submorphs at: 2) goBehind.		"Make it third"

	outerPhrase submorphs last addMorph: scriptedPlayer tileToRefer.
	^ outerPhrase! !


!CategoryViewer methodsFor: 'entries' stamp: 'kuri-t 12/13/2002 14:12'!
addNearToDetailTo: aRow 
	aRow addMorphBack: (Morph new color: self color;
			 extent: 2 @ 10).
	aRow addMorphBack: self tileForSelf.
	aRow addMorphBack: AlignmentMorph new beTransparent! !

!CategoryViewer methodsFor: 'entries' stamp: 'kuri-t 12/13/2002 14:12'!
phraseForVariableFrom: aMethodInterface
	"Return a structure consisting of tiles and controls and a readout representing a 'variable' belonging to the player, complete with an appropriate readout when indicated.  Functions in both universalTiles mode and classic mode.  Slightly misnamed in that this path is used for any methodInterface that indicates an interesting resultType."

	| anArrow slotName getterButton cover inner aRow doc setter tryer universal |

	aRow _ ViewerLine newRow
		color: self color;
		beSticky;
		elementSymbol: (slotName _ aMethodInterface selector);
		wrapCentering: #center;
		cellPositioning: #leftCenter.

	(universal _ scriptedPlayer isUniversalTiles) ifFalse:
		[aRow addMorphBack: (Morph new color: self color;
		extent: 11 @ 22; yourself)].  "spacer"

	aRow addMorphBack: (self infoButtonFor: slotName).
	aRow addMorphBack: (Morph new color: self color; extent: 2@10).  " spacer"

	universal ifTrue:
			[inner _ scriptedPlayer universalTilesForGetterOf: aMethodInterface.
			cover _ Morph new color: Color transparent.
			cover extent: inner fullBounds extent.
			(getterButton _ cover copy) addMorph: cover; addMorphBack: inner.
			cover on: #mouseDown send: #makeUniversalTilesGetter:event:from: 
					to: self withValue: aMethodInterface.
			aRow addMorphFront:  (tryer _ ScriptingSystem tryButtonFor: inner).
			tryer color: tryer color lighter lighter]
		ifFalse:
			[aRow addMorphBack: self tileForSelf bePossessive.
			aRow addMorphBack: (Morph new color: self color; extent: 2@10).  " spacer"
			getterButton _ self getterButtonFor: aMethodInterface selector type: aMethodInterface resultType].

	aRow addMorphBack: getterButton.
	(doc _ aMethodInterface documentationOrNil) ifNotNil:
		[getterButton setBalloonText: doc].

	universal ifFalse:
		[(slotName == #seesColor:) ifTrue:
			[self addIsOverColorDetailTo: aRow.
			^ aRow].
		(slotName == #touchesA:) ifTrue:
			[self addTouchesADetailTo: aRow.
			^ aRow].
		(slotName == #nearTo:) ifTrue:
			[self addNearToDetailTo: aRow.
			^ aRow]].

	aRow addMorphBack: (AlignmentMorph new beTransparent).  "flexible spacer"
	(setter _ aMethodInterface companionSetterSelector) ifNotNil:
		[aRow addMorphBack: (Morph new color: self color; extent: 2@10).  " spacer"
		anArrow _ universal 
			ifTrue: [self arrowSetterButton: #newMakeSetterFromInterface:evt:from:  
						args: aMethodInterface]
			ifFalse: [self arrowSetterButton: #makeSetter:from:forPart:
						args: (Array with: slotName with: aMethodInterface resultType)].
		aRow addMorphBack: anArrow].
	(#(color:sees: playerSeeingColor copy touchesA:) includes: slotName) ifFalse:
 		[(universal and: [slotName == #seesColor:]) ifFalse:
			[aRow addMorphBack: (self readoutFor: slotName type: aMethodInterface resultType readOnly: setter isNil getSelector: aMethodInterface selector putSelector: setter)]].

	anArrow ifNotNil: [anArrow step].
	^ aRow! !

!CategoryViewer methodsFor: 'entries' stamp: 'kuri-t 12/13/2002 14:13'!
wantsRowMenuFor: aSymbol
	"Answer whether a viewer row for the given symbol should have a menu button on it"

	| elementType |
	elementType _ scriptedPlayer elementTypeFor: aSymbol vocabulary: self currentVocabulary.
	(elementType == #systemScript) ifTrue: [^ false].
	((elementType == #systemSlot) and:
		[#(color:sees: touchesA: nearTo:) includes: aSymbol]) ifTrue: [^ false].
	^ true! !

!CategoryViewer methodsFor: 'get/set slots' stamp: 'kuri-t 12/13/2002 14:11'!
getterTilesFor: getterSelector type: aType
	"Answer classic getter for the given name/type"

	|  selfTile selector  aPhrase |
	"aPhrase _ nil, assumed"
	(#(color:sees: colorSees) includes: getterSelector) ifTrue: [aPhrase _ self colorSeesPhrase].
	(#(seesColor: isOverColor) includes: getterSelector) ifTrue: [aPhrase _ self seesColorPhrase].
	(#(touchesA: touchesA) includes: getterSelector) ifTrue: [aPhrase _ self touchesAPhrase].
	(#(nearTo: nearTo) includes: getterSelector) ifTrue: [aPhrase _ self nearToPhrase].

	aPhrase ifNil: [aPhrase _ PhraseTileMorph new setSlotRefOperator: getterSelector asSymbol type: aType].

	selfTile _ self tileForSelf bePossessive.
	selfTile position: aPhrase firstSubmorph position.
	aPhrase firstSubmorph addMorph: selfTile.

	selector _ aPhrase submorphs at: 2.
	(Vocabulary vocabularyNamed: aType capitalized)
		ifNotNilDo:
			[:aVocab | aVocab wantsSuffixArrow ifTrue:
				[selector addSuffixArrow]].
	selector updateLiteralLabel.
	aPhrase enforceTileColorPolicy.
	^ aPhrase! !

!CategoryViewer methodsFor: 'get/set slots' stamp: 'kuri-t 12/13/2002 14:12'!
newGetterTilesFor: aPlayer methodInterface: aMethodInterface
	"Return universal tiles for a getter on this property.  Record who self is."

	| ms argTile argArray |
	ms _ MessageSend receiver: aPlayer selector: aMethodInterface selector arguments: #().

	"Handle three idiosyncratic cases..."
	aMethodInterface selector == #color:sees: ifTrue:
		[argTile _ ScriptingSystem tileForArgType: #Color.
		argArray _ Array with: argTile colorSwatch color with: argTile colorSwatch color copy. 
		ms arguments: argArray].
	aMethodInterface selector == #seesColor: ifTrue:
		[argTile _ ScriptingSystem tileForArgType: #Color.
		ms arguments: (Array with: argTile colorSwatch color)].
	aMethodInterface selector == #touchesA: ifTrue:
		[argTile _ ScriptingSystem tileForArgType: #Player.
		ms arguments: (Array with: argTile actualObject)].
	aMethodInterface selector == #nearTo: ifTrue:
		[argTile _ ScriptingSystem tileForArgType: #Player.
		ms arguments: (Array with: argTile actualObject)].

	^ ms asTilesIn: aPlayer class globalNames: (aPlayer class officialClass ~~ CardPlayer)
			"For CardPlayers, use 'self'.  For others, name it, and use its name."! !


!Vocabulary class methodsFor: 'class initialization' stamp: 'ka 1/15/2003 15:17'!
initializeStandardVocabularies
	"Initialize a few standard vocabularies and place them in the AllStandardVocabularies list."

	AllStandardVocabularies _ nil.
	self allStandardVocabularies.

	self addEToyVocabulary.
	self addEToyVectorVocabulary.

	self addStandardVocabulary: self newPublicVocabulary.
	self addStandardVocabulary: FullVocabulary new.

	self addStandardVocabulary: self newQuadVocabulary.

	self addStandardVocabulary: ColorType new.
	self addStandardVocabulary: BooleanType new.
	self addStandardVocabulary: GraphicType new.
	self addStandardVocabulary: PlayerType new.
	self addStandardVocabulary: SoundType new.
	self addStandardVocabulary: StringType new.
	self addStandardVocabulary: MenuType new.
	self addStandardVocabulary: UnknownType new.
	self addStandardVocabulary: ScriptNameType new.

	self addStandardVocabulary: EffectType new.
	self addStandardVocabulary: NmWarpType new.
	self addStandardVocabulary: DirectionType new.
	self addStandardVocabulary: NmWarpDestinationType new.

	self addStandardVocabulary: (SymbolListType new symbols: #(simple raised inset complexFramed complexRaised complexInset complexAltFramed complexAltRaised complexAltInset); vocabularyName: #BorderStyle; yourself).
	self addStandardVocabulary: (SymbolListType new symbols: #(leftToRight rightToLeft topToBottom bottomToTop); vocabularyName: #ListDirection; yourself).

	self addStandardVocabulary: (SymbolListType new symbols: #(topLeft bottomRight center justified); vocabularyName: #ListCentering; yourself).

	self addStandardVocabulary: (SymbolListType new symbols: #(buttonDown whilePressed buttonUp); vocabularyName: #ButtonPhase; yourself).

	self addStandardVocabulary: (SymbolListType new symbols: #(rigid spaceFill shrinkWrap); vocabularyName: #Resizing; yourself).

	self addStandardVocabulary: self newSystemVocabulary.  "A custom vocabulary for Smalltalk -- still under development)"

	self numberVocabulary.  		"creates and adds it"
	self wonderlandVocabulary.  	"creates and adds it"
	self vocabularyForClass: Time.   "creates and adds it"

	"Vocabulary initialize"! !


!WorldState methodsFor: 'stepping' stamp: 'kuri-t 1/8/2003 17:38'!
stopStepping: aMorph selector: aSelector 
	"Remove the given morph from the step list."
	lastStepMessage
		ifNotNil: [(lastStepMessage receiver == aMorph
					and: [lastStepMessage selector == aSelector])
				ifTrue: [lastStepMessage _ nil]].
	stepList
		do: [:stepMsg | (stepMsg receiver == aMorph
					and: [stepMsg selector == aSelector])
				ifTrue: [stepList
						remove: stepMsg
						ifAbsent: []]]! !


!TransformationMorph reorganize!
('initialization' asFlexOf: flexing:byTransformation:)
('accessing' extent: hasNoScaleOrRotation innocuousName isFlexMorph isRenderer printOn: referencePosition rotationDegrees rotationDegrees: scaleFactor scaleToMatch:)
('drawing' drawOn:)
('change reporting' layoutChanged)
('menu' removeFlexShell)
('private' adjustAfter: chooseSmoothing replaceSubmorph:by:)
('e-toy support' degreesOfFlex forwardDirection forwardDirection: heading heading: setDirectionFrom:)
('dropping/grabbing' grabTransform)
('geometry' computeBounds transformedBy:)
('stepping and presenter' stepTime)
('geometry keep moving' getMoveDelta rememberMoveEndPoint rememberMoveStartPoint resetKeepMovingStatus shouldKeepMoving shouldKeepMoving: startKeepMoving stopKeepMoving)
('NetMorph support' renderedMorph warpTo:x:y:)
('NetMorph extension' address formerWorldBounds home identifier lastWarpTime lastWarpTime: path resetIdentifier warpDirection warpDirection: warpType warpType: warping warping:)
('obsolete' obsoleteRemoveFlexShell)
!

Object subclass: #MorphExtension
	instanceVariableNames: 'locked visible sticky balloonText balloonTextSelector externalName isPartsDonor actorState player eventHandler otherProperties path identifier '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Kernel'!
Morph initialize!
