RectangleMorph subclass: #NmMarkerMorph
	instanceVariableNames: 'uuid textMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-Network'!

!NmMarkerMorph methodsFor: 'constants' stamp: 'MU 12/28/2002 00:58'!
defaultHeight
	^ 20! !

!NmMarkerMorph methodsFor: 'constants' stamp: 'MU 12/28/2002 00:58'!
defaultWidth
	^ 40! !


!NmMarkerMorph methodsFor: 'initialization' stamp: 'MU 12/28/2002 00:59'!
initialize
	super initialize.
	textMorph _ TextMorph new contents: '       '.
	textMorph centered.
	textMorph borderWidth: 4.
	textMorph borderColor: Color transparent.
	textMorph width: self defaultWidth.
	textMorph lock.
	self addMorphCentered: textMorph;
		 clipSubmorphs: true;
		 setBorderStyle: #complexAltInset.
	self color: Color random lighter;
		 width: self defaultWidth;
		 height: self defaultHeight! !


!NmMarkerMorph methodsFor: 'actions' stamp: 'kuri-t 1/23/2003 19:40'!
bringMarkedMorphHome
	| morph |
	morph _ Morph fromUUID: uuid.
	morph isNil
		ifTrue: [self showBalloon: 'Morph(' , uuid asString , ') is not found']
		ifFalse: [morph
				warpTo: self address
				x: self center x
				y: self center y]! !

!NmMarkerMorph methodsFor: 'actions' stamp: 'MU 12/28/2002 01:33'!
label: aString
	textMorph contents: aString.
	self width: textMorph width.
	textMorph center: self center.
	textMorph lock.
	
	! !


!NmMarkerMorph methodsFor: 'accessing' stamp: 'MU 12/28/2002 01:03'!
uuid: anUuid
	uuid _ anUuid! !


!NmMarkerMorph methodsFor: 'menu' stamp: 'MU 12/28/2002 01:43'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addLine.
	aCustomMenu add: 'bring the marked morph back' action: #bringMarkedMorphHome.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmMarkerMorph class
	instanceVariableNames: ''!

!NmMarkerMorph class methodsFor: 'instance creation' stamp: 'MU 12/28/2002 01:02'!
on: aMorph
	| inst |
	inst _ self new.
	inst uuid: aMorph identifier.
	inst label: aMorph name.
	^inst! !


NmError subclass: #NmNoSubmorphs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-Network'!


NmError subclass: #NmNoSuchMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-Network'!

!NmNoSuchMorph methodsFor: 'accessing' stamp: 'mu 12/27/2002 02:41'!
uuidString
	self messageText isNil ifTrue: [^''].
	^self messageText copyFrom: 7 "Morph(" to: 42 "UUID new asString size"! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmNoSuchMorph class
	instanceVariableNames: ''!

!NmNoSuchMorph class methodsFor: 'instance creation' stamp: 'mu 12/27/2002 02:34'!
signalWithUuidString: uuidString
	^self signal: 'Morph(' , uuidString , ') is not found'! !


Object subclass: #NmObjectReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-Network'!


NmObjectReference subclass: #NmMorphReference
	instanceVariableNames: 'className uuid url '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-Network'!

!NmMorphReference methodsFor: 'accessing' stamp: 'kuri-t 11/22/2002 14:28'!
className
	^className! !

!NmMorphReference methodsFor: 'accessing' stamp: 'kuri-t 11/12/2002 15:35'!
className: aString
	className _ aString.! !

!NmMorphReference methodsFor: 'accessing' stamp: 'kuri-t 11/22/2002 14:28'!
url
	^url! !

!NmMorphReference methodsFor: 'accessing' stamp: 'kuri-t 11/12/2002 15:22'!
url: anUrl
	url	_ anUrl.! !

!NmMorphReference methodsFor: 'accessing' stamp: 'kuri-t 11/22/2002 14:28'!
uuid
	^uuid! !

!NmMorphReference methodsFor: 'accessing' stamp: 'kuri-t 11/12/2002 15:34'!
uuid: anUUID
	uuid _ anUUID.! !


!NmMorphReference methodsFor: 'converting' stamp: 'kuri-t 11/12/2002 15:41'!
asProxy
	^ NmMorphProxy
		className: className
		uuid: uuid
		url: url! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmMorphReference class
	instanceVariableNames: ''!

!NmMorphReference class methodsFor: 'instance creation' stamp: 'kuri-t 11/21/2002 13:01'!
className: classNameSymbol uuid: uuidObject url: urlObject
	| morphReference |
	morphReference _ self new.
	morphReference className: classNameSymbol.
	morphReference uuid: uuidObject.
	morphReference url: urlObject.
	^ morphReference.! !

!NmMorphReference class methodsFor: 'instance creation' stamp: 'kuri-t 11/21/2002 13:10'!
on: aMorph
	^ self
		className: aMorph class name
		uuid: aMorph identifier
		url: NmUrl local! !


NmObjectReference subclass: #NmPlayerReference
	instanceVariableNames: 'costume '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-Network'!

!NmPlayerReference methodsFor: 'converting' stamp: 'kuri-t 11/12/2002 15:56'!
asProxy
	^ NmPlayerProxy for: costume asProxy.! !


!NmPlayerReference methodsFor: 'accessing' stamp: 'kuri-t 11/22/2002 14:29'!
costume
	^costume! !

!NmPlayerReference methodsFor: 'accessing' stamp: 'kuri-t 11/12/2002 15:52'!
costume: aMorph
	costume _ aMorph.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmPlayerReference class
	instanceVariableNames: ''!

!NmPlayerReference class methodsFor: 'instance creation' stamp: 'kuri-t 11/21/2002 14:34'!
costume: aMorph
	| playerReference |
	playerReference _ self new.
	playerReference costume: (aMorph asObjectReference).
	^ playerReference.! !

!NmPlayerReference class methodsFor: 'instance creation' stamp: 'kuri-t 11/21/2002 14:35'!
on: aPlayer
	^self costume: aPlayer costume! !


ProtoObject subclass: #NmProxy
	instanceVariableNames: 'className '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-Network'!

!NmProxy methodsFor: 'debugging' stamp: 'mu 12/11/2002 15:53'!
halt
	Halt signal! !

!NmProxy methodsFor: 'debugging' stamp: 'mu 9/20/2002 16:29'!
inspect
	Inspector
		openOn: self xxxDebugRepresentation
		withEvalPane: true
		withLabel: 'a NmProxy'! !

!NmProxy methodsFor: 'debugging' stamp: 'mu 12/11/2002 16:18'!
longPrintOn: aStream limitedTo: sizeLimit indent: indent
	
	self class allInstVarNames doWithIndex:
		[:title :index |
		indent timesRepeat: [aStream tab].
		aStream nextPutAll: title;
		 nextPut: $:;
		 space;
		 tab;
		 nextPutAll: 
			((self instVarAt: index) printStringLimitedTo: (sizeLimit -3 -title size max: 1));
		 cr]! !

!NmProxy methodsFor: 'debugging' stamp: 'mu 9/20/2002 16:26'!
printOn: aStream 
	aStream nextPutAll: self xxxDebugRepresentation printString
		! !

!NmProxy methodsFor: 'debugging' stamp: 'mu 9/20/2002 16:26'!
printString
	| wstr |
	wstr _ WriteStream on: (String new: 64).
	self printOn: wstr.
	^wstr contents! !

!NmProxy methodsFor: 'debugging' stamp: 'mu 12/10/2002 18:12'!
printStringLimitedTo: limit
	| limitedString |
	limitedString _ String streamContents: [:s | self printOn: s] limitedTo: limit.
	limitedString size < limit ifTrue: [^ limitedString].
	^ limitedString , '...etc...'! !

!NmProxy methodsFor: 'debugging' stamp: 'mu 9/20/2002 16:29'!
xxxDebugRepresentation
	^ Array
		with: 'NmProxy of: ',  className
		! !


!NmProxy methodsFor: 'system primitives' stamp: 'MU 12/28/2002 02:52'!
becomeForward: otherObject 
	(Array with: self)
		elementsForwardIdentityTo:
			(Array with: otherObject)! !

!NmProxy methodsFor: 'system primitives' stamp: 'mu 4/11/2003 15:24'!
doesNotUnderstand: aMessage 
	NmTranscript crShow: self class name.
	NmTranscript show: ' message: ' , aMessage printString.
	! !


!NmProxy methodsFor: 'shortcuts' stamp: 'mu 9/20/2002 16:30'!
isKindOf: otherClass
	| cls |
	cls _ Smalltalk
				at: className
				ifAbsent: [^ false].
	^ cls isKindOf: otherClass! !

!NmProxy methodsFor: 'shortcuts' stamp: 'mu 9/20/2002 16:30'!
yourself
	^self! !


!NmProxy methodsFor: 'private' stamp: 'kuri-t 1/20/2003 19:00'!
xxxBackToReal: aMorph 
	^ Error new signal: 'My subclass should have overridden one of my messages.'! !

!NmProxy methodsFor: 'private' stamp: 'kuri-t 12/13/2002 15:43'!
xxxClassName
	^className! !

!NmProxy methodsFor: 'private' stamp: 'mu 9/20/2002 16:41'!
xxxClassName: aSymbol
	className := aSymbol! !

!NmProxy methodsFor: 'private' stamp: 'kuri-t 1/20/2003 19:00'!
xxxFindMorphInLocalWorld
	^ (ActiveWorld allMorphs
		reject: [:each | each isRenderer])
		detect: [:morph | morph identifier = self identifier]
		ifNone: []! !

!NmProxy methodsFor: 'private' stamp: 'MU2 12/19/2002 10:56'!
xxxHandleError: anException
	| clsName |
	clsName _ anException class name.
	NmTranscript crShow: 'Exception class: ' , clsName.! !


!NmProxy methodsFor: 'testing' stamp: 'kuri-t 11/21/2002 17:31'!
isProxy
	^ true! !

!NmProxy methodsFor: 'testing' stamp: 'kuri-t 1/6/2003 16:28'!
shouldPassAsProxy
	^ false.! !


!NmProxy methodsFor: 'objects from disk' stamp: 'kuri-t 11/29/2002 17:41'!
comeFullyUpOnReload: smartRefStream
	^ self! !

!NmProxy methodsFor: 'objects from disk' stamp: 'kuri-t 11/29/2002 17:41'!
objectForDataStream: refStrm
    ^ self! !

!NmProxy methodsFor: 'objects from disk' stamp: 'kuri-t 11/29/2002 17:45'!
readDataFrom: aDataStream size: varsOnDisk
	| cntInstVars cntIndexedVars objectReference |
	objectReference _ self xxxNewObjectReference.
	cntInstVars _ objectReference class instSize.
	cntIndexedVars _ 0.
	cntInstVars _ varsOnDisk.

	aDataStream beginReference: self.
	1 to: cntInstVars do:
		[:i | objectReference instVarAt: i put: aDataStream next].
	1 to: cntIndexedVars do:
		[:i | objectReference basicAt: i put: aDataStream next].
	^ objectReference asProxy! !

!NmProxy methodsFor: 'objects from disk' stamp: 'kuri-t 11/29/2002 17:40'!
storeDataOn: aDataStream
	| cntInstVars cntIndexedVars objectReference |
	objectReference _ self asObjectReference.
	cntInstVars _ objectReference class instSize.
	cntIndexedVars _ objectReference basicSize.
	aDataStream
		beginInstance: self class
		size: cntInstVars + cntIndexedVars.
	1 to: cntInstVars do:
		[:i | aDataStream nextPut: (objectReference instVarAt: i)].

	((aDataStream byteStream class == DummyStream) and: [objectReference class isBits]) ifFalse: [
		1 to: cntIndexedVars do:
			[:i | aDataStream nextPut: (objectReference basicAt: i)]].
! !


NmProxy subclass: #NmMorphProxy
	instanceVariableNames: 'uuid url player '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-Network'!

!NmMorphProxy methodsFor: 'initialize-release' stamp: 'mu 9/12/2002 17:00'!
xxxInitClassName: classNameSymbol uuid: uuidObj url: urlObj 
	className _ classNameSymbol.
	uuid _ uuidObj.
	url _ urlObj! !


!NmMorphProxy methodsFor: 'system primitives' stamp: 'kuri-t 1/20/2003 19:05'!
doesNotUnderstand: aMessage 
	| return detection subject |
	super doesNotUnderstand: aMessage.
	detection _ self xxxFindMorphInLocalWorld.
	return _ detection isNil
				ifTrue: [[self xxxCallDispatch: aMessage target: #morph]
						on: NmpGenericError , NmError
						do: [:ex | self xxxHandleError: ex]]
				ifFalse: [subject _ self xxxBackToReal: detection.
					subject perform: aMessage selector withArguments: aMessage arguments].
	^ return! !


!NmMorphProxy methodsFor: 'debugging' stamp: 'mu 9/12/2002 17:24'!
xxxDebugRepresentation
	^ (Array
		with: 'NmMorphProxy of: ', className
		with: uuid
		with: url)! !


!NmMorphProxy methodsFor: 'friends-delegate' stamp: 'kuri-t 1/9/2003 17:21'!
xxxCallDispatch: aMessage target: targetString 
	| result |
	result _ [aMessage arguments isEmpty
				ifTrue: [self xxxCallNoArgumentsDispatch: aMessage target: targetString]
				ifFalse: [self xxxCallWithArgumentsDispatch: aMessage target: targetString]]
				on: NmNoSuchMorph
				do: [:ex | self xxxTryToUpdateUrl
						ifTrue: [(self xxxHandlerOf: targetString)
								perform: aMessage selector
								withArguments: aMessage arguments]
						ifFalse: [ex pass]].
	^ result! !

!NmMorphProxy methodsFor: 'friends-delegate' stamp: 'mu 3/23/2003 13:43'!
xxxCallNoArgumentsDispatch: aMessage target: targetString 
	| connector |
	connector _ NmRemoteConnector connect: url ipAddressOrHost port: url port.
	^ connector
		callDispatch: uuid asString
		to: targetString
		selector: aMessage selector! !

!NmMorphProxy methodsFor: 'friends-delegate' stamp: 'mu 3/23/2003 13:43'!
xxxCallWithArgumentsDispatch: aMessage target: targetString 
	| connector arguments |
	arguments _ aMessage arguments.
	arguments
		withIndexDo: [:arg :idx | arg shouldPassAsProxy
				ifTrue: [arguments at: idx put: arg asProxy]].

	connector _ NmRemoteConnector connect: url ipAddressOrHost port: url port.
	^ connector
		callDispatch: uuid asString
		to: targetString
		selector: aMessage selector
		withArguments: aMessage arguments! !


!NmMorphProxy methodsFor: 'private' stamp: 'kuri-t 1/20/2003 19:04'!
xxxBackToReal: aMorph 
	self becomeForward: aMorph.
	^ aMorph! !

!NmMorphProxy methodsFor: 'private' stamp: 'mu 12/26/2002 01:18'!
xxxHandleError: anException 
	| clsName |
	clsName _ anException class name.
	NmTranscript crShow: '#$#Exception class: ' , clsName , ' in ' , self class name.
	(#(#NmpTimeout #NmpInvalidSocketConnection #NmpSocketPrimitiveFailed #NmpCannotConnect ) includes: clsName)
		ifTrue: [NmProcessManager releaseAllLockedProcesses.
			^ nil].
	anException pass! !

!NmMorphProxy methodsFor: 'private' stamp: 'kuri-t 1/9/2003 17:24'!
xxxHandlerOf: targetString 
	targetString == #morph ifTrue: [^ self].
	targetString == #player ifTrue: [^ self player]! !

!NmMorphProxy methodsFor: 'private' stamp: 'kuri-t 11/29/2002 17:44'!
xxxNewObjectReference
	^ NmMorphReference new.! !

!NmMorphProxy methodsFor: 'private' stamp: 'MU2 1/21/2003 16:54'!
xxxTryToUpdateUrl
	| morphProxy |
	morphProxy _ NmRemoteConnector callFindBy: uuid retry: 3.
	^ morphProxy isNil
		ifTrue: [false]
		ifFalse: [url _ morphProxy address.
			true]
	! !

!NmMorphProxy methodsFor: 'private' stamp: 'kuri-t 12/13/2002 17:55'!
xxxUrl
	^ url! !


!NmMorphProxy methodsFor: 'player accessing' stamp: 'mu 9/20/2002 18:04'!
player
	player isNil
		ifTrue: [player _ NmPlayerProxy for: self].
	^ player! !


!NmMorphProxy methodsFor: 'converting' stamp: 'kuri-t 11/21/2002 14:32'!
asObjectReference
	^NmMorphReference className: className uuid: uuid url: url! !


!NmMorphProxy methodsFor: 'NetMorph accessing' stamp: 'kuri-t 12/17/2002 14:20'!
address
	^ url! !

!NmMorphProxy methodsFor: 'NetMorph accessing' stamp: 'kuri-t 12/3/2002 18:04'!
identifier
	^ uuid! !


!NmMorphProxy methodsFor: 'classification' stamp: 'mu 12/11/2002 14:54'!
isMorph
	^true! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmMorphProxy class
	instanceVariableNames: ''!

!NmMorphProxy class methodsFor: 'instance creation' stamp: 'mu 9/12/2002 17:01'!
className: className uuid: uuid url: url 
	^ self new
		xxxInitClassName: className
		uuid: uuid
		url: url! !

!NmMorphProxy class methodsFor: 'instance creation' stamp: 'kuri-t 12/13/2002 14:29'!
on: aMorph 
	^ self on: aMorph url: NmUrl local! !

!NmMorphProxy class methodsFor: 'instance creation' stamp: 'kuri-t 12/13/2002 14:29'!
on: aMorph url: url 
	^ self
		className: aMorph class name
		uuid: aMorph identifier
		url: url! !


NmProxy subclass: #NmPlayerProxy
	instanceVariableNames: 'costume '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-Network'!

!NmPlayerProxy methodsFor: 'system primitives' stamp: 'kuri-t 1/20/2003 19:03'!
doesNotUnderstand: aMessage 
	| return detection subject |
	super doesNotUnderstand: aMessage.
	detection _ self xxxFindMorphInLocalWorld.
	return _ detection isNil
				ifTrue: [[self costume xxxCallDispatch: aMessage target: #player]
						on: NmpGenericError , NmError
						do: [:ex | self costume xxxHandleError: ex]]
				ifFalse: [subject _ self xxxBackToReal: detection.
					subject perform: aMessage selector withArguments: aMessage arguments].
	^ return! !


!NmPlayerProxy methodsFor: 'friends' stamp: 'mu 9/20/2002 18:07'!
xxxCostume: aMorphProxy
	costume := aMorphProxy! !


!NmPlayerProxy methodsFor: 'private' stamp: 'kuri-t 1/20/2003 19:02'!
xxxBackToReal: aMorph 
	self becomeForward: aMorph player.
	^ aMorph player! !

!NmPlayerProxy methodsFor: 'private' stamp: 'kuri-t 11/29/2002 17:44'!
xxxNewObjectReference
	^ NmPlayerReference new.! !


!NmPlayerProxy methodsFor: 'costume accessing' stamp: 'mu 9/20/2002 16:46'!
costume
	^costume! !

!NmPlayerProxy methodsFor: 'costume accessing' stamp: 'kuri-t 1/20/2003 19:01'!
identifier
	^ costume identifier! !


!NmPlayerProxy methodsFor: 'debugging' stamp: 'kuri-t 10/24/2002 14:52'!
xxxDebugRepresentation
	^ Array
		with: 'NmPlayerProxy of: ' , costume printString
		! !


!NmPlayerProxy methodsFor: 'converting' stamp: 'kuri-t 11/21/2002 14:35'!
asObjectReference
	^NmPlayerReference costume: costume! !


!NmPlayerProxy methodsFor: 'name' stamp: 'kuri-t 12/3/2002 18:05'!
uniqueNameForReference
	^ '(Player fromUUIDString: ', self costume identifier asString printString, ')'
! !


!NmPlayerProxy methodsFor: 'misc' stamp: 'kuri-t 12/3/2002 16:34'!
isPlayerLike
	^ true! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmPlayerProxy class
	instanceVariableNames: ''!

!NmPlayerProxy class methodsFor: 'instance creation' stamp: 'mu 9/20/2002 18:08'!
for: aMorphProxy
	| inst |
	inst _ self new.
	inst xxxCostume: aMorphProxy.
	^inst! !

!NmPlayerProxy class methodsFor: 'instance creation' stamp: 'kuri-t 12/13/2002 15:23'!
on: aPlayer 
	| morphProxy |
	morphProxy _ aPlayer costume isProxy
				ifTrue: [aPlayer costume]
				ifFalse: [aPlayer costume asProxy].
	^ self for: morphProxy! !


NmNotification subclass: #NmWarpedOutNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-Network'!

!NmWarpedOutNotification methodsFor: 'exceptionDescription' stamp: 'kuri-t 2/7/2003 17:33'!
defaultAction
	self resume: false! !
