RectangleMorph subclass: #NmUrlMorph
	instanceVariableNames: 'url textMorph exists '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-WorldMap'!

!NmUrlMorph methodsFor: 'accessing' stamp: 'mu 3/24/2003 01:17'!
exists
	^ exists! !

!NmUrlMorph methodsFor: 'accessing' stamp: 'mu 3/24/2003 01:17'!
exists: aBoolean
	 exists _ aBoolean! !

!NmUrlMorph methodsFor: 'accessing' stamp: 'mu 4/12/2003 19:36'!
host
	^ url host! !

!NmUrlMorph methodsFor: 'accessing' stamp: 'ns 9/17/2002 16:38'!
port
	^ url port! !

!NmUrlMorph methodsFor: 'accessing' stamp: 'ns 9/17/2002 13:50'!
text
	^ textMorph contents asString! !

!NmUrlMorph methodsFor: 'accessing' stamp: 'ns 9/17/2002 13:49'!
url
	^ url! !

!NmUrlMorph methodsFor: 'accessing' stamp: 'mu 4/12/2003 19:38'!
url: anUrl 
	| string |
	url _ anUrl.
	(url host isNil
			or: [url host isEmpty])
		ifTrue: [^ self text: String new].
	string _ url host , String cr , url port printString.
	self text: string! !


!NmUrlMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 17:13'!
defaultCellWidth
	^ self class defaultCellWidth! !

!NmUrlMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 17:13'!
defaultExistsColor
	^ self class defaultExistsColor! !

!NmUrlMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 17:14'!
defaultMapColor
	^ self class defaultMapColor! !


!NmUrlMorph methodsFor: 'dropping/grabbing' stamp: 'mu 4/15/2003 03:02'!
wantsToBeDroppedInto: aMorph 
	^(aMorph isKindOf: NmWorldMapRowMorph) or: [aMorph isKindOf: TrashCanMorph]
		! !


!NmUrlMorph methodsFor: 'initialization' stamp: 'mu 4/12/2003 20:54'!
initialize
	"NmUrlMorph new."
	super initialize.
	exists _ true.
	url _ NmUrl new.
	textMorph _ TextMorph new.
	textMorph centered.
	textMorph borderWidth: 4.
	textMorph borderColor: Color transparent.
	textMorph width: self defaultCellWidth.
	textMorph lock.
	self addMorphCentered: textMorph;
		 clipSubmorphs: true;
		 setBorderStyle: #complexAltInset.
	self color: self defaultMapColor;
		 width: self defaultCellWidth.
	self text:  ' '.! !


!NmUrlMorph methodsFor: 'private' stamp: 'mu 3/24/2003 01:11'!
computeMapColor
	^url isLocal ifTrue: [self class defaultLocalColor] ifFalse: [self class defaultExistsColor]! !

!NmUrlMorph methodsFor: 'private' stamp: 'mu 4/12/2003 21:12'!
text: aText 
	aText withBlanksTrimmed isEmpty
		ifTrue: [self exists: false]
		ifFalse: [self exists: true].
	textMorph contents: aText asString.
	textMorph position: bounds center - (textMorph extent // 2).
	textMorph lock.
	self exists
		ifTrue: [self color: self computeMapColor.
			self setBorderStyle: #complexAltRaised]
		ifFalse: [textMorph contents: ' '.
			self setBorderStyle: #complexAltInset.
			self color: self defaultMapColor].
	self setBalloonText: aText! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmUrlMorph class
	instanceVariableNames: ''!

!NmUrlMorph class methodsFor: 'scripting' stamp: 'ns 9/17/2002 15:49'!
additionsToViewerCategories
	^ #(#additionsToViewerCategoryBasic #additionsToViewerCategoryScripts #additionsToViewerCategoryColorAndBorder #additionsToViewerCategoryGeometry #additionsToViewerCategoryMiscellaneous #additionsToViewerCategoryButton #additionsToViewerCategoryMotion #additionsToViewerCategoryObservation #additionsToViewerCategoryPenUse #additionsToViewerCategoryLayout #additionsToViewerCategoryDragAndDrop #additionsToViewerCategoryScripting #additionsToViewerCategoryTests #additionsToViewerCategoryNmUrl )
		select: [:aSelector | self respondsTo: aSelector]
		thenCollect: [:aSelector | self perform: aSelector]! !

!NmUrlMorph class methodsFor: 'scripting' stamp: 'mu 4/12/2003 19:38'!
additionsToViewerCategoryNmUrl
	"Answer viewer additions for the 'URL' category"

	^#(
		URL 
		(
"			(slot url 'url' String	readWrite Player getUrl Player setUrl:)"
			(slot host 'host' String	readWrite Player getAuthority Player setAuthority:)
"			(slot path 'path' String	readWrite Player getPath Player setPath:)"
			(slot port 'port' Number readWrite Player getPort Player  setPort:)
			(slot ipAddress 'ip address' String readOnly Player getIpAddress unused  unused)
		)
	)
! !

!NmUrlMorph class methodsFor: 'scripting' stamp: 'mu 4/12/2003 19:39'!
additionsToViewerCategoryNmUrlDeluxe
	"Answer viewer additions for the 'URL' category"

	^#(
		URL 
		(
			(slot url 'url' String	readWrite Player getUrl Player setUrl:)
			(slot fragment 'fragment' String	readWrite Player getFragment Player setFragment:)
			(slot scheme 'scheme' String	readWrite Player getScheme Player setScheme:)
			(slot host 'host' String	readWrite Player getAuthority Player setAuthority:)
			(slot path 'path' String	readWrite Player getPath Player setPath:)
			(slot query 'query' String	readWrite Player getQuery Player setQuery:)
			(slot port 'port' Number readWrite Player getPort Player  setPort:)
			(slot realm 'realm' String	readWrite Player getRealm Player setRealm:)
		)
	)
! !


!NmUrlMorph class methodsFor: 'instance creation' stamp: 'ns 9/17/2002 17:09'!
url: anUrl 
	| urlMorph |
	urlMorph _ self new.
	urlMorph url: anUrl.
	^ urlMorph! !


!NmUrlMorph class methodsFor: 'constants' stamp: 'ns 9/17/2002 17:13'!
defaultCellWidth
	^ 75! !

!NmUrlMorph class methodsFor: 'constants' stamp: 'mu 3/24/2003 01:09'!
defaultExistsColor
	^ Color tan! !

!NmUrlMorph class methodsFor: 'constants' stamp: 'mu 3/24/2003 01:12'!
defaultLocalColor
	^ Color lightCyan lighter! !

!NmUrlMorph class methodsFor: 'constants' stamp: 'ns 9/17/2002 17:13'!
defaultMapColor
	^ Color lightGray! !


NmUrlMorph subclass: #NmDestinationMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-WorldMap'!

!NmDestinationMorph methodsFor: 'actions' stamp: 'mu 4/14/2003 20:17'!
destination
	(url notNil and: [url host notEmpty]) ifTrue: [^url].
	^self text! !

!NmDestinationMorph methodsFor: 'actions' stamp: 'mu 4/15/2003 19:29'!
setDestinationFromName: destinationName 
	| destinationUrl | 
	destinationUrl _ destinationName asUrl.
	destinationUrl isNmUrl
		ifTrue: [self url: destinationUrl]
		ifFalse: [self text: destinationName]! !


!NmDestinationMorph methodsFor: 'private' stamp: 'mu 4/14/2003 20:17'!
computeMapColor
	^(self destination asString = NmWorldMap localName) ifTrue: [self class defaultLocalColor] ifFalse: [self class defaultExistsColor]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmDestinationMorph class
	instanceVariableNames: ''!

!NmDestinationMorph class methodsFor: 'instance creation' stamp: 'mu 4/12/2003 19:50'!
name: destinationName
	| inst |
	inst _ self new.
	inst setDestinationFromName: destinationName.
	^inst ! !


AlignmentMorph subclass: #NmWorldMapMorph
	instanceVariableNames: 'column startPoint dicDiff '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-WorldMap'!

!NmWorldMapMorph methodsFor: 'initialization' stamp: 'mu 4/15/2003 02:23'!
createWindow
	self prepareOpen.
	^self! !

!NmWorldMapMorph methodsFor: 'initialization' stamp: 'mu 4/15/2003 03:17'!
initSubPanels
	self addButtonRow.
	self addMap.! !

!NmWorldMapMorph methodsFor: 'initialization' stamp: 'mu 4/15/2003 03:17'!
initialize
	super initialize.
	self fillStyle: self mapMorphFillStyle.
	self hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	borderWidth _ 2.
	self listDirection: #topToBottom.
	self cornerStyle: #square.
	self layoutInset: 4.
	self initSubPanels! !

!NmWorldMapMorph methodsFor: 'initialization' stamp: 'mu 4/16/2003 02:38'!
openInWorld
	"NmWorldMapMorph new openInWorld."
	self createWindow.
	super openInWorld! !


!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 12:21'!
backgroundColor
	^ Color gray: 0.9! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 12:21'!
buttonFillStyle
	| fill |
	fill _ GradientFillStyle ramp: {0.0
					-> (Color
							r: 0.742
							g: 0.903
							b: 1.0). 1.0
					-> (Color
							r: 0.516
							g: 0.71
							b: 1.0)}.
	fill origin: self bounds topLeft + (14 @ 3).
	fill direction: 8 @ 6.
	fill radial: false.
	^ fill! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/11/2002 19:29'!
defaultButtonClass
	^ SimpleButtonMorph! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/11/2002 18:22'!
defaultCellWidth
	^ 75! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/11/2002 18:06'!
defaultExistsColor
	^ Color tan! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ka 1/10/2003 12:05'!
defaultInset
	^ self class defaultInset! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/11/2002 18:06'!
defaultMapColor
	^ Color lightGray! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 12:21'!
defaultOwnerClass
	^ SystemWindow! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 12:22'!
mapMorphFillStyle
	| fill |
	fill _ GradientFillStyle ramp: {0.0
					-> (Color
							r: 0.355
							g: 0.548
							b: 1.0). 1.0
					-> (Color
							r: 0.774
							g: 0.935
							b: 1.0)}.
	fill origin: self bounds topLeft + (61 @ 7).
	fill direction: 33 @ 37.
	fill radial: false.
	^ fill! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 12:22'!
minimumExtent
	| width height |
	width _ height _ 0.
	self submorphs
		do: [:each | 
			width _ width max: each extent x.
			height _ height + each extent y].
	(self owner isKindOf: self defaultOwnerClass)
		ifTrue: [height _ height + self owner labelHeight + 20.
			width _ width + 20].
	^ width @ height! !


!NmWorldMapMorph methodsFor: 'action' stamp: 'mu 4/15/2003 01:21'!
addMapRow
	column ifNil: [^self].
	column addMorphBack: (self makeRow)! !

!NmWorldMapMorph methodsFor: 'action' stamp: 'mu 4/15/2003 02:57'!
close
	(PopUpMenu confirm: 'Store to server?') ifTrue: [self store].
	(self owner isKindOf: self defaultOwnerClass)
		ifTrue: [^ self owner closeBoxHit].
	^ self delete! !

!NmWorldMapMorph methodsFor: 'action' stamp: 'mu 4/15/2003 15:09'!
inspectMap
	NmWorldMap map inspect! !

!NmWorldMapMorph methodsFor: 'action' stamp: 'mu 4/15/2003 03:18'!
load
	[NmWorldMap loadAndUpdate]
		on: Error
		do: [self inform: 'WorldMap loading failed!!'.
			^ self].
	self
		submorphsDo: [:each | each delete].
	self initSubPanels! !

!NmWorldMapMorph methodsFor: 'action' stamp: 'mu 4/15/2003 16:52'!
setLocalInfo
	| point name defaultName oldOwner nameAsUrl |
	point _ FillInTheBlank request: 'Where is your location at map?' initialAnswer: NmWorldMap localPoint printString.
	point isEmpty
		ifTrue: [^ self].
	point _ Point readFrom: point.
	defaultName _ NmWorldMap
				at: point
				ifAbsent: [| imageName defaultImageName | 
					imageName _ FileDirectory localNameFor: Smalltalk imageName.
					defaultImageName _ imageName copyFrom: 1 to: imageName size - 6.
					defaultImageName , ' ' , Utilities authorInitials].
	name _ FillInTheBlank request: 'What is your location name?' initialAnswer: defaultName.
	name isEmpty	ifTrue: [^ self].
	nameAsUrl _ name asUrl.
	(( nameAsUrl isNmUrl) and: [nameAsUrl ~= NmUrl local]) ifTrue:[(PopUpMenu confirm: 'The url does not match your local url. Continue anyway?') ifFalse:[^self]].
	
	oldOwner _ NmWorldMap at: point. 
	oldOwner notNil ifTrue: [NmWorldMap map at: NmWorldMap localPoint put: oldOwner ]. 

	NmWorldMap localPoint: point.
	NmWorldMap localName: name.
	NmWorldMap at: point put: name.
	self
		submorphsDo: [:each | each delete].
	self initSubPanels! !

!NmWorldMapMorph methodsFor: 'action' stamp: 'mu 4/15/2003 17:19'!
store
	| columnSize index dic |
	columnSize _ column submorphs size.
	index _ startPoint y.
	dic _ Dictionary new.
	columnSize
		to: 1
		by: -1
		do: [:y | 
			| alignmentMorph cellsize | 
			alignmentMorph _ column submorphs at: y.
			cellsize _ alignmentMorph submorphs size.
			1
				to: cellsize
				do: [:x | 
					| destinationMorph point | 
					destinationMorph _ alignmentMorph submorphs at: x.
					point _ x @ index.
					point _ point + startPoint - (1 @ 0).
					dic at: point put: destinationMorph destination].
			index _ index + 1].
	dicDiff
		keysAndValuesDo: [:point :dest | dic at: point put: dest].
	column ifNotNil: [column color: self backgroundColor].
	NmWorldMap map: dic.
	NmWorldMap store.
	
	! !


!NmWorldMapMorph methodsFor: 'event handling' stamp: 'ns 9/11/2002 18:59'!
handlesMouseDown: evt 
	^ true! !

!NmWorldMapMorph methodsFor: 'event handling' stamp: 'ka 1/10/2003 15:07'!
morphToGrab: event
	| morphs morph |
	morphs _ self morphsAt: event position.
	morphs isEmpty
		ifTrue: [^ nil].
	morph _ morphs first.
	(morph isKindOf: TextMorph)
		ifTrue: [^ morph owner].
	(morph isMemberOf: BorderedMorph)
		ifTrue: [^ morph].
	(morph isKindOf: AlignmentMorph)
		ifTrue: [(morph submorphOfClass: self defaultButtonClass) notNil
				ifTrue: [^ nil]
				ifFalse: [(morph submorphOfClass: AlignmentMorph) notNil
						ifTrue: [^ nil]
						ifFalse: [^ morph]]].
	^ nil! !

!NmWorldMapMorph methodsFor: 'event handling' stamp: 'mu 4/15/2003 17:17'!
mouseDown: evt
	"Handle a mouse down event."
	| grabbedMorph handHadHalos |
	grabbedMorph _ self morphToGrab: evt.
	grabbedMorph ifNotNil:[
		column ifNotNil:[column color: Color red].
		grabbedMorph isSticky ifTrue:[^self].
		self isPartsBin ifFalse:[ | result | 
			result _ evt hand grabMorph: grabbedMorph.
			^ result].
		grabbedMorph _ grabbedMorph partRepresented duplicate.
		grabbedMorph restoreSuspendedEventHandler.
		(grabbedMorph fullBounds containsPoint: evt position) 
			ifFalse:[grabbedMorph position: evt position].
		"Note: grabbedMorph is ownerless after duplicate so use #grabMorph:from: instead"
		^evt hand grabMorph: grabbedMorph from: self].
	(super handlesMouseDown: evt)
		ifTrue:[^super mouseDown: evt].
	handHadHalos _ evt hand halo notNil.
	evt hand halo: nil. "shake off halos"
	evt hand releaseKeyboardFocus. "shake of keyboard foci"
	evt shiftPressed ifTrue:[
		^evt hand 
			waitForClicksOrDrag: self 
			event: evt 
			selectors: { #findWindow:. nil. nil. #dragThroughOnDesktop:}
			threshold: 5].
	self isWorldMorph ifTrue: [
		handHadHalos ifTrue: [^self addAlarm: #invokeWorldMenu: with: evt after: 200].
		^self invokeWorldMenu: evt
	].
	"otherwise, explicitly ignore the event if we're not the world,
	so that we could be picked up if need be"
	self isWorldMorph ifFalse:[evt wasHandled: false].
! !


!NmWorldMapMorph methodsFor: 'private' stamp: 'mu 4/15/2003 15:09'!
addButtonRow
	| buttonBar |
	buttonBar _ AlignmentMorph newRow cellInset: 2;
				 hResizing:  #shrinkWrap;
				vResizing:  #shrinkWrap;
				 color: Color transparent.
	buttonBar
		addMorphBack: (self buttonName: 'Store' action: #store).
	buttonBar
		addMorphBack: (self buttonName: 'Load' action: #load).
	buttonBar
		addMorphBack: (self buttonName: 'Add Row' action: #addMapRow).
	buttonBar
		addMorphBack: (self buttonName: 'Set Your Info' action: #setLocalInfo).
	buttonBar
		addMorphBack: (self buttonName: 'Inspect' action: #inspectMap).
	buttonBar
		addMorphBack: (self buttonName: 'Close' action: #close).
	buttonBar setBorderStyle: #complexAltInset.
	buttonBar borderWidth: 4.
	self addMorphBack: buttonBar! !

!NmWorldMapMorph methodsFor: 'private' stamp: 'mu 4/12/2003 21:01'!
addMap
	| xCol yCol map xMax xMin yMax yMin displayedURLDic |
	column _ self makeColumn.
	xCol _ OrderedCollection new.
	yCol _ OrderedCollection new.
	map _ NmWorldMap map.
	map isEmpty ifTrue: [self inform: 'WorldMap is empty!!'. ^self].
	map
		keysDo: [:each | 
			xCol add: each x.
			yCol add: each y].
	xMax _ (xCol
				detectMax: [:x | x])
				min: 3.
	xMin _ xCol
				detectMin: [:x | x].
	yMax _ (yCol
				detectMax: [:y | y])
				min: 4.
	yMin _ yCol
				detectMin: [:y | y].
	startPoint _ xMin @ yMin.
	displayedURLDic _ Dictionary new.
	yMin
		to: yMax
		do: [:y | 
			| row | 
			row _ self makeRow.
			xMin
				to: xMax
				do: [:x | 
					| destination destMorph | 
					destination _ map
								at: x @ y
								ifAbsent: [].
					destMorph _ NmDestinationMorph new.
					destination isNil
						ifFalse: [
							displayedURLDic at: x @ y put: destination.
							destMorph setDestinationFromName: destination.].
					row addMorphBack: destMorph].
			column addMorph: row].
	dicDiff _ map
				reject: [:each | displayedURLDic includes: each].
	column layoutChanged.
	self addMorphBack: column! !

!NmWorldMapMorph methodsFor: 'private' stamp: 'mu 4/15/2003 01:01'!
buttonName: aString action: aSymbol 
	^ self defaultButtonClass new target: self;
		 label: aString;
		 actionSelector: aSymbol;
		
		color: (Color gray: 0.8);
		 fillStyle: self buttonFillStyle;
		 borderWidth: 4;
		 borderColor: #complexAltRaised;
		 cornerStyle: #square! !

!NmWorldMapMorph methodsFor: 'private' stamp: 'ka 1/10/2003 11:53'!
makeColumn
	"self basicNew makeColumn"
	column _ AlignmentMorph newColumn.
	column cellInset: self defaultInset;
		 layoutInset: self defaultInset.
	column enableDragNDrop; vResizing: #shrinkWrap; hResizing: #shrinkWrap; layoutInset: self defaultInset; borderColor: Color black; borderWidth: 1; wrapCentering: #left; cellPositioning: #topLeft.
	column enableDragNDrop: true.
	column setBorderStyle: #complexAltInset.
	column borderWidth: 4.
	column color: self backgroundColor.
	^ column! !

!NmWorldMapMorph methodsFor: 'private' stamp: 'ka 1/10/2003 12:11'!
makeRow
	"self basicNew makeRow openInHand"
	^ self class makeRow! !

!NmWorldMapMorph methodsFor: 'private' stamp: 'ns 9/17/2002 12:22'!
prepareOpen
	(self owner isKindOf: self defaultOwnerClass)
		ifTrue: [| closeButtonMorph | 
			closeButtonMorph _ self allMorphs
						detect: [:each | (each isKindOf: self defaultButtonClass)
								and: [each actionSelector == #actionClose]]
						ifNone: [].
			closeButtonMorph notNil
				ifTrue: [closeButtonMorph delete]]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmWorldMapMorph class
	instanceVariableNames: 'soleInstance '!

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'ns 9/17/2002 12:19'!
createWindow
	| window |
	window _ self new createWindow.
	^ window! !

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'ka 12/19/2002 15:28'!
new
	soleInstance isNil
		ifTrue: [soleInstance _ self basicNew].
	soleInstance initialize.
	ActiveWorld restoreMorphicDisplay.
	^ soleInstance! !

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'ns 9/12/2002 11:37'!
open
	^ NmWorldMapMorph new openInWorld! !


!NmWorldMapMorph class methodsFor: 'constants' stamp: 'ka 1/10/2003 12:26'!
defaulfRowExtent
	^ 93 @ 58! !

!NmWorldMapMorph class methodsFor: 'constants' stamp: 'ka 1/10/2003 12:05'!
defaultInset
	^ 16! !


!NmWorldMapMorph class methodsFor: 'parts bin' stamp: 'ka 1/10/2003 14:43'!
makeRow
	"self makeRow openInHand"
	| row |
	row _ NmWorldMapRowMorph newRow.
	row cellInset: self defaultInset;
		 layoutInset: self defaultInset.
	row enableDragNDrop; vResizing: #shrinkWrap; hResizing: #shrinkWrap; layoutInset: 8; borderColor: Color black; borderWidth: 1; wrapCentering: #left; cellPositioning: #topLeft.
	row setBorderStyle: #complexFramed.
	row extent: self defaulfRowExtent.
	^ row! !


AlignmentMorph subclass: #NmWorldMapRowMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-WorldMap'!

!NmWorldMapRowMorph methodsFor: 'dropping/grabbing' stamp: 'mu 4/15/2003 02:20'!
wantsToBeDroppedInto: aMorph 
	^ (aMorph isKindOf: self class) not
		! !
