Error subclass: #NmpGenericError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Network-Protocol'!


NmpGenericError subclass: #NmpCannotConnect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Network-Protocol'!


Object subclass: #NmpGenericServer
	instanceVariableNames: 'connectionQueue isListening currentPort listeningProcess '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Network-Protocol'!

!NmpGenericServer methodsFor: 'initialize-release' stamp: 'mu 12/4/2002 17:19'!
initialize
	NmpObject crShow: 'initializing network ... '.
	Socket initializeNetworkIfFail: [^NmpObject show:' Failed!!!!'].
	NmpObject crShow:'ok '.
	isListening _ false.
	currentPort _ nil.
	! !

!NmpGenericServer methodsFor: 'initialize-release' stamp: 'mu 11/26/2002 17:18'!
release
	
	self stop.
	self initialize.! !


!NmpGenericServer methodsFor: 'accessing' stamp: 'mu 12/6/2002 14:37'!
currentPort
	^currentPort! !


!NmpGenericServer methodsFor: 'testing' stamp: 'mu 12/6/2002 14:39'!
isRunning
	^isListening! !


!NmpGenericServer methodsFor: 'actions' stamp: 'mu 12/3/2002 18:26'!
restart: portNumber
	self stop.
	self start: portNumber! !

!NmpGenericServer methodsFor: 'actions' stamp: 'mu 12/3/2002 18:03'!
start
	self start: self class defaultPort! !

!NmpGenericServer methodsFor: 'actions' stamp: 'mu 12/4/2002 17:19'!
start: portNumber
	isListening
		ifFalse: [
			currentPort _ portNumber.
			connectionQueue _ ConnectionQueue portNumber: currentPort queueLength: self class defaultConnectionCount. 
			listeningProcess _ [self listenLoop] newProcess.
			listeningProcess priority: Processor highIOPriority.
			listeningProcess resume].
	isListening _ true! !

!NmpGenericServer methodsFor: 'actions' stamp: 'mu 4/11/2003 14:50'!
stop
	isListening
		ifTrue: [listeningProcess
				ifNotNil: [listeningProcess terminate.
					listeningProcess _ nil].
			connectionQueue
				ifNotNil: [connectionQueue destroy.
					NmpObject crShow: '#connectionQueue destroyed# '.
					connectionQueue _ nil]].
	isListening _ false.
	NmpObject crShow: 'stop'; crShow: ''! !


!NmpGenericServer methodsFor: 'private' stamp: 'mu 4/11/2003 14:51'!
listenLoop
	
	NmpObject show: '  listen'.
	[true] whileTrue: [ | receptorSocket |
		receptorSocket _ connectionQueue getConnectionOrNilLenient.
		receptorSocket ifNil: [
			(Delay forMilliseconds: 80) wait
		] ifNotNil: [ 
			self receptorClass new receiveDataOn: receptorSocket.
		]
	].! !


!NmpGenericServer methodsFor: 'factory' stamp: 'MU 11/29/2002 16:54'!
receptorClass
	^NmpGenericReceptor! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmpGenericServer class
	instanceVariableNames: 'default '!

!NmpGenericServer class methodsFor: 'instance creation' stamp: 'MU 11/29/2002 15:07'!
default
	default ifNil: [default := self basicNew initialize].
	^default! !

!NmpGenericServer class methodsFor: 'instance creation' stamp: 'MU 11/29/2002 15:07'!
new
	^self shouldNotImplement! !


!NmpGenericServer class methodsFor: 'class initialization' stamp: 'mu 11/26/2002 18:18'!
initialize
	"NmpGenericServer initialize"
	default := nil! !


!NmpGenericServer class methodsFor: 'constants' stamp: 'mu 12/4/2002 17:32'!
defaultConnectionCount
	^8! !

!NmpGenericServer class methodsFor: 'constants' stamp: 'MU 12/3/2002 11:36'!
defaultPort
	^44444! !


NmpGenericError subclass: #NmpInvalidSocketConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Network-Protocol'!


Object subclass: #NmpObject
	instanceVariableNames: 'socket process toSendQueue firstRead headerBufferStream header headerArray bodySize body receivedObject '
	classVariableNames: 'CRLF IsDebugging Platform '
	poolDictionaries: ''
	category: 'NM-Network-Protocol'!

!NmpObject methodsFor: 'sending' stamp: 'MU 12/2/2002 16:25'!
loopSendData
	| nextSend |
	nextSend _ toSendQueue next.
	nextSend isNil
		ifFalse: [self
				basicSendObject: (nextSend at: 1)
				semantic: (nextSend at: 2)
				command: (nextSend at: 3)
				by: (nextSend at: 4).
			NmpObject space; show: #loopSendData]! !

!NmpObject methodsFor: 'sending' stamp: 'MU 12/2/2002 18:19'!
onewaySend: object 
	self
		onewaySend: object
		by: #ReferenceStream! !

!NmpObject methodsFor: 'sending' stamp: 'MU 12/2/2002 18:20'!
onewaySend: object by: encoder 
	self
		onewaySend: object
		command: #Request
		by: encoder! !

!NmpObject methodsFor: 'sending' stamp: 'MU 12/2/2002 18:18'!
onewaySend: object command: commandString 
	self
		onewaySend: object
		command: commandString
		by: #ReferenceStream! !

!NmpObject methodsFor: 'sending' stamp: 'MU 12/2/2002 18:18'!
onewaySend: object command: commandString by: encoder 
	| sendData |
	sendData _ Array
				with: object
				with: #ONEWAY
				with: commandString
				with: encoder.
	
	toSendQueue nextPut: sendData! !

!NmpObject methodsFor: 'sending' stamp: 'MU 12/2/2002 18:23'!
onewaySendArray: arrayOfByteObjects 
	self onewaySendArray: arrayOfByteObjects by: #ReferenceStream! !

!NmpObject methodsFor: 'sending' stamp: 'MU 12/2/2002 18:22'!
onewaySendArray: arrayOfByteObjects by: encoder
	self 
		onewaySendArray: arrayOfByteObjects
		command: #REQUEST
		by: encoder! !

!NmpObject methodsFor: 'sending' stamp: 'MU 12/2/2002 18:22'!
onewaySendArray: arrayOfByteObjects command: comandString 
	self
		onewaySendArray: arrayOfByteObjects
		command: comandString
		by: #ReferenceStream! !

!NmpObject methodsFor: 'sending' stamp: 'MU 12/2/2002 18:22'!
onewaySendArray: arrayOfByteObjects command: comandString by: encoder
	arrayOfByteObjects
		do: [:each | 
			| sendData | 
			sendData _ Array
						with: each
						with: #'ONEWAY,MANY'
						with: comandString
						with: encoder.
			toSendQueue nextPut: sendData]! !

!NmpObject methodsFor: 'sending' stamp: 'MU 12/2/2002 18:19'!
send: object 
	^self
		send: object
		by: #ReferenceStream! !

!NmpObject methodsFor: 'sending' stamp: 'MU 12/2/2002 18:16'!
send: object by: encoder 
	^ self
		send: object
		command: #REQUEST
		by: encoder! !

!NmpObject methodsFor: 'sending' stamp: 'MU 11/29/2002 19:33'!
send: object command: commandString
	^ self
		send: object
		command: commandString
		by: #ReferenceStream! !

!NmpObject methodsFor: 'sending' stamp: 'MU 12/29/2002 17:42'!
send: object command: commandString by: encoder 
	| dataComing |
	dataComing _ false.
	self
		basicSendObject: object
		semantic: #NONE
		command: commandString
		by: encoder.
	self
		ensureSocketDo: [dataComing _ socket
						waitForDataUntil: (Socket deadlineSecs: self class defaultSendTimeoutSeconds)].
	dataComing
		ifFalse: [self close.
			^ NmpInvalidSocketConnection signal: 'Data not coming'].
	self receiveOneMessage.
	(header isEmpty
			and: [receivedObject isNil])
		ifTrue: [self receiveOneMessage.
			header isEmpty
				ifTrue: [self close.
					^ NmpInvalidSocketConnection signal: 'Retried but header data not coming']].
	self signalIfError.
	^ receivedObject! !

!NmpObject methodsFor: 'sending' stamp: 'MU 12/2/2002 18:26'!
sendArray: arrayOfByteObjects 
	^ self sendArray: arrayOfByteObjects by: #ReferenceStream! !

!NmpObject methodsFor: 'sending' stamp: 'MU 12/2/2002 18:26'!
sendArray: arrayOfByteObjects by: encoder 
	^ self
		sendArray: arrayOfByteObjects
		command: #REQUEST
		by: #ReferenceStream! !

!NmpObject methodsFor: 'sending' stamp: 'MU 12/2/2002 18:25'!
sendArray: arrayOfByteObjects command: commandString 
	^ self
		sendArray: arrayOfByteObjects
		command: commandString
		by: #ReferenceStream! !

!NmpObject methodsFor: 'sending' stamp: 'MU 12/29/2002 17:42'!
sendArray: arrayOfByteObjects command: commandString by: encoder 
	"NOT SERIOUSLY IMPLEMENTED"
	| dataComing |
	arrayOfByteObjects
		do: [:each | self
				basicSendObject: each
				semantic: #MANY
				command: commandString
				by: encoder].
	dataComing _ socket
				waitForDataUntil: (Socket deadlineSecs: self class defaultSendTimeoutSeconds).
	dataComing
		ifFalse: [self close.
			^ NmpInvalidSocketConnection signal: 'Data not coming'].
	self receiveOneMessage.
	(header isEmpty
			and: [receivedObject isNil])
		ifTrue: [self receiveOneMessage.
			header isEmpty
				ifTrue: [self close.
					^ NmpInvalidSocketConnection signal: 'Retried but header data not coming']].
	self signalIfError.
	^ receivedObject! !


!NmpObject methodsFor: 'returning' stamp: 'MU 11/29/2002 16:17'!
return: object 
	^self return: object by: #ReferenceStream ! !

!NmpObject methodsFor: 'returning' stamp: 'MU 12/3/2002 11:54'!
return: object by: encoder 
	self
		basicSendObject: object
		semantic: #ONEWAY
		command: #RETURN
		by: encoder.
	
	! !

!NmpObject methodsFor: 'returning' stamp: 'MU 11/29/2002 16:18'!
returnArray: arrayOfByteObjects 
	^self returnArray: arrayOfByteObjects by: #ReferenceStream ! !

!NmpObject methodsFor: 'returning' stamp: 'MU 12/3/2002 11:55'!
returnArray: arrayOfByteObjects by: encoder 
	arrayOfByteObjects
		do: [:each | self
				basicSendObject: each
				semantic: #'ONEWAY,MANY'
				command: #RETURN
				by: encoder].
	! !

!NmpObject methodsFor: 'returning' stamp: 'mu 12/4/2002 17:50'!
returnError: error 
	self returnError: error by: #DataStream! !

!NmpObject methodsFor: 'returning' stamp: 'mu 12/4/2002 17:57'!
returnError: error by: encoder 
	self
		basicSendObject: (Array with: error class name with: error messageText with: (self shortStackFrom: error ))
		semantic: #ONEWAY
		command: #ERROR
		by: encoder.
	
	! !


!NmpObject methodsFor: 'receiving' stamp: 'MU 12/3/2002 11:45'!
handleReceived: object semantic: semanticString command: commandString encoder: encoderString
	receivedObject _ object.
		
	IsDebugging ifTrue: [
	NmpObject crShow: Time now printString.
	NmpObject crShow: '-command ', commandString printString.
	NmpObject crShow: '-semantic ', semanticString printString.
	NmpObject crShow: '-encoder ', encoderString printString.
	NmpObject crShow: '-object ', receivedObject printString.
	NmpObject crShow: '-remoteAddress ', socket  remoteAddress printString.
	].
	
	"Subclass do some method invocation with receivedObject and return value"
	^nil
	
	! !

!NmpObject methodsFor: 'receiving' stamp: 'mu 12/10/2002 17:05'!
handleReturn: returnedObject semantic: semanticArray command: commandString encoder: encoderString 
	
	(commandString = 'ERROR' or: [commandString = 'RETURN']) ifTrue: [^ nil].

	(semanticArray includes: 'ONEWAY') ifTrue: [^self].
	
	(semanticArray includes: 'MANY')
		ifTrue: [^self returnArray: returnedObject by: encoderString].
	
	^self return: returnedObject by: encoderString
	! !

!NmpObject methodsFor: 'receiving' stamp: 'mu 12/3/2002 19:44'!
processHeader
	| semantic |
	header isEmpty ifTrue: [^self].
	headerArray _ header substrings.
	semantic _ self semanticOf: headerArray.
	self semanticOf: headerArray put: (semantic findTokens: #($,)) asArray! !

!NmpObject methodsFor: 'receiving' stamp: 'mu 12/4/2002 10:36'!
receiveBody
	| sizeStr bodyStr |
	header isEmpty
		ifTrue: [self resetReceiveVariables.
			^ body].
	sizeStr _ self sizeOf: headerArray.
	bodySize _ (sizeStr copyFrom: 2 to: sizeStr size - 1) asNumber.
	IsDebugging
		ifTrue: [NmpObject crShow: '-bodySize: ' , sizeStr].
	bodyStr _ WriteStream
				on: (String new: bodySize).
	bodyStr nextPutAll: headerBufferStream upToEnd.
	[self socketIsSafe
		and: [bodySize > bodyStr position]]
		whileTrue: [bodyStr nextPutAll: socket getData].
	^ body _ bodyStr contents! !

!NmpObject methodsFor: 'receiving' stamp: 'mu 12/4/2002 10:48'!
receiveHeader
	| headerDivider |
	[self
		ensureSocketDo: [firstRead _ socket getData]]
		on: NmpGenericError
		do: [:ex | 
			self resetReceiveVariables.
			ex pass].
	headerDivider _ firstRead indexOf: self headerDividerMark.
	headerDivider = 0
		ifTrue: [self resetReceiveVariables.
			^ header].
	headerBufferStream _ firstRead readStream.
	header _ headerBufferStream next: headerDivider.
	^ header! !

!NmpObject methodsFor: 'receiving' stamp: 'MU 12/29/2002 02:55'!
receiveOneMessage
	| semantic command encoder object return |
	self resetReceiveVariables.
	self receiveHeader.
	header isEmpty
		ifTrue: [^ self].
	self processHeader.
	self receiveBody.
	body isEmpty
		ifTrue: [^ self].
	semantic _ self semanticOf: headerArray.
	command _ self commandOf: headerArray.
	encoder _ self encoderOf: headerArray.
	object _ self objectFromBinary: body encoder: encoder.
	return _ self
				handleReceived: object
				semantic: semantic
				command: command
				encoder: encoder.
	self
		handleReturn: return
		semantic: semantic
		command: command
		encoder: encoder! !


!NmpObject methodsFor: 'constants' stamp: 'mu 11/26/2002 18:40'!
bodySizeMark
	^$*! !

!NmpObject methodsFor: 'constants' stamp: 'MU 11/29/2002 19:58'!
headerDividerMark
	^$!!! !

!NmpObject methodsFor: 'constants' stamp: 'mu 11/27/2002 15:44'!
protocolNameAndVersion
	^'NMP01' copy! !


!NmpObject methodsFor: 'private' stamp: 'mu 12/27/2002 02:30'!
buildExceptionFrom: exceptionArray 
	| exceptionClassName exceptionClass exceptionMessageText  shortStack exception |
	exceptionClassName _ (exceptionArray at: 1) asSymbol.
	exceptionClass _ Smalltalk
				at: exceptionClassName
				ifAbsent: [Error].
	exceptionMessageText _ (exceptionArray at: 2) asSymbol.
	shortStack _ exceptionArray at: 3.
			
	exception _ exceptionClass new.
	exception tag: shortStack. 
	exception messageText: exceptionMessageText.
	^exception! !

!NmpObject methodsFor: 'private' stamp: 'mu 12/10/2002 17:59'!
close
	self resetReceiveVariables.
	socket closeAndDestroy.
	process terminate.
! !

!NmpObject methodsFor: 'private' stamp: 'MU 12/29/2002 03:01'!
resetReceiveVariables
	firstRead _ headerBufferStream _ receivedObject _ nil.
	bodySize _ 0.
	header _ body _ ''.
	headerArray _ Array new: 4! !

!NmpObject methodsFor: 'private' stamp: 'mu 12/4/2002 17:57'!
shortStackFrom: anError 

	| ctx |
	ctx := anError instVarNamed: 'initialContext'.
	^ctx isNil ifTrue: [''] ifFalse: [ctx shortStack]! !

!NmpObject methodsFor: 'private' stamp: 'mu 12/27/2002 02:30'!
signalExceptionFrom: exceptionArray 
	| exception |
	exception _ self buildExceptionFrom: exceptionArray.
	exception signal! !

!NmpObject methodsFor: 'private' stamp: 'mu 12/4/2002 17:02'!
signalIfError
	headerArray isEmpty
		ifTrue: [^ self].
	(self commandOf: headerArray)
			= 'ERROR'
		ifTrue: [self signalExceptionFrom: receivedObject]! !


!NmpObject methodsFor: 'private-header' stamp: 'MU 12/2/2002 12:41'!
commandOf: aHeaderArray
	^aHeaderArray at: 3! !

!NmpObject methodsFor: 'private-header' stamp: 'MU 12/2/2002 12:41'!
encoderOf: aHeaderArray
	^aHeaderArray at: 4! !

!NmpObject methodsFor: 'private-header' stamp: 'MU 12/2/2002 15:38'!
header: versionString semantic: semanticString command: commandString encoder: encoderString size: sizeString
	| headerStream sendHeader | 
	headerStream _ WriteStream
				on: (String new: 80).
	headerStream nextPutAll: versionString;
		 space.
	headerStream nextPutAll: semanticString;
		 space.
	headerStream nextPutAll: commandString;
		 space.
	headerStream nextPutAll: encoderString; 
		 space.
	headerStream nextPutAll: self bodySizeMark asString , sizeString , self headerDividerMark asString.
	sendHeader _ headerStream contents.
	^sendHeader! !

!NmpObject methodsFor: 'private-header' stamp: 'MU 12/2/2002 12:40'!
semanticOf: aHeaderArray
	^aHeaderArray at: 2! !

!NmpObject methodsFor: 'private-header' stamp: 'MU 12/2/2002 15:51'!
semanticOf: aHeaderArray put: newValue
	^aHeaderArray at: 2 put: newValue! !

!NmpObject methodsFor: 'private-header' stamp: 'MU 12/2/2002 12:41'!
sizeOf: aHeaderArray
	^aHeaderArray at: 5! !

!NmpObject methodsFor: 'private-header' stamp: 'mu 11/28/2002 15:03'!
versionOf: aHeaderArray
	^aHeaderArray at: 1! !


!NmpObject methodsFor: 'private-protocol' stamp: 'mu 12/4/2002 10:44'!
basicSendData: data semantic: semanticString command: command by: encoder 
	[| sendHeader sentSize toSendSize sendData | 
	sendHeader _ self header: self protocolNameAndVersion semantic: semanticString command: command encoder: encoder size: data size printString.
	sentSize _ 0.
	toSendSize _ sendHeader size + data size.
	sendData _ sendHeader , data.
	
	[sentSize < toSendSize]
		whileTrue: [self
				ensureSocketDo: [sentSize _ sentSize
								+ (socket sendSomeData: sendData startIndex: sentSize + 1)]]]
		on: Error
		do: [:ex | (self isSocketPrimitiveFailed: ex)
				ifTrue: [NmpSocketPrimitiveFailed signal]
				ifFalse: [ex pass]]! !

!NmpObject methodsFor: 'private-protocol' stamp: 'MU 12/2/2002 12:37'!
basicSendObject: object semantic: semantic command: command by: encoder
	| data |
	data := self binaryFromObject: object encoder: encoder.
	self
		basicSendData: data
		semantic: semantic
		command: command
		by: encoder! !


!NmpObject methodsFor: 'private-socket' stamp: 'mu 12/27/2002 20:29'!
ensureSocketDo: aBlock 
	self socketIsSafe
		ifTrue: [[^ aBlock value]
				on: Error
				do: [:ex | 
					(self isSocketTimeout: ex)
						ifTrue: [NmpTimeout signal].
					(self isSocketPrimitiveFailed: ex)
						ifTrue: [NmpSocketPrimitiveFailed signal].
					ex pass]]
		ifFalse: [NmpInvalidSocketConnection signal: 'Socket is invalid: ', socket printString]! !

!NmpObject methodsFor: 'private-socket' stamp: 'mu 11/26/2002 17:59'!
isSocketPrimitiveFailed: exception 
	^ exception messageText = 'a primitive has failed'! !

!NmpObject methodsFor: 'private-socket' stamp: 'mu 12/4/2002 12:27'!
isSocketTimeout: exception 
	^ exception messageText = 'getData timeout'
		or: [exception messageText = 'send data timeout; data not sent']! !

!NmpObject methodsFor: 'private-socket' stamp: 'mu 11/26/2002 18:21'!
socketIsSafe
	socket isNil ifTrue: [^false].
	socket isValid not	ifTrue: [^ false].
	self class platform == #'mac os' ifFalse: [
	socket isUnconnected	ifTrue: [^ false].
	socket isOtherEndClosed ifTrue: [^ false]].
	^ true! !


!NmpObject methodsFor: 'private-serialization' stamp: 'mu 2/20/2003 16:22'!
binaryFromObject: anObject encoder: encodingClassName
	| encoder file |
	encoder _ encodingClassName asSymbol.
	encoder = #NONE ifTrue: [^anObject isNil ifTrue: [ByteArray new:0] ifFalse: [anObject]].
	file := RWBinaryOrTextStream
				on: (ByteArray new: 5000).
	file binary.
	((Smalltalk at: encoder) on: file)
		nextPut: anObject.
	file close.
	^ file contents! !

!NmpObject methodsFor: 'private-serialization' stamp: 'mu 2/20/2003 15:57'!
objectFromBinary: bytes encoder: encodingClassName
	| object encoder |
	bytes isNil ifTrue: [^nil].
	encoder _ encodingClassName asSymbol.
	encoder = #NONE ifTrue: [^bytes].
	encoder = #SmartRefStream ifTrue: [^SmartRefStream objectFromStreamedRepresentation: bytes].
	object := (Smalltalk at: encoder) unStream: bytes.
	^ object! !


!NmpObject methodsFor: 'accessing' stamp: 'mu 12/11/2002 13:58'!
socket
	^socket! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmpObject class
	instanceVariableNames: ''!

!NmpObject class methodsFor: 'utility' stamp: 'mu 4/11/2003 14:04'!
crShow: aString
	IsDebugging ifTrue: [Transcript cr; show: aString]! !

!NmpObject class methodsFor: 'utility' stamp: 'mu 11/27/2002 16:57'!
isDebugging
	^IsDebugging! !

!NmpObject class methodsFor: 'utility' stamp: 'mu 11/27/2002 16:58'!
isDebugging: boolean
	"NmpObject isDebugging: true"
	"NmpObject isDebugging: false"
	IsDebugging _ boolean! !

!NmpObject class methodsFor: 'utility' stamp: 'mu 12/26/2002 17:31'!
log: anError 
	|  imageName filename |
	imageName _ (Smalltalk imageName findTokens: FileDirectory slash) last.
	filename _ 'nmpError', '(', imageName, ')', '.log'.
	self log: anError to: filename.! !

!NmpObject class methodsFor: 'utility' stamp: 'mu 12/26/2002 17:30'!
log: anError to: filename
	| ex file ctx stack |
	ex _ anError.
	file _ FileStream fileNamed: filename asString.
	file isNil
		ifTrue: [NmpObject crShow: 'File open failed in NmpErrorLog'.
			^ self].
	file setToEnd.
	file cr; nextPutAll: '### Original Error is... ###'.
	file cr; nextPutAll: TimeStamp current printString.
	file cr; nextPutAll: '#Receiver: ' , ex receiver printString.
	file cr; nextPutAll: '#Description: ' , ex description.
	ctx _ ex instVarNamed: 'initialContext'.
	stack _ ctx isNil
				ifTrue: ['']
				ifFalse: [ctx shortStack].
	file cr; nextPutAll: '#Stack:'.
	file cr; cr; nextPutAll: stack.
	file close! !

!NmpObject class methodsFor: 'utility' stamp: 'mu 11/26/2002 18:56'!
platform
	^Platform! !

!NmpObject class methodsFor: 'utility' stamp: 'mu 4/11/2003 14:04'!
show: aString
	IsDebugging ifTrue: [Transcript show: aString]! !


!NmpObject class methodsFor: 'class initialization' stamp: 'mu 4/11/2003 14:30'!
initialize
	"NmpObject initialize"
	IsDebugging _ false.
	CRLF _ String with: Character cr with: Character lf.
	Smalltalk addToStartUpList: self.
	self startUp
	! !

!NmpObject class methodsFor: 'class initialization' stamp: 'mu 11/22/2002 17:07'!
obsolete
	Smalltalk removeFromStartUpList: self.
! !


!NmpObject class methodsFor: 'start up/shut down' stamp: 'mu 11/26/2002 18:55'!
startUp
	Platform := Smalltalk platformName asLowercase asSymbol.! !


!NmpObject class methodsFor: 'constants' stamp: 'MU 12/29/2002 17:41'!
defaultSendTimeoutSeconds
	^5! !


NmpObject subclass: #NmpGenericConnector
	instanceVariableNames: 'ipAddress port isConnected '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Network-Protocol'!

!NmpGenericConnector methodsFor: 'initialize' stamp: 'mu 12/11/2002 10:57'!
connect: ipAddressOrHost port: portNumber 
	^self connect: ipAddressOrHost port: portNumber timeout: self class defaultTimeoutSeconds! !

!NmpGenericConnector methodsFor: 'initialize' stamp: 'mu 12/11/2002 10:56'!
connect: ipAddressOrHost port: portNumber timeout: timeoutSeconds
	ipAddress _ ipAddressOrHost.
	port _ portNumber.
	Socket initializeNetwork.
	socket _ Socket newTCP.
	toSendQueue _ SharedQueue new.
	isConnected _ self tryConnect: timeoutSeconds.
	isConnected ifFalse: [NmpCannotConnect signal: 'Server does not respond: ', ipAddressOrHost , ':' , portNumber printString].
	process _ [isConnected
				ifTrue: [[NmpObject show: #CONNECTER:SEND:LOOP.
					self loopSendData.
					self isConnected] whileTrue.
					NmpObject show: #CONNECTER:UNCONNECTED.
					socket closeAndDestroy]
				ifFalse: [NmpObject show: #CONNECTER:END.]] newProcess.
	process priority: Processor highIOPriority.
	process resume! !


!NmpGenericConnector methodsFor: 'actions' stamp: 'MU 12/2/2002 16:25'!
close
	super close.
	isConnected _ false.
	! !


!NmpGenericConnector methodsFor: 'private-protocol' stamp: 'mu 12/4/2002 15:24'!
basicSendData: data semantic: semanticString command: command by: encoder 
	^ [super
		basicSendData: data
		semantic: semanticString
		command: command
		by: encoder]
		on: NmpGenericError
		do: [:ex | 
			self close.
			ex pass]! !


!NmpGenericConnector methodsFor: 'private' stamp: 'MU 2/25/2003 16:28'!
tryConnect: timeoutSeconds
	| addr |
	addr _ NetNameResolver addressForName: ipAddress  timeout: self class resolveTimeoutSeconds.
	addr
		ifNil: [NmpCannotConnect signal: 'Could not resolve the server named:', ipAddress. ^false].
	socket connectTo: addr port: port.
	(socket
			waitForConnectionUntil: (Socket deadlineSecs: timeoutSeconds))
		ifFalse: [^ false].
	^ true! !


!NmpGenericConnector methodsFor: 'testing' stamp: 'MU 11/29/2002 14:38'!
isConnected
	^isConnected! !


!NmpGenericConnector methodsFor: 'accessing' stamp: 'mu 12/4/2002 18:18'!
ipAddress
	^ipAddress! !

!NmpGenericConnector methodsFor: 'accessing' stamp: 'mu 12/4/2002 18:17'!
port
	^port! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmpGenericConnector class
	instanceVariableNames: 'port timeoutSeconds resolveTimeoutSeconds '!

!NmpGenericConnector class methodsFor: 'instance creation' stamp: 'MU 2/25/2003 16:26'!
connect: ipAddressOrHost
	^self connect: ipAddressOrHost port: self port! !

!NmpGenericConnector class methodsFor: 'instance creation' stamp: 'MU 2/25/2003 16:27'!
connect: ipAddressOrHost port: portNumber
	^self connect: ipAddressOrHost port: portNumber timeout: self timeoutSeconds! !

!NmpGenericConnector class methodsFor: 'instance creation' stamp: 'mu 12/11/2002 10:57'!
connect: ipAddressOrHost port: portNumber timeout: timeoutSeconds
	^self new connect: ipAddressOrHost port: portNumber timeout: timeoutSeconds! !


!NmpGenericConnector class methodsFor: 'constants' stamp: 'MU 12/3/2002 11:39'!
defaultPort
	^44444! !

!NmpGenericConnector class methodsFor: 'constants' stamp: 'MU 2/25/2003 16:24'!
defaultResolveTimeoutSeconds
	^5! !

!NmpGenericConnector class methodsFor: 'constants' stamp: 'mu 12/11/2002 10:55'!
defaultTimeoutSeconds
	^5! !


!NmpGenericConnector class methodsFor: 'accessing' stamp: 'MU 2/25/2003 16:26'!
port
	port ifNil: [port _ self defaultPort].
	^port! !

!NmpGenericConnector class methodsFor: 'accessing' stamp: 'MU 2/25/2003 16:25'!
port: aValue

	port := aValue! !

!NmpGenericConnector class methodsFor: 'accessing' stamp: 'MU 2/25/2003 16:27'!
resolveTimeoutSeconds
	resolveTimeoutSeconds ifNil: [resolveTimeoutSeconds _ self defaultResolveTimeoutSeconds].
	^resolveTimeoutSeconds! !

!NmpGenericConnector class methodsFor: 'accessing' stamp: 'MU 2/25/2003 16:25'!
resolveTimeoutSeconds: aValue

	resolveTimeoutSeconds := aValue! !

!NmpGenericConnector class methodsFor: 'accessing' stamp: 'MU 2/25/2003 16:27'!
timeoutSeconds
	timeoutSeconds ifNil: [timeoutSeconds _ self defaultTimeoutSeconds].
	^timeoutSeconds! !

!NmpGenericConnector class methodsFor: 'accessing' stamp: 'MU 2/25/2003 16:25'!
timeoutSeconds: aValue

	timeoutSeconds := aValue! !


!NmpGenericConnector class methodsFor: 'class initialization' stamp: 'MU 2/25/2003 16:29'!
initialize
	"NmpGenericConnector initialize"
	port _ timeoutSeconds _ resolveTimeoutSeconds _ nil! !


NmpObject subclass: #NmpGenericReceptor
	instanceVariableNames: 'isWaiting '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Network-Protocol'!

!NmpGenericReceptor methodsFor: 'initialize' stamp: 'mu 12/4/2002 17:38'!
receiveDataOn: aSocket 
	isWaiting _ true.
	socket _ aSocket.
	process _ [[self isReadyForRequest]
				whileTrue: [[self loopReceiveOneMessage]
						on: Error
						do: [:ex | 
							self returnError: ex.
							self class log: ex]].
			socket closeAndDestroy] newProcess.
	process priority: Processor highIOPriority.
	process resume! !


!NmpGenericReceptor methodsFor: 'actions' stamp: 'MU 11/28/2002 18:53'!
stop
	isWaiting _ false.
	NmpObject crShow: '- receptor stop'! !


!NmpGenericReceptor methodsFor: 'private' stamp: 'mu 12/5/2002 17:47'!
loopReceiveOneMessage
	[self receiveOneMessage]
		on: NmpGenericError
		do: [:ex | 
			ex class name == #NmpTimeout
				ifTrue: [NmpObject crShow: 'timeout ' , ex printString.
					(Delay forMilliseconds: 10) wait].
			ex class name == #NmpInvalidSocketConnection
				ifTrue: [isWaiting _ false.
					NmpObject crShow: 'terminate ' , ex printString]]! !


!NmpGenericReceptor methodsFor: 'testing' stamp: 'MU 11/28/2002 18:50'!
isReadyForRequest
	^isWaiting and: [socket isConnected]! !


NmpGenericError subclass: #NmpSocketPrimitiveFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Network-Protocol'!


NmpGenericError subclass: #NmpTimeout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Network-Protocol'!

NmpGenericServer initialize!
NmpObject initialize!
NmpGenericConnector initialize!