Object subclass: #NmResolver
	instanceVariableNames: 'pointToIpPortDictionary '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Resolver'!

!NmResolver methodsFor: 'initialize-release' stamp: 'mu 3/19/2003 02:12'!
initFromCSVString: csvString 
	
	pointToIpPortDictionary _ NmCSVReadWriter parseCSVString: csvString.
	
	self privateRegisterLocalPointIpAndPort! !

!NmResolver methodsFor: 'initialize-release' stamp: 'mu 3/17/2003 01:12'!
initialize
	pointToIpPortDictionary _ nil.
	self privateRegisterLocalPointIpAndPort! !


!NmResolver methodsFor: 'actions' stamp: 'mu 3/23/2003 12:42'!
ipAndPortArrayAt: aPoint 
	^self ipAndPortArrayAt: aPoint ifAbsent: []! !

!NmResolver methodsFor: 'actions' stamp: 'mu 3/23/2003 15:41'!
ipAndPortArrayAt: aPoint ifAbsent: aBlock
	| ipAndPortStr chopIndex |
	ipAndPortStr _ self ipAndPortAt: aPoint.
	ipAndPortStr isNil
		ifTrue: [^aBlock value].
	chopIndex _ ipAndPortStr indexOf: $:.
	^ Array
		with: (ipAndPortStr copyFrom: 1 to: chopIndex - 1)
		with: (ipAndPortStr copyFrom: chopIndex + 1 to: ipAndPortStr size) asNumber! !

!NmResolver methodsFor: 'actions' stamp: 'mu 3/23/2003 15:07'!
ipAndPortArrays
	^self points collect:[:each | self ipAndPortArrayAt: each]! !

!NmResolver methodsFor: 'actions' stamp: 'mu 3/23/2003 12:42'!
ipAndPortAt: aPoint 
	^self ipAndPortAt: aPoint ifAbsent: []! !

!NmResolver methodsFor: 'actions' stamp: 'mu 3/23/2003 12:26'!
ipAndPortAt: aPoint ifAbsent: aBlock
	^self pointToIpPortDictionary at: aPoint asString ifAbsent: aBlock! !

!NmResolver methodsFor: 'actions' stamp: 'mu 3/16/2003 01:33'!
ipAndPortAt: aPoint put: ipAndPortString
	^self pointToIpPortDictionary at: aPoint asString put: ipAndPortString! !

!NmResolver methodsFor: 'actions' stamp: 'mu 3/23/2003 15:06'!
points
	^self pointToIpPortDictionary keys! !

!NmResolver methodsFor: 'actions' stamp: 'mu 3/23/2003 12:25'!
resolvePoint: destinationPoint ifAbsent: aBlock 
	^self ipAndPortAt: destinationPoint ifAbsent: aBlock! !


!NmResolver methodsFor: 'accessing' stamp: 'mu 3/16/2003 23:32'!
pointToIpPortDictionary
	pointToIpPortDictionary ifNil:[pointToIpPortDictionary _ Dictionary new].
	^pointToIpPortDictionary! !

!NmResolver methodsFor: 'accessing' stamp: 'mu 3/16/2003 01:16'!
pointToIpPortDictionary: aDictionary
	pointToIpPortDictionary _ aDictionary! !


!NmResolver methodsFor: 'converting' stamp: 'mu 3/16/2003 01:29'!
csvString
	^NmCSVReadWriter csvStringFrom: self pointToIpPortDictionary! !


!NmResolver methodsFor: 'private' stamp: 'mu 3/17/2003 01:20'!
privateRegisterLocalPointIpAndPort
	self ipAndPortAt: NmWorldMap localPoint put: self class localIpAndPortString ! !


!NmResolver methodsFor: 'actions-obsolete' stamp: 'mu 3/23/2003 13:05'!
resolveName: destinationName 
	| point ipAndPort ip |
	point _ NmWorldMap pointOf: destinationName.
	ipAndPort _ self ipAndPortArrayAt: point.
	ip _ ipAndPort isNil
				ifFalse: [ipAndPort first].
	^ ip isNil
		ifTrue: [| ipByteArray | 
			ipByteArray _ NetNameResolver addressForName: destinationName timeout: 30.
			ipByteArray isNil
				ifFalse: [NetNameResolver stringFromAddress: ipByteArray]]
		ifFalse: [ip]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmResolver class
	instanceVariableNames: 'default '!

!NmResolver class methodsFor: 'class initialization' stamp: 'mu 3/16/2003 01:35'!
initialize
	"NmResolver initialize"
	default _ nil! !


!NmResolver class methodsFor: 'instance creation' stamp: 'mu 3/16/2003 01:35'!
new
	self shouldNotImplement! !


!NmResolver class methodsFor: 'accessing' stamp: 'mu 3/16/2003 01:36'!
default
	"NmResolver default"
	default
		ifNil: [default _ self basicNew initialize].
	^ default! !


!NmResolver class methodsFor: 'constants' stamp: 'my 4/9/2003 22:22'!
resolverPrefix
	^NmSettings resolverPrefix! !


!NmResolver class methodsFor: 'storing/loading' stamp: 'mu 3/17/2003 01:07'!
load
	NmSettings useExternalAdminServer
		ifTrue: [| call url resp port newEntriesCSV | 
			url _ NmSettings adminServerUrl asUrl.
			port _ url port.
			call _ (SoapCallEntry
						tcpHost: url authority
						port: (port isNil
								ifTrue: [NmSettings defaultAdminServerPort]
								ifFalse: [port])) newCall.
			call targetObjectURI: url fullPath.
			call methodName: 'getResolverStringNamed:'.
			call
				addParameter: (SoapVariable name: #mapName value: NmWorldMap mapName).
			resp _ call invoke.
			newEntriesCSV _ resp isFault
						ifTrue: [resp raiseException]
						ifFalse: [resp returnValue].
			self default initFromCSVString: newEntriesCSV]
		ifFalse: [| mapString | 
			mapString _ NmWorldInfoReadWriter getCsvStringFromFile: self resolverPrefix , NmWorldMap mapName.
			self default initFromCSVString: mapString].
	NmTranscript crShow: '## NmResolver was loaded: ' , self default pointToIpPortDictionary printString! !

!NmResolver class methodsFor: 'storing/loading' stamp: 'mu 3/17/2003 01:05'!
store
	NmSettings useExternalAdminServer
		ifFalse: [NmWorldInfoReadWriter putCsvString: self default csvString toFile: self resolverPrefix, NmWorldMap mapName.]! !


!NmResolver class methodsFor: 'utilities' stamp: 'mu 3/17/2003 01:19'!
localIpAndPortString
	^NmUtil localAddress, ':', NmSettings warpPort asString! !


!NmResolver class methodsFor: 'updating' stamp: 'mu 3/24/2003 00:03'!
loadAndUpdate
	self load.
	self updateClientIpAndPort.
	! !

!NmResolver class methodsFor: 'updating' stamp: 'mu 3/24/2003 00:06'!
updateClientIpAndPort
	"NmResolver updateClientIpAndPort"
	self default privateRegisterLocalPointIpAndPort.
	NmSettings useExternalAdminServer
		ifTrue: [| call url resp port | 
			url _ NmSettings adminServerUrl asUrl.
			port _ url port.
			call _ (SoapCallEntry
						tcpHost: url authority
						port: (port isNil
								ifTrue: [NmSettings defaultAdminServerPort]
								ifFalse: [port])) newCall.
			call targetObjectURI: url fullPath.
			call methodName: 'updateIpAndPort:at:in:'.
			call
				addParameter: (SoapVariable name: #ipAndPort value: self localIpAndPortString).
			call
				addParameter: (SoapVariable name: #pointString value: NmWorldMap localPoint asString).
			call
				addParameter: (SoapVariable name: #mapName value: NmWorldMap mapName).
			resp _ call invoke.
			resp isFault
				ifTrue: [resp raiseException]]
		ifFalse: [self store].
	NmTranscript crShow: '## NmResolver was updated: ', self default pointToIpPortDictionary printString! !

NmResolver initialize!