Object subclass: #NmInitializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Client'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmInitializer class
	instanceVariableNames: ''!

!NmInitializer class methodsFor: 'class initialization' stamp: 'MU2 1/21/2003 18:04'!
initialize
	"NmInitializer initialize"
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.
	Vocabulary initialize! !

!NmInitializer class methodsFor: 'class initialization' stamp: 'mu 11/20/2002 12:04'!
obsolete
	
	Smalltalk removeFromStartUpList: self.
	Smalltalk removeFromShutDownList: self.! !


!NmInitializer class methodsFor: 'startup actions' stamp: 'mu 4/11/2003 15:22'!
removeObsoletePlayerClasses
	"NmInitializer removeObsoletePlayerClasses"
	| obsoleteClasses |
	Smalltalk obsoleteClasses
		do: [:obsoleteClass | 
			| obsoleteClassName | 
			obsoleteClassName _ obsoleteClass name.
			('*Player*' match: obsoleteClassName)
				ifTrue: [obsoleteClass removeFromSystemUnlogged.
					NmTranscript crShow: '>> An obsolete player class: ' , obsoleteClassName , ' is removed.']].
	obsoleteClasses _ Smalltalk obsoleteClasses.
	obsoleteClasses size > 0
		ifTrue: [NmTranscript crShow: '>> Obsolete classes that still exist: '.
			obsoleteClasses
				do: [:obsoleteClass | NmTranscript crShow: '  ', obsoleteClass name]]! !


!NmInitializer class methodsFor: 'system startup' stamp: 'mu 3/24/2003 01:48'!
initializeForNet
	NmUrl initialize.
	NmResolver initialize.
	NmServerManager startWarpServer.
	[NmWorldMap loadAndUpdate.
	NmAutoWorldInfoLoader default start.
	NmAvailabilityChecker default start]
		on: SoapImplError, NmpGenericError
		do: [:ex | 
			self inform: 'NetMorph: network initialize failed!!'.
			ex pass].
	NmRemoteConnector initialize! !

!NmInitializer class methodsFor: 'system startup' stamp: 'ka 1/16/2003 15:41'!
startUp
	"NmInitializer startUp"
	self initializeForNet.
	NmFlapSetup addFlap.
	NmProcessManager initialize.
	Player freeUnreferencedSubclasses.
	self removeObsoletePlayerClasses.
	PaintBoxMorph classPool at: #RecentColors put: nil.
	NmTranscript crShow: self name , ': initialize success'! !


!NmInitializer class methodsFor: 'system shutdown' stamp: 'mu 3/24/2003 01:49'!
shutDown
	NmAvailabilityChecker default stop.
	NmAutoWorldInfoLoader default stop.
	NmRemoteConnector closeAllConnections.
	NmServerManager stopWarpServer.
	NmProcessManager releaseAllLockedProcesses! !


NmAbstractSettings subclass: #NmSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Client'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmSettings class
	instanceVariableNames: ''!

!NmSettings class methodsFor: 'accessing' stamp: 'MU 2/25/2003 16:36'!
connectTimeoutSeconds
	^ self properties at: #connectTimeoutSeconds ifAbsentPutValue: NmpGenericConnector defaultTimeoutSeconds! !

!NmSettings class methodsFor: 'accessing' stamp: 'MU 2/25/2003 16:37'!
connectTimeoutSeconds:  aValue 
	NmpGenericConnector timeoutSeconds: aValue.
	self properties at: #connectTimeoutSeconds put: aValue.
	self changed: #connectTimeoutSeconds.
	^ true! !

!NmSettings class methodsFor: 'accessing' stamp: 'my 4/9/2003 21:52'!
explicitGlobalAddress
	^ self properties at: #explicitGlobalAddress ifAbsentPutValue: nil! !

!NmSettings class methodsFor: 'accessing' stamp: 'my 4/9/2003 21:54'!
explicitGlobalAddress: aValue 
	"NmSettings explicitGlobalAddress: '123.2.4.5'"
	self properties at: #explicitGlobalAddress put: aValue asString.
	self changed: #explicitGlobalAddress.
	^ true! !

!NmSettings class methodsFor: 'accessing' stamp: 'kuri-t 2/24/2003 15:27'!
intervalMinutes
	^ self properties at: #intervalMinutes ifAbsentPutValue: self defaultIntervalMinutes! !

!NmSettings class methodsFor: 'accessing' stamp: 'kuri-t 2/24/2003 16:09'!
intervalMinutes: aValue 
	| aNumber |
	[aNumber _ aValue asNumber asFloat.
	self properties at: #intervalMinutes put: aNumber]
		on: Error
		do: [:ex | ^ false].
	NmAutoWorldInfoLoader default interval: (self properties at: #intervalMinutes)
			* 1000 * 60.
	self changed: #intervalMinutes.
	^ true! !

!NmSettings class methodsFor: 'accessing' stamp: 'ns 1/22/2003 19:25'!
mapName
	| mapName |
	mapName _ self properties
				at: #mapName
				ifAbsent: [].
	(mapName isNil
			or: [mapName isEmpty])
		ifTrue: [mapName _ self properties at: #mapName put: self defaultMapName].
	^ mapName! !

!NmSettings class methodsFor: 'accessing' stamp: 'ns 1/22/2003 19:25'!
mapName: aValue 
	(aValue isNil
			or: [aValue asString isEmpty])
		ifTrue: [^ false].
	self properties at: #mapName put: aValue asString.
	self changed: #mapName.
	^ true! !

!NmSettings class methodsFor: 'accessing' stamp: 'ka 2/17/2003 16:04'!
useAvailabilityChecker
	"self useAvailabilityChecker"
	^ self properties at: #useAvailabilityChecker ifAbsentPutValue: true! !

!NmSettings class methodsFor: 'accessing' stamp: 'ka 2/17/2003 16:23'!
useAvailabilityChecker: boolean 
	boolean == self useAvailabilityChecker
		ifTrue: [^ self].
	self properties at: #useAvailabilityChecker put: boolean == true.
	NmAvailabilityChecker default checkAvailability! !

!NmSettings class methodsFor: 'accessing' stamp: 'mu 3/10/2003 16:47'!
useExternalAdminServer
	^ self properties at: #useExternalAdminServer ifAbsentPutValue: true! !

!NmSettings class methodsFor: 'accessing' stamp: 'mu 3/10/2003 16:48'!
useExternalAdminServer: aBoolean
	^ self properties at: #useExternalAdminServer put: aBoolean! !

!NmSettings class methodsFor: 'accessing' stamp: 'MU 2/25/2003 16:35'!
useKeepMoving
	^self properties at: #useKeepMoving ifAbsentPutValue: false! !

!NmSettings class methodsFor: 'accessing' stamp: 'MU 2/25/2003 16:35'!
useKeepMoving: aValue 
	self properties at: #useKeepMoving put: aValue! !

!NmSettings class methodsFor: 'accessing' stamp: 'ns 1/20/2003 19:21'!
warpPort
	^ self properties at: #warpPort ifAbsentPutValue: self defaultWarpPort! !

!NmSettings class methodsFor: 'accessing' stamp: 'mu 3/12/2003 01:04'!
warpPort: aValue 
	"NmSettings warpPort: 37458"
	| aNumber |
	[aNumber _ aValue asNumber]
		on: Error
		do: [^ false].
	self properties at: #warpPort put: aNumber.
	self changed: #warpPort.
	self initializeForNet.
	^ true! !

!NmSettings class methodsFor: 'accessing' stamp: 'kuri-t 2/13/2003 16:24'!
warpableInterval
	^ 1000! !


!NmSettings class methodsFor: 'constants' stamp: 'ns 1/22/2003 18:33'!
defaultInterval
	^ NmAutoWorldInfoLoader defaultInterval! !

!NmSettings class methodsFor: 'constants' stamp: 'kuri-t 2/24/2003 15:25'!
defaultIntervalMinutes
	^ NmAutoWorldInfoLoader defaultIntervalMinutes! !

!NmSettings class methodsFor: 'constants' stamp: 'MU 10/2/2002 14:48'!
defaultMapName
	^ 'WorldMap.csv' copy.! !

!NmSettings class methodsFor: 'constants' stamp: 'ns 9/25/2002 13:58'!
defaultMapPath
	^ FileDirectory default pathName copy! !

!NmSettings class methodsFor: 'constants' stamp: 'kuri-t 10/16/2002 18:50'!
defaultScreenSize
	^ 800 @ 600! !

!NmSettings class methodsFor: 'constants'!
defaultWarpPort
	^ 37458! !


!NmSettings class methodsFor: 'class initialization' stamp: 'mu 3/12/2003 01:03'!
initializeForNet

	NmUrl initialize.
	NmServerManager startWarpServer.
	! !


!NmSettings class methodsFor: 'storing/loading' stamp: 'ns 1/22/2003 18:47'!
load
	"NmServerSettings load"
	| inst |
	inst _ super load.
	inst warpPort: inst warpPort.
	! !


!NmSettings class methodsFor: 'actions' stamp: 'mu 2/12/2003 16:44'!
toggleMapFromInternet
	self mapFromInternet: (self mapFromInternet not).
	^self mapFromInternet! !

!NmSettings class methodsFor: 'actions' stamp: 'ka 2/17/2003 15:51'!
toggleUseAvailabilityChecker
	self useAvailabilityChecker: self useAvailabilityChecker not.
	^ self useAvailabilityChecker! !


!NmSettings class methodsFor: 'accessing-obsolete' stamp: 'mu 3/10/2003 16:53'!
mapFromInternet
	^ self useExternalAdminServer! !

!NmSettings class methodsFor: 'accessing-obsolete' stamp: 'mu 3/10/2003 16:53'!
mapFromInternet: aValue 
	self useExternalAdminServer: aValue! !


NmAbstractSettingsMorph subclass: #NmSettingsMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Client'!

!NmSettingsMorph methodsFor: 'actions' stamp: 'ns 1/23/2003 11:35'!
inspectMap
	NmWorldMap map inspect.! !

!NmSettingsMorph methodsFor: 'actions' stamp: 'my 4/9/2003 23:25'!
listAllMaps
	| menu |
	menu _ (SelectionMenu selections: NmWorldMap listLoadableMapNames) startUp.
	NmWorldMap mapName: menu
		 ! !

!NmSettingsMorph methodsFor: 'actions' stamp: 'mu 3/24/2003 01:24'!
loadMap

	NmWorldMap loadAndUpdate.! !

!NmSettingsMorph methodsFor: 'actions'!
save
	NmSettings store! !

!NmSettingsMorph methodsFor: 'actions' stamp: 'ns 1/23/2003 11:35'!
storeMap
	NmWorldMap store.! !

!NmSettingsMorph methodsFor: 'actions' stamp: 'ns 1/23/2003 11:36'!
viewMap
	NmWorldMapMorph open! !


!NmSettingsMorph methodsFor: 'factory' stamp: 'kuri-t 2/20/2003 12:06'!
settingClass
	^ self class settingClass! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmSettingsMorph class
	instanceVariableNames: ''!

!NmSettingsMorph class methodsFor: 'private' stamp: 'my 4/9/2003 23:19'!
buildListButtonRowOn: morph 
	| button |
	button _  self
		buildButtonOn: morph
		action: #listAllMaps
		label: 'list'
		help: 'list all Map names'.
	button extent:40@20.
	button hResizing: #rigid.
	^button! !

!NmSettingsMorph class methodsFor: 'private' stamp: 'my 4/9/2003 23:08'!
buildMapButtonRowOn: morph

	| store load inspect viewMap row |
	store _ self buildButtonOn: morph action: #storeMap label: 'Store Map' help: 'store WorldMap' .
	load _ self buildButtonOn: morph action: #loadMap label: 'Load Map' help: 'load WorldMap' .
	inspect _ self buildButtonOn: morph action: #inspectMap label: 'I' help: 'inspect WorldMap' .
	viewMap _ self buildButtonOn: morph action: #viewMap label: 'M' help: 'open WorldMap' .
		
	row _ AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		addAllMorphs: (Array with: store with: load with: inspect with: viewMap);
		extent: 100@35.
	
	^row! !

!NmSettingsMorph class methodsFor: 'private' stamp: 'my 4/9/2003 23:14'!
createWindow
	"NmSettingsMorph createWindow openInHand."
	| inst textField row checkBox mapButtons window |
	window _ self createSystemWindow.
	(inst _ window findA: self)
		ifNil: [^ self error: 'System Window not found.'].
	row _ self buildRowLabeled: 'map from internet '.
	checkBox _ UpdatingThreePhaseButtonMorph checkBox target: self settingClass;
				 actionSelector: #toggleMapFromInternet;
				 getSelector: #mapFromInternet.
	row addMorphBack: checkBox.
	mapButtons _ self buildMapButtonRowOn: inst.
	row addMorphBack: mapButtons.
	inst addMorphBack: row.
	row _ self buildRowLabeled: 'map url:   '.
	textField _ self buildTextField: #adminServerUrl.
	row addMorphBack: textField.
	inst addMorphBack: row.
	row _ self buildRowLabeled: 'map name:'.
	textField _ self buildTextField: #mapName.
	row addMorphBack: textField.
	row addMorphBack: (self buildListButtonRowOn: inst).
	inst addMorphBack: row.
	row _ self buildRowLabeled: 'warp port:'.
	textField _ self buildTextField: #warpPort.
	row addMorphBack: textField.
	inst addMorphBack: row.
	row _ self buildRowLabeled: 'map path: '.
	textField _ self buildTextField: #mapPath.
	row addMorphBack: textField.
	inst addMorphBack: row.
	row _ self buildRowLabeled: 'interval:   '.
	textField _ self buildTextField: #intervalMinutes.
	row addMorphBack: textField.
	row
		addMorphBack: (self buildRowLabeled: ' minutes').
	inst addMorphBack: row.
	row _ self buildRowLabeled: 'use availability checker: '.
	checkBox _ UpdatingThreePhaseButtonMorph checkBox target: self settingClass;
				 actionSelector: #toggleUseAvailabilityChecker;
				 getSelector: #useAvailabilityChecker.
	row addMorphBack: checkBox.
	inst addMorphBack: row.
	row _ self buildResetDefaultButtonRowOn: inst.
	inst addMorphBack: row.
	window extent: self windowExtent.
	^ window! !


!NmSettingsMorph class methodsFor: 'instance creation' stamp: 'ka 2/17/2003 16:09'!
windowExtent
	^ 350 @ 230! !


!NmSettingsMorph class methodsFor: 'factory' stamp: 'ns 1/22/2003 16:40'!
settingClass
	^ NmSettings! !


!NmSettingsMorph class methodsFor: 'defaults' stamp: 'ns 1/22/2003 17:19'!
labelString
	^ 'NetMorph setting'! !


Object subclass: #NmUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Client'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmUtil class
	instanceVariableNames: 'netMorphProxyCache platformSymbol '!

!NmUtil class methodsFor: 'class initialization' stamp: 'mu 11/20/2002 12:04'!
initialize
	"NmUtil initialize"

	Smalltalk addToStartUpList: self.
	self flushNetMorphProxyCache
	! !

!NmUtil class methodsFor: 'class initialization' stamp: 'mu 11/20/2002 12:04'!
obsolete
	"NmUtil obsolete"

	Smalltalk removeFromStartUpList: self.
	! !


!NmUtil class methodsFor: 'system' stamp: 'ns 12/10/2002 10:37'!
displayExtent: extent 
	DisplayScreen
		depth: Display depth
		width: extent x
		height: extent y
		fullscreen: false! !

!NmUtil class methodsFor: 'system' stamp: 'mu 4/15/2003 18:59'!
makeNeighborImage
	"NmUtil makeNeighborImage"
	| oldName |
	World leftFenceEnabled: false; rightFenceEnabled: false.
	NmSettings mapPath: FileDirectory default pathName.
	NmSettings mapFromInternet: false.
	NmWorldMap beTwoNeighbors.
	NmWorldMap store.
	oldName _ FileDirectory localNameFor: (Smalltalk fullNameForImageNamed: Smalltalk imageName).
	oldName _ (oldName copyFrom: 1 to: oldName size - 6).
	[NmWorldMap map
		keysAndValuesDo: [:point :destination | 
			| newName | 
			newName _ oldName , '-', point asString.
			(SourceFiles at: 2)
				ifNotNil: [Smalltalk
						saveChangesInFileNamed: (Smalltalk fullNameForChangesNamed: newName)].
			Smalltalk
				saveImageInFileNamed: (Smalltalk fullNameForImageNamed: newName).
			NmSettings warpPort: destination asUrl port.
			NmWorldMap resetLocal]]
		on: CannotDeleteFileException
		do: [:ex | ex]! !

!NmUtil class methodsFor: 'system' stamp: 'MU 11/20/2002 10:56'!
platformSymbol
	"NmUtil platformSymbol"
	platformSymbol ifNil: [platformSymbol _ Smalltalk platformName asLowercase asSymbol ].
	^platformSymbol! !

!NmUtil class methodsFor: 'system' stamp: 'mu 3/10/2003 17:44'!
setDisplayExtentForWin32
	"NmUtil setDisplayExtentForWin32."
	NmUtil platformSymbol == #win32
		ifTrue: [self displayExtent: NmSettings defaultScreenSize]! !

!NmUtil class methodsFor: 'system' stamp: 'MU 11/19/2002 19:20'!
startUp

	platformSymbol := nil.
! !


!NmUtil class methodsFor: 'adapter for Network' stamp: 'my 4/9/2003 21:58'!
localAddress
	"Squeak specific"
	^ NmSettings explicitGlobalAddress isNil
		ifTrue: [NetNameResolver localAddressString]
		ifFalse: [NmSettings explicitGlobalAddress]! !

!NmUtil class methodsFor: 'adapter for Network' stamp: 'my 4/9/2003 22:06'!
localHostname
	"Squeak specific"
	"NmUtil localHostname"
	| localHostname |
	localHostname _ NetNameResolver nameForAddress: NetNameResolver localHostAddress timeout: 30.
	localHostname isNil ifTrue: [^self localAddress].
	^ localHostname! !

!NmUtil class methodsFor: 'adapter for Network' stamp: 'mu 10/28/2002 16:45'!
unresolvedIPAddressString
	^ '0.0.0.0' copy! !

!NmUtil class methodsFor: 'adapter for Network' stamp: 'mu 4/15/2003 16:43'!
urlFromString: aString 
	| string url |
	(aString isNil or: [aString = '']) ifTrue: [^ nil].
	string _ (aString beginsWith: NmUrl protcolIdentifier , '://')
				ifTrue: [aString]
				ifFalse: [NmUrl protcolIdentifier , '://' , aString].
	[url _ string asUrl]
		on: Error
		do: [:ex | ^ nil].
	^ (url isNmUrl)
		ifTrue: [url]! !


!NmUtil class methodsFor: 'NetMorph proxy cache' stamp: 'ka 9/13/2002 16:35'!
flushNetMorphProxyCache
	"NmUtil flushNetMorphProxyCache"
	netMorphProxyCache _ Dictionary new! !

!NmUtil class methodsFor: 'NetMorph proxy cache' stamp: 'ka 9/13/2002 16:34'!
netMorphProxyCache
	"NmUtil netMorphProxyCache"
	^ netMorphProxyCache! !


!NmUtil class methodsFor: 'gzip support' stamp: 'ka 10/15/2002 17:45'!
gunzippedFrom: aByteArray 
	"NmUtil gunzippedFrom: (NmUtil gzippedFrom: 'hello' asByteArray) asString"
	| gzipStream |
	gzipStream _ GZipReadStream on: aByteArray.
	^ gzipStream contents! !

!NmUtil class methodsFor: 'gzip support' stamp: 'ka 10/15/2002 17:42'!
gzippedFrom: aByteArray 
	"NmUtil gzippedFrom: 'hello' asByteArray"
	| bufferStream gZipStream |
	bufferStream _ RWBinaryOrTextStream
				on: (ByteArray new: 5000).
	bufferStream binary.
	gZipStream _ GZipWriteStream on: bufferStream.
	aByteArray
		do: [:each | gZipStream nextPut: each].
	gZipStream close.
	^ bufferStream contents! !

NmInitializer initialize!
NmUtil initialize!