Object subclass: #NmWorldMap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-WorldMap'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmWorldMap class
	instanceVariableNames: 'map mapPath localPoint localName '!

!NmWorldMap class methodsFor: 'accessing' stamp: 'mu 4/15/2003 16:36'!
at: aPoint
	^map at: aPoint

! !

!NmWorldMap class methodsFor: 'accessing' stamp: 'mu 4/15/2003 16:37'!
at: aPoint ifAbsent: aBlock
	^map at: aPoint ifAbsent: aBlock

! !

!NmWorldMap class methodsFor: 'accessing' stamp: 'mu 4/16/2003 02:26'!
at: aPoint put: destinationString
	^self at: aPoint put: destinationString asString on: map
! !

!NmWorldMap class methodsFor: 'accessing'!
map
	^ map! !

!NmWorldMap class methodsFor: 'accessing' stamp: 'mu 4/15/2003 16:49'!
map: aDictionary
	| dict |
	dict _ Dictionary new.
	aDictionary keysAndValuesDo:[:k :v | self at: k put: v asString on: dict].
	map _ dict

! !


!NmWorldMap class methodsFor: 'class initialization' stamp: 'mu 4/16/2003 02:08'!
initialize
	"NmWorldMap initialize"
	map _ Dictionary new.
	localPoint _ 0@0.
	localName _ nil
	
	
	! !


!NmWorldMap class methodsFor: 'storing/loading' stamp: 'mu 4/12/2003 19:40'!
listLoadableMapNames
	"NmWorldMap listLoadableMapNames"
	NmSettings useExternalAdminServer
		ifTrue: [| call url resp port | 
			url _ NmSettings adminServerUrl asUrl.
			port _ url port.
			call _ (SoapCallEntry
						tcpHost: url authority
						port: (port isNil
								ifTrue: [NmSettings defaultAdminServerPort]
								ifFalse: [port])) newCall.
			call targetObjectURI: url fullPath.
			call methodName: 'listAllMapNames'.
			resp _ call invoke.
			^ resp isFault
				ifTrue: [resp raiseException.
					nil]
				ifFalse: [resp returnValue]]
		ifFalse: [^ NmWorldInfoReadWriter listMapCsvFileNamesFromDirectory]! !

!NmWorldMap class methodsFor: 'storing/loading' stamp: 'mu 3/19/2003 01:49'!
load
	"NmWorldMap load"
	| mapString |
	NmSettings useExternalAdminServer
		ifTrue: [| call url resp port | 
			url _ NmSettings adminServerUrl asUrl.
			port _ url port.
			call _ (SoapCallEntry
						tcpHost: url authority
						port: (port isNil
								ifTrue: [NmSettings defaultAdminServerPort]
								ifFalse: [port])) newCall.
			call targetObjectURI: url fullPath.
			call methodName: 'getMapStringNamed:'.
			call
				addParameter: (SoapVariable name: #mapName value: NmSettings mapName).
			resp _ call invoke.
			mapString _ resp isFault
						ifTrue: [resp raiseException.
							nil]
						ifFalse: [resp returnValue].
			self fromCSVString: mapString]
		ifFalse: [mapString _ NmWorldInfoReadWriter getCsvStringFromFile: NmSettings mapName.
			self fromCSVString: mapString].
	NmTranscript crShow: '## NmWorldMap was loaded: ' , self map printString.
	self resetLocal! !

!NmWorldMap class methodsFor: 'storing/loading' stamp: 'mu 4/11/2003 14:56'!
loadAndUpdate
	[self load.
	NmResolver loadAndUpdate]
		on: SoapImplError , SoapImplError
		do: [:ex | 
			self inform: 'Server does not respond!!'.
			NmTranscript crShow: ex description]! !

!NmWorldMap class methodsFor: 'storing/loading' stamp: 'mu 3/17/2003 01:00'!
store
	"NmWorldMap store"
	NmSettings useExternalAdminServer
		ifTrue: [| call url resp port | 
			url _ NmSettings adminServerUrl asUrl.
			port _ url port.
			call _ (SoapCallEntry
						tcpHost: url authority
						port: (port isNil
								ifTrue: [NmSettings defaultAdminServerPort]
								ifFalse: [port])) newCall.
			call targetObjectURI: url fullPath.
			call methodName: 'putMapString:named:'.
			call
				addParameter: (SoapVariable name: #mapCSVString value: self csvString).
			call
				addParameter: (SoapVariable name: #mapName value: NmSettings mapName).
			resp _ call invoke.
			resp isFault
				ifTrue: [resp raiseException]
				ifFalse: [resp returnValue]]
		ifFalse: [NmWorldInfoReadWriter  putCsvString: self csvString toFile: NmSettings mapName].
	self resetLocal! !


!NmWorldMap class methodsFor: 'obsolete' stamp: 'mu 4/16/2003 02:32'!
bottomOf: address 
	"NmWorldMap bottomOf: 'nm://smalltalk:37458/' asUrl"
	| point destinationPoint destination |
	point _ self pointOf: address.
	point isNil
		ifTrue: [^ nil].
	destinationPoint _ Point x: point x y: point y - 1.
	destination _  map
		at: destinationPoint
		ifAbsent: [^nil].
	^destination asUrl isNmUrl ifTrue: [destination asUrl] ifFalse: [destination] ! !

!NmWorldMap class methodsFor: 'obsolete' stamp: 'mu2 11/25/2002 17:47'!
deltaPointFrom: fromUrl to: toUrl 
	"NmWorldMap deltaPointFrom: 'nm://lisp:37458' asUrl to: 
	'nm://lisp:37459' asUrl  800@0"
	| fromPoint toPoint |
	fromPoint _ self pointOf: fromUrl.
	toPoint _ self pointOf: toUrl.
	^ toPoint - fromPoint * (ActiveWorld extent) * (1 @ -1)! !

!NmWorldMap class methodsFor: 'obsolete' stamp: 'mu 4/16/2003 02:32'!
leftOf: address 
	"NmWorldMap leftOf: 'nm://smalltalk:37458/' asUrl"
	| point destinationPoint destination |
	point _ self pointOf: address.
	point isNil
		ifTrue: [^ nil].
	destinationPoint _ Point x: point x - 1 y: point y.
	destination _  map
		at: destinationPoint
		ifAbsent: [^nil].
	^destination asUrl isNmUrl ifTrue: [destination asUrl] ifFalse: [destination] ! !

!NmWorldMap class methodsFor: 'obsolete' stamp: 'mu 4/16/2003 02:32'!
rightOf: address 
	"NmWorldMap rightOf: 'nm://smalltalk:37458/' asUrl"
	| point destinationPoint destination |
	point _ self pointOf: address.
	point isNil
		ifTrue: [^ nil].
	destinationPoint _ Point x: point x + 1 y: point y.
	destination _  map
		at: destinationPoint
		ifAbsent: [^nil].
	^destination asUrl isNmUrl ifTrue: [destination asUrl] ifFalse: [destination] ! !

!NmWorldMap class methodsFor: 'obsolete' stamp: 'mu 4/16/2003 02:32'!
topOf: address 
	"NmWorldMap topOf: 'nm://smalltalk:37458/' asUrl"
	| point destinationPoint destination |
	point _ self pointOf: address.
	point isNil
		ifTrue: [^ nil].
	destinationPoint _ Point x: point x y: point y + 1.
	destination _  map
		at: destinationPoint
		ifAbsent: [^nil].
	^destination asUrl isNmUrl ifTrue: [destination asUrl] ifFalse: [destination] ! !


!NmWorldMap class methodsFor: 'accessing point' stamp: 'mu 4/16/2003 02:30'!
deltaPointTo: destinationPoint
	| fromPoint toPoint |
	fromPoint _ self localPoint.
	toPoint _ destinationPoint.
	^ toPoint - fromPoint * (ActiveWorld extent) * (1 @ -1)! !

!NmWorldMap class methodsFor: 'accessing point' stamp: 'mu 4/16/2003 02:29'!
pointOf: destination 
	"NmWorldMap pointOf: 'nm://Smalltalk:37458/' asUrl"
	"NmWorldMap pointOf: 'nm://qwerty:37458/'"
	| destinationName |
	destinationName _ self normalizedDestinationStringFrom: destination asString. 
	
	^map
		keyAtValue: destinationName
		ifAbsent: [^ nil]! !


!NmWorldMap class methodsFor: 'converting' stamp: 'mu 3/17/2003 00:12'!
csvString
	"NmWorldMap csvString"
	^ NmWorldInfoReadWriter csvStringFrom: map! !

!NmWorldMap class methodsFor: 'converting' stamp: 'mu 4/12/2003 21:19'!
fromCSVString: aString 
	| rawDict mapDict |
	rawDict _ NmWorldInfoReadWriter parseCSVString: aString.
	mapDict _ Dictionary new.
	rawDict
		keysAndValuesDo: [:point :destinationWorldName | mapDict
				at: (Point readFrom: point)
				put: destinationWorldName].
	self map: mapDict! !


!NmWorldMap class methodsFor: 'prototype' stamp: 'mu 1/17/2003 14:51'!
beTwoNeighbors
	"NmWorldMap beTwoNeighbors"
	| newMap |
	newMap _ Dictionary new.
	newMap at: 0@0 put: NmUrl local.
	newMap at: 1@0 put: (NmUrl local copy port: NmUrl local port + 1).
	self map: newMap.
	^self! !


!NmWorldMap class methodsFor: 'private' stamp: 'mu 4/15/2003 16:58'!
at: aPoint put: destinationString on: dictionary 
	| destName |
	destName _ self normalizedDestinationStringFrom: destinationString.
	destName
		ifNotNil: [^ dictionary at: aPoint put: destName]! !

!NmWorldMap class methodsFor: 'private' stamp: 'mu 4/15/2003 16:58'!
normalizedDestinationStringFrom: destString 
	| url |
	destString isString not ifTrue: [self error: 'WorldMap key should be String'. ^nil].
	url _ destString asUrl.
	^ url isNmUrl
		ifTrue: [url asString]
		ifFalse: [destString]! !


!NmWorldMap class methodsFor: 'accessing name' stamp: 'mu 3/23/2003 15:46'!
allWorldNames
	^map values
	! !

!NmWorldMap class methodsFor: 'accessing name' stamp: 'mu 3/13/2003 19:17'!
mapName
	^NmSettings mapName! !

!NmWorldMap class methodsFor: 'accessing name' stamp: 'mu 3/13/2003 19:18'!
mapName: aString
	^NmSettings mapName: aString! !


!NmWorldMap class methodsFor: 'accessing destination' stamp: 'mu 3/23/2003 15:07'!
allDestinations
	"NmWorldMap allDestinations"
	^NmResolver default ipAndPortArrays
		! !

!NmWorldMap class methodsFor: 'accessing destination' stamp: 'mu 3/23/2003 16:19'!
bottomDestination
	"NmWorldMap bottomDestination"
	^NmResolver default ipAndPortArrayAt:  localPoint + (0@-1)
		! !

!NmWorldMap class methodsFor: 'accessing destination' stamp: 'mu 3/23/2003 16:19'!
leftDestination
	"NmWorldMap leftDestination"
	^NmResolver default ipAndPortArrayAt:  localPoint + (-1@0)
		! !

!NmWorldMap class methodsFor: 'accessing destination' stamp: 'mu 3/23/2003 15:22'!
neighborDestinations
	^(localPoint fourNeighbors collect: [:each | NmResolver default ipAndPortArrayAt: each]) reject: [:each | each isNil]! !

!NmWorldMap class methodsFor: 'accessing destination' stamp: 'mu 3/23/2003 16:19'!
rightDestination
	"NmWorldMap rightDestination"
	^NmResolver default ipAndPortArrayAt:  localPoint + (1@0)
		! !

!NmWorldMap class methodsFor: 'accessing destination' stamp: 'mu 3/23/2003 15:35'!
survivorsDo: aBlock 
	| allDestinations availableDestinations otherDestinations |
	allDestinations _ self allDestinations.
	availableDestinations _ NmAvailabilityChecker default availableDestinations.
	(self neighborDestinations intersection: availableDestinations)
		do: [:each | aBlock value: each].
	otherDestinations _ allDestinations removeAll: self neighborDestinations.
	(otherDestinations intersection: availableDestinations)
		do: [:each | aBlock value: each]! !

!NmWorldMap class methodsFor: 'accessing destination' stamp: 'mu 3/23/2003 16:19'!
topDestination
	"NmWorldMap topDestination"
	^NmResolver default ipAndPortArrayAt:  localPoint + (0@1)
		! !


!NmWorldMap class methodsFor: 'local info' stamp: 'mu 4/14/2003 20:08'!
localName
	localName isNil ifTrue: [^NmUrl local asString].
	^localName! !

!NmWorldMap class methodsFor: 'local info' stamp: 'mu 4/15/2003 16:59'!
localName: aString
	localName _ self normalizedDestinationStringFrom: aString! !

!NmWorldMap class methodsFor: 'local info' stamp: 'mu 4/14/2003 20:06'!
localPoint
	^localPoint! !

!NmWorldMap class methodsFor: 'local info' stamp: 'mu 4/14/2003 20:06'!
localPoint: aPoint
	localPoint _ aPoint! !

!NmWorldMap class methodsFor: 'local info' stamp: 'mu 4/15/2003 16:14'!
resetLocal
	self map
		keysAndValuesDo: [:point :destination | destination = self localName 
				ifTrue: [
					localPoint _ point.
					^ self]].
	"no match"
	localPoint _ 0@0! !

NmWorldMap initialize!